cordova.define("cordova-plugin-gwl-mixpush.GwlMixPushPlugin", function(require, exports, module) {
var cordova = require('cordova');

//混合推送，目前支持小米，后续会有华为等推送，怎么加后无需任何代码改动就可兼容多种推送
var GwlMixPushPlugin = function() {}

/*设置推送的引擎 xiaoMi||huaWei
  示例：window.plugins.MixPushPlugin.setPushEngine(["xiaoMi"],successCallback,errorCallback);
 */
GwlMixPushPlugin.prototype.setPushEngine = function(args, successCallback, errorCallback) {
    console.log("GwlMixPushPlugin.prototype.setPushEngine");
    cordova.exec(successCallback, errorCallback, 'GwlMixPushPlugin', "setPushEngine", args);
}

/*启动注册推送
示例：let miId = '288230*****896';
      let miKey = '5901***96';
      window.plugins.MixPushPlugin.registerPush([miId, miKey],successCallback,errorCallback); 
 */
GwlMixPushPlugin.prototype.registerPush = function(args, successCallback, errorCallback) {
    console.log("GwlMixPushPlugin.prototype.registerPush");
    cordova.exec(successCallback, errorCallback, 'GwlMixPushPlugin', "registerPush", args);
}

/*退出推送
  示例：window.plugins.MixPushPlugin.exitPush([],successCallback,errorCallback);		
*/
GwlMixPushPlugin.prototype.exitPush = function(args, successCallback, errorCallback) {
    cordova.exec(successCallback, errorCallback, 'GwlMixPushPlugin', "exitPush", args);
}

/*为指定用户设置userAccount
  示例：window.plugins.MixPushPlugin.setAccount(["dmc"],successCallback,errorCallback);		
*/
GwlMixPushPlugin.prototype.setAccount = function(args, successCallback, errorCallback) {
    cordova.exec(successCallback, errorCallback, 'GwlMixPushPlugin', "setAccount", args);
}

/*取消指定用户的userAccount。
  示例：window.plugins.MixPushPlugin.unsetAccount(["dmc"],successCallback,errorCallback);		
*/
GwlMixPushPlugin.prototype.unsetAccount = function(args, successCallback, errorCallback) {
    cordova.exec(successCallback, errorCallback, 'GwlMixPushPlugin', "unsetAccount", args);
}

/*获取客户端的RegId。
  示例：window.plugins.MixPushPlugin.getRegId([],(id)=>{alert(id);}),errorCallback);		
*/
GwlMixPushPlugin.prototype.getRegId = function(args, successCallback, errorCallback) {
    cordova.exec(successCallback, errorCallback, 'GwlMixPushPlugin', "getRegId", args);
}

/*为指定用户设置alias
  示例：window.plugins.MixPushPlugin.setAlias(["123"],successCallback,errorCallback);		
*/
GwlMixPushPlugin.prototype.setAlias = function(args, successCallback, errorCallback) {
    cordova.exec(successCallback, errorCallback, 'GwlMixPushPlugin', "setAlias", args);
}

/*取消指定用户的alias
  示例：window.plugins.MixPushPlugin.unsetAlias(["123"],successCallback,errorCallback);		
*/
GwlMixPushPlugin.prototype.unsetAlias = function(args, successCallback, errorCallback) {
    cordova.exec(successCallback, errorCallback, 'GwlMixPushPlugin', "unsetAlias", args);
}

/*为某个用户设置订阅topic
  示例：window.plugins.MixPushPlugin.subscribe(["112"],successCallback,errorCallback);		
*/
GwlMixPushPlugin.prototype.subscribe = function(args, successCallback, errorCallback) {
    cordova.exec(successCallback, errorCallback, 'GwlMixPushPlugin', "subscribe", args);
}

/*取消某个用户的订阅topic
  示例：window.plugins.MixPushPlugin.unsubscribe(["112"],successCallback,errorCallback);		
*/
GwlMixPushPlugin.prototype.unsubscribe = function(args, successCallback, errorCallback) {
    cordova.exec(successCallback, errorCallback, 'GwlMixPushPlugin', "unsubscribe", args);
}

/*暂停接收MiPush服务推送的消息
  示例：window.plugins.MixPushPlugin.pausePush([],successCallback,errorCallback);		
*/
GwlMixPushPlugin.prototype.pausePush = function(args, successCallback, errorCallback) {
    cordova.exec(successCallback, errorCallback, 'GwlMixPushPlugin', "pausePush", args);
}

/*恢复接收MiPush服务推送的消息，这时服务器会把暂停时期的推送消息重新推送过来
  示例：window.plugins.MixPushPlugin.resumePush([],successCallback,errorCallback);		
*/
GwlMixPushPlugin.prototype.resumePush = function(args, successCallback, errorCallback) {
    cordova.exec(successCallback, errorCallback, 'GwlMixPushPlugin', "resumePush", args);
}

/*关闭MiPush推送服务，不再维护长连接，服务不可用
  示例：window.plugins.MixPushPlugin.disablePush([],successCallback,errorCallback);		
*/
GwlMixPushPlugin.prototype.disablePush = function(args, successCallback, errorCallback) {
    cordova.exec(successCallback, errorCallback, 'GwlMixPushPlugin', "disablePush", args);
}

/*打开 MiPush 推送服务，继续维护长连接
  示例：window.plugins.MixPushPlugin.enablePush([],successCallback,errorCallback);		
*/
GwlMixPushPlugin.prototype.enablePush = function(args, successCallback, errorCallback) {
    cordova.exec(successCallback, errorCallback, 'GwlMixPushPlugin', "enablePush", args);
}

/*清除小米推送弹出的通知
  示例：window.plugins.MixPushPlugin.clearNotification([],successCallback,errorCallback);		
*/
GwlMixPushPlugin.prototype.clearNotification = function(args, successCallback, errorCallback) {
    cordova.exec(successCallback, errorCallback, 'GwlMixPushPlugin', "clearNotification", args);
}


GwlMixPushPlugin.prototype.clearNotificationById = function(args, successCallback, errorCallback) {
    cordova.exec(successCallback, errorCallback, 'GwlMixPushPlugin', "clearNotificationById", args);
}

//事件======================================================================================//

/*启动注册推送成功失败事件监听
  示例： document.addEventListener("MixPushPlugin.onRegisterPush", (data) => {
            if (data&&data.code == 200 ) {
                console.log('注册成功：' + data.regId);             
            }
        }, false); 	
*/
GwlMixPushPlugin.prototype.onRegisterPush = function(data) {
    console.log('GwlMixPushPlugin:onRegisterPush: ');
    console.log(data);
    data = JSON.parse(JSON.stringify(data));
    cordova.fireDocumentEvent('GwlMixPushPlugin.onRegisterPush', data);
}

/*来推送时的监听事件
  示例：document.addEventListener("MixPushPlugin.onNotificationArrived", (data) => {
            if (data && data.title) {
                console.log('来消息了：' + data.title);
            }
        }, false);	
*/
GwlMixPushPlugin.prototype.onNotificationArrived = function(data) {
    data = JSON.parse(JSON.stringify(data));
    console.log('GwlMixPushPlugin:onNotificationArrived: ' + data);
    cordova.fireDocumentEvent('GwlMixPushPlugin.onNotificationArrived', data);
}

/*用来接收服务器发来的通知栏消息（用户点击通知栏时触发）监听事件
  示例：document.addEventListener("MixPushPlugin.onNotificationClicked", (data) => {
            if (data && data.title) {
                console.log('点消息了：' + data.title);
            }
        }, false);	
*/
GwlMixPushPlugin.prototype.onNotificationClicked = function(data) {
    data = JSON.parse(JSON.stringify(data));
    console.log('GwlMixPushPlugin:onNotificationClicked: ' + data);
    cordova.fireDocumentEvent('GwlMixPushPlugin.onNotificationClicked', data);
}

/*设置Alias监听事件
  示例：document.addEventListener("MixPushPlugin.onSetAliasPush", (data) => {
            if (data.code == 200) {
                console.log("成功");
            }
        }, false);	
*/
GwlMixPushPlugin.prototype.onSetAliasPush = function(data) {
    data = JSON.parse(JSON.stringify(data));
    console.log('GwlMixPushPlugin:onSetAliasPush: ' + data);
    cordova.fireDocumentEvent('GwlMixPushPlugin.onSetAliasPush', data);
}

/*取消Alias监听事件
  示例：document.addEventListener("MixPushPlugin.onUnSetAliasPush", (data) => {
            if (data.code == 200) {
                console.log("成功");
            }
        }, false);	
*/
GwlMixPushPlugin.prototype.onUnSetAliasPush = function(data) {
    data = JSON.parse(JSON.stringify(data));
    console.log('GwlMixPushPlugin:onUnSetAliasPush: ' + data);
    cordova.fireDocumentEvent('GwlMixPushPlugin.onUnSetAliasPush', data);
}

/*SetAccount监听事件
  示例：用法于上面类似	
*/
GwlMixPushPlugin.prototype.onSetAccountPush = function(data) {
    data = JSON.parse(JSON.stringify(data));
    console.log('GwlMixPushPlugin:onSetAccountPush: ' + data);
    cordova.fireDocumentEvent('GwlMixPushPlugin.onSetAccountPush', data);
}

/*UnSetAccount监听事件
  示例：用法于上面类似	
*/
GwlMixPushPlugin.prototype.onUnSetAccountPush = function(data) {
    data = JSON.parse(JSON.stringify(data));
    console.log('GwlMixPushPlugin:onUnSetAccountPush: ' + data);
    cordova.fireDocumentEvent('GwlMixPushPlugin.onUnSetAccountPush', data);
}

/*Subscribe监听事件
  示例：用法于上面类似	
*/
GwlMixPushPlugin.prototype.onSubscribePush = function(data) {
    data = JSON.parse(JSON.stringify(data));
    console.log('GwlMixPushPlugin:onSubscribePush: ' + data);
    cordova.fireDocumentEvent('GwlMixPushPlugin.onSubscribePush', data);
}

/*UnSubscribe监听事件
  示例：用法于上面类似	
*/
GwlMixPushPlugin.prototype.onUnSubscribePush = function(data) {
    data = JSON.parse(JSON.stringify(data));
    console.log('GwlMixPushPlugin:onUnSubscribePush: ' + data);
    cordova.fireDocumentEvent('GwlMixPushPlugin.onUnSubscribePush', data);
}



/*设置APP角标数字
  示例：设置数字20当设置0的时候就等同于badgerRemoveCount，window.plugins.MixPushPlugin.badgerApplyCount([20],successCallback,errorCallback);
 */
GwlMixPushPlugin.prototype.badgerApplyCount = function(args, successCallback, errorCallback) {
    cordova.exec(successCallback, errorCallback, 'GwlMixPushPlugin', "badgerApplyCount", args);
}

//清空APP角标数字
//示例：window.plugins.MixPushPlugin.badgerRemoveCount([],successCallback,errorCallback);
GwlMixPushPlugin.prototype.badgerRemoveCount = function(args, successCallback, errorCallback) {
    cordova.exec(successCallback, errorCallback, 'GwlMixPushPlugin', "badgerRemoveCount", args);
}


GwlMixPushPlugin.prototype.addBadgerToSp = function(args, successCallback, errorCallback) {
    cordova.exec(successCallback, errorCallback, 'GwlMixPushPlugin', "addBadgerToSp", args);
}


GwlMixPushPlugin.prototype.minusBadgerToSp = function(args, successCallback, errorCallback) {
    cordova.exec(successCallback, errorCallback, 'GwlMixPushPlugin', "minusBadgerToSp", args);
}

if (!window.plugins) {
    window.plugins = {}
}

if (!window.plugins.GwlMixPushPlugin) {
    window.plugins.GwlMixPushPlugin = new GwlMixPushPlugin()
}


module.exports = new GwlMixPushPlugin();
});
