webpackJsonp([129],{

/***/ 123:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return APPUtils; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__ionic_native_network__ = __webpack_require__(603);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__ionic_native_app_version__ = __webpack_require__(604);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_ionic_angular__ = __webpack_require__(22);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__ionic_native_file__ = __webpack_require__(148);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__ionic_native_file_transfer__ = __webpack_require__(605);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};






var APPUtils = /** @class */ (function () {
    function APPUtils(platform, network, alertCtrl, file, transfer, appVersion) {
        this.platform = platform;
        this.network = network;
        this.alertCtrl = alertCtrl;
        this.file = file;
        this.transfer = transfer;
        this.appVersion = appVersion;
    }
    APPUtils.prototype.warn = function (info) {
        console.log('%cNativeService/' + info, 'color:#e8c406');
    };
    /**
    * 是否真机环境
    * @return {boolean}
    */
    APPUtils.prototype.isMobile = function () {
        return this.platform.is('mobile') && !this.platform.is('mobileweb');
    };
    /**
     * 是否android真机环境
     * @return {boolean}
     */
    APPUtils.prototype.isAndroid = function () {
        return this.isMobile() && this.platform.is('android');
    };
    /**
     * 是否ios真机环境
     * @return {boolean}
     */
    APPUtils.prototype.isIos = function () {
        return this.isMobile() && (this.platform.is('ios') || this.platform.is('ipad') || this.platform.is('iphone'));
    };
    /**
     * 获取网络类型 如`unknown`, `ethernet`, `wifi`, `2g`, `3g`, `4g`, `cellular`, `none`
     */
    APPUtils.prototype.getNetworkType = function () {
        if (!this.isMobile()) {
            return 'wifi';
        }
        return this.network.type;
    };
    /**
     * 判断是否有网络
     * @returns {boolean}
     */
    APPUtils.prototype.isConnecting = function () {
        return this.getNetworkType() != 'none';
    };
    /**
     * 获得app版本号,如0.01
     * @description  对应/config.xml中version的值
     * @returns {Promise<string>}
     */
    APPUtils.prototype.getVersionNumber = function () {
        var _this = this;
        return new Promise(function (resolve) {
            _this.appVersion.getVersionNumber().then(function (value) {
                resolve(value);
            }).catch(function (err) {
                _this.warn('getVersionNumber:' + err);
            });
        });
    };
    /**
     * 获得app name,如ionic2_tabs
     * @description  对应/config.xml中name的值
     * @returns {Promise<string>}
     */
    APPUtils.prototype.getAppName = function () {
        var _this = this;
        return new Promise(function (resolve) {
            _this.appVersion.getAppName().then(function (value) {
                resolve(value);
            }).catch(function (err) {
                _this.warn('getAppName:' + err);
            });
        });
    };
    /**
     * 获得app包名/id,如com.kit.ionic2tabs
     * @description  对应/config.xml中id的值
     * @returns {Promise<string>}
     */
    APPUtils.prototype.getPackageName = function () {
        var _this = this;
        return new Promise(function (resolve) {
            _this.appVersion.getPackageName().then(function (value) {
                resolve(value);
            }).catch(function (err) {
                _this.warn('getPackageName:' + err);
            });
        });
    };
    /**
     * 下载安装app
     */
    APPUtils.prototype.downloadApp = function (download_url) {
        var alert = this.alertCtrl.create({
            title: '下载进度：0%',
            enableBackdropDismiss: false,
            buttons: ['后台下载']
        });
        alert.present();
        var fileTransfer = this.transfer.create();
        var apk = this.file.externalRootDirectory + 'gwl_talent.apk'; //apk保存的目录
        fileTransfer.download(download_url, apk).then(function () {
            //window['install'].install(apk.replace('file://', ''));
        });
        fileTransfer.onProgress(function (event) {
            var num = Math.floor(event.loaded / event.total * 100);
            if (num === 100) {
                alert.dismiss();
            }
            else {
                var title = document.getElementsByClassName('alert-title')[0];
                title && (title.innerHTML = '下载进度：' + num + '%');
            }
        });
    };
    /**
     * 比较版本号
     * @param ver1 第一个版本号 来自服务器端
     * @param ver2 第二个版本号 来自本机
     */
    APPUtils.prototype.hasNewVersion = function (ver1, ver2) {
        var arr1 = ver1.split('.');
        var arr2 = ver2.split('.');
        //将两个版本号拆成数字 
        var minL = Math.min(arr1.length, arr2.length);
        var pos = 0; //当前比较位
        var diff = 0; //当前为位比较是否相等
        //逐个比较如果当前位相等则继续比较下一位
        while (pos < minL) {
            diff = parseInt(arr1[pos]) - parseInt(arr2[pos]);
            if (diff != 0) {
                break;
            }
            pos++;
        }
        if (diff > 0) {
            console.log('新版本');
            return true;
        }
        else {
            return false;
        }
    };
    APPUtils = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_3__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2_ionic_angular__["Platform"],
            __WEBPACK_IMPORTED_MODULE_0__ionic_native_network__["a" /* Network */],
            __WEBPACK_IMPORTED_MODULE_2_ionic_angular__["AlertController"],
            __WEBPACK_IMPORTED_MODULE_4__ionic_native_file__["a" /* File */],
            __WEBPACK_IMPORTED_MODULE_5__ionic_native_file_transfer__["a" /* FileTransfer */],
            __WEBPACK_IMPORTED_MODULE_1__ionic_native_app_version__["a" /* AppVersion */]])
    ], APPUtils);
    return APPUtils;
}());

//# sourceMappingURL=AppUtils.js.map

/***/ }),

/***/ 1247:
/***/ (function(module, exports, __webpack_require__) {

var map = {
	"./af": 475,
	"./af.js": 475,
	"./ar": 476,
	"./ar-dz": 477,
	"./ar-dz.js": 477,
	"./ar-kw": 478,
	"./ar-kw.js": 478,
	"./ar-ly": 479,
	"./ar-ly.js": 479,
	"./ar-ma": 480,
	"./ar-ma.js": 480,
	"./ar-sa": 481,
	"./ar-sa.js": 481,
	"./ar-tn": 482,
	"./ar-tn.js": 482,
	"./ar.js": 476,
	"./az": 483,
	"./az.js": 483,
	"./be": 484,
	"./be.js": 484,
	"./bg": 485,
	"./bg.js": 485,
	"./bm": 486,
	"./bm.js": 486,
	"./bn": 487,
	"./bn.js": 487,
	"./bo": 488,
	"./bo.js": 488,
	"./br": 489,
	"./br.js": 489,
	"./bs": 490,
	"./bs.js": 490,
	"./ca": 491,
	"./ca.js": 491,
	"./cs": 492,
	"./cs.js": 492,
	"./cv": 493,
	"./cv.js": 493,
	"./cy": 494,
	"./cy.js": 494,
	"./da": 495,
	"./da.js": 495,
	"./de": 496,
	"./de-at": 497,
	"./de-at.js": 497,
	"./de-ch": 498,
	"./de-ch.js": 498,
	"./de.js": 496,
	"./dv": 499,
	"./dv.js": 499,
	"./el": 500,
	"./el.js": 500,
	"./en-au": 501,
	"./en-au.js": 501,
	"./en-ca": 502,
	"./en-ca.js": 502,
	"./en-gb": 503,
	"./en-gb.js": 503,
	"./en-ie": 504,
	"./en-ie.js": 504,
	"./en-il": 505,
	"./en-il.js": 505,
	"./en-nz": 506,
	"./en-nz.js": 506,
	"./eo": 507,
	"./eo.js": 507,
	"./es": 508,
	"./es-do": 509,
	"./es-do.js": 509,
	"./es-us": 510,
	"./es-us.js": 510,
	"./es.js": 508,
	"./et": 511,
	"./et.js": 511,
	"./eu": 512,
	"./eu.js": 512,
	"./fa": 513,
	"./fa.js": 513,
	"./fi": 514,
	"./fi.js": 514,
	"./fo": 515,
	"./fo.js": 515,
	"./fr": 516,
	"./fr-ca": 517,
	"./fr-ca.js": 517,
	"./fr-ch": 518,
	"./fr-ch.js": 518,
	"./fr.js": 516,
	"./fy": 519,
	"./fy.js": 519,
	"./gd": 520,
	"./gd.js": 520,
	"./gl": 521,
	"./gl.js": 521,
	"./gom-latn": 522,
	"./gom-latn.js": 522,
	"./gu": 523,
	"./gu.js": 523,
	"./he": 524,
	"./he.js": 524,
	"./hi": 525,
	"./hi.js": 525,
	"./hr": 526,
	"./hr.js": 526,
	"./hu": 527,
	"./hu.js": 527,
	"./hy-am": 528,
	"./hy-am.js": 528,
	"./id": 529,
	"./id.js": 529,
	"./is": 530,
	"./is.js": 530,
	"./it": 531,
	"./it.js": 531,
	"./ja": 532,
	"./ja.js": 532,
	"./jv": 533,
	"./jv.js": 533,
	"./ka": 534,
	"./ka.js": 534,
	"./kk": 535,
	"./kk.js": 535,
	"./km": 536,
	"./km.js": 536,
	"./kn": 537,
	"./kn.js": 537,
	"./ko": 538,
	"./ko.js": 538,
	"./ku": 539,
	"./ku.js": 539,
	"./ky": 540,
	"./ky.js": 540,
	"./lb": 541,
	"./lb.js": 541,
	"./lo": 542,
	"./lo.js": 542,
	"./lt": 543,
	"./lt.js": 543,
	"./lv": 544,
	"./lv.js": 544,
	"./me": 545,
	"./me.js": 545,
	"./mi": 546,
	"./mi.js": 546,
	"./mk": 547,
	"./mk.js": 547,
	"./ml": 548,
	"./ml.js": 548,
	"./mn": 549,
	"./mn.js": 549,
	"./mr": 550,
	"./mr.js": 550,
	"./ms": 551,
	"./ms-my": 552,
	"./ms-my.js": 552,
	"./ms.js": 551,
	"./mt": 553,
	"./mt.js": 553,
	"./my": 554,
	"./my.js": 554,
	"./nb": 555,
	"./nb.js": 555,
	"./ne": 556,
	"./ne.js": 556,
	"./nl": 557,
	"./nl-be": 558,
	"./nl-be.js": 558,
	"./nl.js": 557,
	"./nn": 559,
	"./nn.js": 559,
	"./pa-in": 560,
	"./pa-in.js": 560,
	"./pl": 561,
	"./pl.js": 561,
	"./pt": 562,
	"./pt-br": 563,
	"./pt-br.js": 563,
	"./pt.js": 562,
	"./ro": 564,
	"./ro.js": 564,
	"./ru": 565,
	"./ru.js": 565,
	"./sd": 566,
	"./sd.js": 566,
	"./se": 567,
	"./se.js": 567,
	"./si": 568,
	"./si.js": 568,
	"./sk": 569,
	"./sk.js": 569,
	"./sl": 570,
	"./sl.js": 570,
	"./sq": 571,
	"./sq.js": 571,
	"./sr": 572,
	"./sr-cyrl": 573,
	"./sr-cyrl.js": 573,
	"./sr.js": 572,
	"./ss": 574,
	"./ss.js": 574,
	"./sv": 575,
	"./sv.js": 575,
	"./sw": 576,
	"./sw.js": 576,
	"./ta": 577,
	"./ta.js": 577,
	"./te": 578,
	"./te.js": 578,
	"./tet": 579,
	"./tet.js": 579,
	"./tg": 580,
	"./tg.js": 580,
	"./th": 581,
	"./th.js": 581,
	"./tl-ph": 582,
	"./tl-ph.js": 582,
	"./tlh": 583,
	"./tlh.js": 583,
	"./tr": 584,
	"./tr.js": 584,
	"./tzl": 585,
	"./tzl.js": 585,
	"./tzm": 586,
	"./tzm-latn": 587,
	"./tzm-latn.js": 587,
	"./tzm.js": 586,
	"./ug-cn": 588,
	"./ug-cn.js": 588,
	"./uk": 589,
	"./uk.js": 589,
	"./ur": 590,
	"./ur.js": 590,
	"./uz": 591,
	"./uz-latn": 592,
	"./uz-latn.js": 592,
	"./uz.js": 591,
	"./vi": 593,
	"./vi.js": 593,
	"./x-pseudo": 594,
	"./x-pseudo.js": 594,
	"./yo": 595,
	"./yo.js": 595,
	"./zh-cn": 596,
	"./zh-cn.js": 596,
	"./zh-hk": 597,
	"./zh-hk.js": 597,
	"./zh-tw": 598,
	"./zh-tw.js": 598
};
function webpackContext(req) {
	return __webpack_require__(webpackContextResolve(req));
};
function webpackContextResolve(req) {
	var id = map[req];
	if(!(id + 1)) // check for number or string
		throw new Error("Cannot find module '" + req + "'.");
	return id;
};
webpackContext.keys = function webpackContextKeys() {
	return Object.keys(map);
};
webpackContext.resolve = webpackContextResolve;
module.exports = webpackContext;
webpackContext.id = 1247;

/***/ }),

/***/ 1251:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return TabService; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__provider_Api__ = __webpack_require__(49);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__services_BaseService__ = __webpack_require__(91);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__angular_core__ = __webpack_require__(0);
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};



var TabService = /** @class */ (function (_super) {
    __extends(TabService, _super);
    function TabService(api) {
        var _this = _super.call(this) || this;
        _this.api = api;
        return _this;
    }
    TabService.prototype.checkAppUpdate = function () {
        var _this = this;
        this.subscription.add(this.api.checkAppUpdate()
            .subscribe(function (res) {
            console.log(res);
            _this.page.checkUpdate(res);
        }, function (err) {
            //this.page.showMsg(err.msg);
            console.log(err);
        }));
    };
    TabService.prototype.postPushRegId = function (params) {
        this.subscription.add(this.api.registerPush(params)
            .subscribe(function (res) {
            console.log(res);
        }, function (err) {
            console.log(err);
        }));
    };
    TabService = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_2__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_0__provider_Api__["a" /* Api */]])
    ], TabService);
    return TabService;
}(__WEBPACK_IMPORTED_MODULE_1__services_BaseService__["a" /* BaseService */]));

//# sourceMappingURL=TabService.js.map

/***/ }),

/***/ 1271:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return MyApp; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__entity_DialogList__ = __webpack_require__(251);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__entity_User__ = __webpack_require__(662);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__entity_Account__ = __webpack_require__(663);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__provider_Api__ = __webpack_require__(49);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__provider_Constants__ = __webpack_require__(67);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__provider_utils_StorageUtils__ = __webpack_require__(92);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__pages_tabs_tabs__ = __webpack_require__(676);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__provider_Config__ = __webpack_require__(48);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__provider_utils_UiUtils__ = __webpack_require__(76);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__provider_utils_AppUtils__ = __webpack_require__(123);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11_ionic_angular__ = __webpack_require__(22);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_12__ionic_native_status_bar__ = __webpack_require__(652);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_13__ionic_native_splash_screen__ = __webpack_require__(653);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_14__ionic_native_screen_orientation__ = __webpack_require__(651);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_15__ionic_native_app_minimize__ = __webpack_require__(654);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_16_date_fns_add_seconds__ = __webpack_require__(93);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_16_date_fns_add_seconds___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_16_date_fns_add_seconds__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_17_typeorm__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_18__entity_Dialog__ = __webpack_require__(252);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
//import { Keyboard } from '@ionic-native/keyboard';



















var MyApp = /** @class */ (function () {
    function MyApp(platform, 
        //public keyboard : Keyboard,
        //private ionicApp: IonicApp,
        screenOrientation, statusBar, splashScreen, appUtils, uiUtils, app, local, api, appMinimize, events) {
        var _this = this;
        this.platform = platform;
        this.screenOrientation = screenOrientation;
        this.statusBar = statusBar;
        this.splashScreen = splashScreen;
        this.appUtils = appUtils;
        this.uiUtils = uiUtils;
        this.app = app;
        this.local = local;
        this.api = api;
        this.appMinimize = appMinimize;
        this.events = events;
        this.rootPage = '';
        this.backButtonPressed = false;
        this.platform.ready().then(function () { return __awaiter(_this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!this.platform.is("core")) return [3 /*break*/, 1];
                        //桌面浏览器判断
                        this.uiUtils.confirmDialogOneBtn('温馨提示', '请使用移动端浏览器或下载工作啦APP客户端！').then(function () {
                            _this.uiUtils.openUrlByBrowser("http://talent.goworkla.cn");
                        });
                        return [3 /*break*/, 4];
                    case 1:
                        this.config = __WEBPACK_IMPORTED_MODULE_7__provider_Config__["a" /* Config */].getInstance(); //实例化config
                        // Okay, so the platform is ready and our plugins are available.
                        // Here you can do any higher level native things you might need.
                        //this.statusBar.styleDefault();
                        //平台判断
                        this.config.isIOS = this.platform.is('ios');
                        this.config.isWeb = this.platform.is('mobileweb');
                        console.log("platform web :" + this.config.isWeb);
                        if (!!this.config.isWeb) return [3 /*break*/, 3];
                        this.splashScreen.hide();
                        this.statusBar.overlaysWebView(false);
                        this.statusBar.backgroundColorByHexString("#a650ff");
                        this.screenOrientation.lock(this.screenOrientation.ORIENTATIONS.PORTRAIT);
                        //键盘监听
                        /*
                        this.keyboard.onKeyboardShow().subscribe((value: any) => {
                          console.log("onKeyboardShow");
                          this.config.isKeyboardShow = true;
                          this.config.keyboardValue = value;
                        });
                    
                        this.keyboard.onKeyboardHide().subscribe((value: any) => {
                          console.log("onKeyboardHide");
                          this.config.isKeyboardShow = false;
                        });*/
                        //数据库全局初始化
                        return [4 /*yield*/, Object(__WEBPACK_IMPORTED_MODULE_17_typeorm__["l" /* createConnection */])({
                                type: 'cordova',
                                database: 'gwltalent',
                                location: 'default',
                                logging: ['error', 'schema'],
                                synchronize: true,
                                entities: [
                                    __WEBPACK_IMPORTED_MODULE_2__entity_Account__["a" /* Account */],
                                    __WEBPACK_IMPORTED_MODULE_1__entity_User__["a" /* User */],
                                    __WEBPACK_IMPORTED_MODULE_0__entity_DialogList__["a" /* DialogList */],
                                    __WEBPACK_IMPORTED_MODULE_18__entity_Dialog__["a" /* Dialog */] //消息内容
                                ]
                            })];
                    case 2:
                        //键盘监听
                        /*
                        this.keyboard.onKeyboardShow().subscribe((value: any) => {
                          console.log("onKeyboardShow");
                          this.config.isKeyboardShow = true;
                          this.config.keyboardValue = value;
                        });
                    
                        this.keyboard.onKeyboardHide().subscribe((value: any) => {
                          console.log("onKeyboardHide");
                          this.config.isKeyboardShow = false;
                        });*/
                        //数据库全局初始化
                        _a.sent();
                        this.registerBackButtonAction(); //注册返回按键事件
                        _a.label = 3;
                    case 3:
                        this.checkLogin();
                        _a.label = 4;
                    case 4: return [2 /*return*/];
                }
            });
        }); });
    }
    /**
     * 初始化token,acount_id,resume_id
     *
     */
    MyApp.prototype.checkLogin = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            var _a, page, id;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        if (!!this.config.isWeb) return [3 /*break*/, 2];
                        this.accountDB = Object(__WEBPACK_IMPORTED_MODULE_17_typeorm__["o" /* getRepository */])('account');
                        _a = this;
                        return [4 /*yield*/, this.accountDB.findOne()];
                    case 1:
                        _a.account = _b.sent();
                        this.userDB = Object(__WEBPACK_IMPORTED_MODULE_17_typeorm__["o" /* getRepository */])('user');
                        console.log(this.account);
                        if (this.account) {
                            this.config.token = this.account.token;
                            if (this.account.account_id) {
                                this.config.account_id = this.account.account_id;
                                this.config.jm_login_user = this.account.jm_user;
                                this.config.jm_login_pwd = this.account.jm_pwd;
                                //this.getResume();//更新用户信息
                                this.getUserInfo();
                            }
                            else {
                                this.checkAccount();
                            }
                        }
                        else {
                            this.rootPage = 'LoginStudentIdPage';
                        }
                        return [3 /*break*/, 3];
                    case 2:
                        /**
                         * 二维码扫描入口
                         * 未登录 带学校ID微站
                         * 已登录
                         */
                        console.log(this.platform.getQueryParam("app"));
                        page = this.platform.getQueryParam("app");
                        id = this.platform.getQueryParam("id");
                        if (page && id) {
                            switch (page) {
                                case 'campustalk':
                                    this.rootPage = 'WapCampusTalkPage';
                                    this.config.wapCampusTalkId = id;
                                    break;
                                case 'milkround':
                                    this.rootPage = 'WapMilkRoundPage';
                                    this.config.wapMilkRoundId = id;
                                    break;
                                case 'company':
                                    this.rootPage = 'WapCompanyPage';
                                    this.config.wapCompanyId = id;
                                    break;
                            }
                        }
                        else {
                            this.local.get(__WEBPACK_IMPORTED_MODULE_4__provider_Constants__["a" /* Constants */].LocalStorage.AccessToken).then(function (res) {
                                console.log("获取本地accesstoken");
                                console.log(res);
                                if (res) {
                                    _this.config.token = res;
                                    _this.local.get(__WEBPACK_IMPORTED_MODULE_4__provider_Constants__["a" /* Constants */].LocalStorage.AccountId).then(function (accountId) {
                                        if (accountId) {
                                            _this.config.account_id = accountId;
                                            /**
                                             * 极光账号
                                             */
                                            _this.local.get(__WEBPACK_IMPORTED_MODULE_4__provider_Constants__["a" /* Constants */].LocalStorage.JmUser).then(function (user) {
                                                _this.config.jm_login_user = user;
                                            });
                                            _this.local.get(__WEBPACK_IMPORTED_MODULE_4__provider_Constants__["a" /* Constants */].LocalStorage.JmPwd).then(function (pwd) {
                                                _this.config.jm_login_pwd = pwd;
                                            });
                                            _this.getUserInfo();
                                            //this.getResume();//更新用户信息
                                        }
                                        else {
                                            _this.checkAccount();
                                        }
                                    });
                                }
                                else {
                                    _this.goWapHome();
                                }
                            });
                        }
                        _b.label = 3;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * 未登录的wap首页
     * url链接中必须有 学校id
     * IP/#/5ab99b55d041fd4014a3b8f4
     *
     * 本地存储 collegeid 防止刷新丢失
     */
    MyApp.prototype.goWapHome = function () {
        /*
        this.local.get(Constants.LocalStorage.CollegeId).then((id) => {
          if(id){
            this.config.collegeId = id;
          }else{
            let params = window.location.hash;
            this.config.collegeId = params.replace('#/','');
    
            if(this.config.collegeId){
              this.local.set(Constants.LocalStorage.CollegeId,this.config.collegeId);
            }
          }
    
          
        });*/
        var params = window.location.hash;
        this.config.collegeId = params.replace('#/', '');
        this.rootPage = 'WapTabsPage';
    };
    MyApp.prototype.checkAccount = function () {
        var _this = this;
        this.api.getAccount()
            .subscribe(function (res) { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!res.accountid) return [3 /*break*/, 4];
                        this.config.account_id = res.accountid;
                        this.config.jm_login_user = res.jm_username;
                        this.config.jm_login_pwd = res.jm_password;
                        if (!!this.config.isWeb) return [3 /*break*/, 2];
                        this.account.account_id = res.accountid;
                        this.account.jm_user = res.jm_username;
                        this.account.jm_pwd = res.jm_password;
                        return [4 /*yield*/, this.accountDB.save(this.account)];
                    case 1:
                        _a.sent();
                        return [3 /*break*/, 3];
                    case 2:
                        this.local.set(__WEBPACK_IMPORTED_MODULE_4__provider_Constants__["a" /* Constants */].LocalStorage.AccountId, res.accountid);
                        this.local.set(__WEBPACK_IMPORTED_MODULE_4__provider_Constants__["a" /* Constants */].LocalStorage.JmUser, res.jm_username);
                        this.local.set(__WEBPACK_IMPORTED_MODULE_4__provider_Constants__["a" /* Constants */].LocalStorage.JmPwd, res.jm_password);
                        _a.label = 3;
                    case 3:
                        //更新简历
                        //this.getResume();
                        this.getUserInfo();
                        return [3 /*break*/, 5];
                    case 4:
                        this.rootPage = 'LoginUserProfilePage';
                        _a.label = 5;
                    case 5: return [2 /*return*/];
                }
            });
        }); }, function (err) {
            //this.uiUtils.showToast(err.msg);
            if (err.error.status == 403 || err.error.status == 401) {
                _this.rootPage = 'LoginStudentIdPage';
            }
        });
    };
    MyApp.prototype.getResume = function () {
        var _this = this;
        this.api.getResume()
            .subscribe(function (res) { return __awaiter(_this, void 0, void 0, function () {
            var _a, hasSelected, _i, _b, item;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        console.log(res);
                        if (!(res && res.resumeid)) return [3 /*break*/, 10];
                        this.config.resume_id = res.resumeid;
                        this.config.resume_number = res.resume_number;
                        //入职时间
                        this.config.entryTime.code = res.entry;
                        this.config.entryTime.text = res.entry_text;
                        if (!!this.config.isWeb) return [3 /*break*/, 2];
                        this.account.resume_id = res.resumeid;
                        this.account.resume_number = res.resume_number;
                        return [4 /*yield*/, this.accountDB.save(this.account)];
                    case 1:
                        _c.sent();
                        return [3 /*break*/, 3];
                    case 2:
                        this.local.set(__WEBPACK_IMPORTED_MODULE_4__provider_Constants__["a" /* Constants */].LocalStorage.ResumeId, res.resumeid);
                        this.local.set(__WEBPACK_IMPORTED_MODULE_4__provider_Constants__["a" /* Constants */].LocalStorage.ResumeNumber, res.resume_number);
                        _c.label = 3;
                    case 3:
                        if (!(res.education_backgrounds && res.education_backgrounds.length > 0)) return [3 /*break*/, 9];
                        this.config.education = res.education_backgrounds; //教育经历
                        this.config.user.name = res.talent_base.name;
                        this.config.user.sex = res.talent_base.gender;
                        if (res.talent_base.logo) {
                            this.config.user.avatar = res.talent_base.logo;
                        }
                        else {
                            if (res.talent_base.gender == "01") {
                                this.config.user.avatar = this.config.maleDefaultAvatar;
                            }
                            else if (res.talent_base.gender == "02") {
                                this.config.user.avatar = this.config.femaleDefaultAvatar;
                            }
                            else {
                                this.config.user.avatar = this.config.userDefaultAvatar;
                            }
                        }
                        this.config.user.wechat = res.talent_base.wechat;
                        this.config.user.email = res.talent_base.email;
                        this.config.userMobile = res.talent_base.mobile;
                        this.config.studentId = res.talent_base.no;
                        this.config.collegeId = res.talent_base.collegeid;
                        this.config.user.school = res.education_backgrounds[0].graduation_school;
                        this.config.user.schoolCode = res.education_backgrounds[0].school_code;
                        this.config.user.major = res.education_backgrounds[0].major_status_text;
                        if (!!this.config.isWeb) return [3 /*break*/, 7];
                        _a = this;
                        return [4 /*yield*/, this.userDB.findOne()];
                    case 4:
                        _a.user = _c.sent();
                        if (!this.user) return [3 /*break*/, 6];
                        this.user.name = res.talent_base.name;
                        this.user.sex = res.talent_base.gender;
                        this.user.avatar = res.talent_base.logo;
                        this.user.wechat = res.talent_base.wechat;
                        this.user.email = res.talent_base.email;
                        this.user.school = res.education_backgrounds[0].graduation_school;
                        this.user.schoolCode = res.education_backgrounds[0].school_code;
                        this.user.major = res.education_backgrounds[0].major_status_text;
                        return [4 /*yield*/, this.userDB.save(this.user)];
                    case 5:
                        _c.sent();
                        _c.label = 6;
                    case 6: return [3 /*break*/, 8];
                    case 7:
                        this.local.set(__WEBPACK_IMPORTED_MODULE_4__provider_Constants__["a" /* Constants */].LocalStorage.User, this.config.user);
                        _c.label = 8;
                    case 8:
                        this.config.jobTarget = res.job_target; //职位筛选条件
                        this.config.resumeLevel = res.level; //简历完整度
                        /*
                        if(res.job_target.work_city[0]){
                          this.config.user.targetCity = res.job_target.work_city[0].text;
                          this.config.user.targetCityCode = res.job_target.work_city[0].code;
                        }*/
                        //判断是否第一次注册技能
                        if (res.skills && res.skills.length > 0) {
                            this.config.skills = res.skills; //技能
                            this.config.workExperiences = res.work_experiences; //工作经历
                            this.config.training = res.training_experiences; //培训经历
                            this.config.certificates = res.certificates; //证书
                            this.config.opus = res.works; //作品
                            this.config.project = res.project_experiences; //项目/比赛经历
                            //判断是否第一职位订阅
                            //if(res.job_target.career.length > 0){
                            //this.config.career = res.job_target.career;
                            //判断是否选择职位
                            if (res.pro_skills && res.pro_skills.length > 0) {
                                this.config.proSkills = res.pro_skills;
                                hasSelected = true;
                                for (_i = 0, _b = this.config.proSkills; _i < _b.length; _i++) {
                                    item = _b[_i];
                                    if (item.contrast_list.length == 0) {
                                        hasSelected = false;
                                    }
                                }
                                //判断专业（职位）技能
                                if (hasSelected) {
                                    //初始化消息：清除所有会话和记录
                                    /*
                                    this.local.get(Constants.LocalStorage.DialogList).then((list) => {
                                      if(list){
                                        for(let i = 0;i < list.length;i++){
                                          this.local.remove(list[i].dlid);
                                        }
                                      }
                                      
                                      this.local.remove(Constants.LocalStorage.DialogList);
                                      this.config.dialogList = new Array();
                                      this.config.unReadTotal = 0;
                                    });*/
                                    //已完成引导注册
                                    this.rootPage = 'WelcomePage';
                                }
                                else {
                                    this.rootPage = 'LoginPositionSkillPage';
                                }
                            }
                            else {
                                this.rootPage = 'LoginPositionPage';
                            }
                            /*}else{
                              this.rootPage = 'LoginPositionPage';
                            }*/
                        }
                        else {
                            //注册技能
                            this.rootPage = 'LoginUserSkillPage';
                        }
                        return [3 /*break*/, 10];
                    case 9:
                        //注册学校
                        this.rootPage = 'LoginCollegePage';
                        _c.label = 10;
                    case 10: return [2 /*return*/];
                }
            });
        }); }, function (err) {
            console.log(err);
            if (err.error) {
                if (err.error.status == 403 || err.error.status == 401) {
                    _this.refreshToken();
                }
                else if (err.error.status == 400) {
                    _this.rootPage = 'LoginStudentIdPage';
                }
                else {
                    _this.uiUtils.confirmDialogOneBtn('网络错误', '连接服务器失败！请稍后重试').then(function () {
                        _this.platform.exitApp();
                    });
                }
            }
            else {
                _this.rootPage = 'LoginStudentIdPage';
            }
        });
    };
    MyApp.prototype.getUserInfo = function () {
        var _this = this;
        this.api.getUserInfo()
            .subscribe(function (res) {
            console.log("get user info");
            console.log(res);
            if (res.mobile_actived == false || !res.mobile) {
                _this.rootPage = 'BindingMobilePage';
            }
            else {
                _this.getResume();
            }
        }, function (err) {
            if (_this.config.isWeb) {
                _this.goWapHome();
            }
            else {
                _this.rootPage = 'LoginStudentIdPage';
            }
        });
    };
    MyApp.prototype.refreshToken = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            var token, account, res, params;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!!this.config.isWeb) return [3 /*break*/, 2];
                        return [4 /*yield*/, this.accountDB.findOne()];
                    case 1:
                        account = _a.sent();
                        token = account.refresh_token;
                        return [3 /*break*/, 4];
                    case 2: return [4 /*yield*/, this.local.get(__WEBPACK_IMPORTED_MODULE_4__provider_Constants__["a" /* Constants */].LocalStorage.RefreshToken)];
                    case 3:
                        res = _a.sent();
                        token = res;
                        _a.label = 4;
                    case 4:
                        params = {
                            "grant_type": "refresh_token",
                            "code": '',
                            "refresh_token": token,
                            "loginname": '',
                            "password": '',
                            "login_source": '',
                        };
                        this.api.getToken(params)
                            .subscribe(function (res) { return __awaiter(_this, void 0, void 0, function () {
                            var expiresDate;
                            return __generator(this, function (_a) {
                                switch (_a.label) {
                                    case 0:
                                        console.log("refresh_token =>" + res.access_token);
                                        this.config.token = res.access_token;
                                        expiresDate = __WEBPACK_IMPORTED_MODULE_16_date_fns_add_seconds__(new Date(), res.expires_in);
                                        console.log(expiresDate);
                                        if (!!this.config.isWeb) return [3 /*break*/, 2];
                                        this.account.token = res.access_token;
                                        this.account.refresh_token = res.refresh_token;
                                        this.account.token_expires = expiresDate.toString();
                                        return [4 /*yield*/, this.accountDB.save(this.account)];
                                    case 1:
                                        _a.sent();
                                        return [3 /*break*/, 3];
                                    case 2:
                                        this.local.set(__WEBPACK_IMPORTED_MODULE_4__provider_Constants__["a" /* Constants */].LocalStorage.AccessToken, res.access_token);
                                        this.local.set(__WEBPACK_IMPORTED_MODULE_4__provider_Constants__["a" /* Constants */].LocalStorage.RefreshToken, res.refresh_token);
                                        this.local.set(__WEBPACK_IMPORTED_MODULE_4__provider_Constants__["a" /* Constants */].LocalStorage.TokenExpiresDate, expiresDate);
                                        _a.label = 3;
                                    case 3:
                                        this.checkLogin();
                                        return [2 /*return*/];
                                }
                            });
                        }); }, function (err) {
                            _this.rootPage = 'LoginStudentIdPage';
                        });
                        return [2 /*return*/];
                }
            });
        });
    };
    MyApp.prototype.registerBackButtonAction = function () {
        var _this = this;
        if (!this.appUtils.isAndroid()) {
            return;
        }
        this.platform.registerBackButtonAction(function () {
            if (_this.config.isKeyboardShow) {
                //this.keyboard.close();
                //this.config.isKeyboardShow = false;
                return;
            }
            //如果想点击返回按钮隐藏toast或loading或Overlay就把下面加上
            var overlay = _this.app._appRoot._overlayPortal.getActive();
            if (overlay && overlay.dismiss) {
                overlay.dismiss();
                return;
            }
            var modalOverlay = _this.app._appRoot._modalPortal.getActive();
            if (modalOverlay && modalOverlay.dismiss) {
                modalOverlay.dismiss();
                return;
            }
            var activeVC = _this.nav.getActive();
            /*if(!activeVC){
              return;
            }*/
            var page = activeVC.instance;
            if (!(page instanceof __WEBPACK_IMPORTED_MODULE_6__pages_tabs_tabs__["a" /* TabsPage */])) {
                if (!_this.nav.canGoBack()) {
                    return _this.showExit();
                    //return this.myAppMinimize();
                }
                return _this.nav.pop();
            }
            var tabs = page.tabs;
            var activeNav = tabs.getSelected();
            return activeNav.canGoBack() ? activeNav.pop() : _this.showExit(); //this.myAppMinimize();
        }, 999);
    };
    MyApp.prototype.myAppMinimize = function () {
        this.appMinimize.minimize();
        //this.config.showLocalNotifications = true;
        //由于在chat页面中屏蔽消息通知，在此页面下最小化退出，接收不到消息通知
        /*
        let activeVC = this.nav.getActive();
        let page = activeVC.instance;
        let tabs = page.tabs;
        tabs.select(0);*/
    };
    //双击退出提示框
    MyApp.prototype.showExit = function () {
        var _this = this;
        if (this.backButtonPressed) {
            //this.platform.exitApp();
            this.myAppMinimize();
        }
        else {
            this.uiUtils.showToast('再按一次退出工作啦', "bottom");
            this.backButtonPressed = true;
            setTimeout(function () {
                _this.backButtonPressed = false;
            }, 2000);
        }
    };
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_10__angular_core__["ViewChild"])('myNav'),
        __metadata("design:type", __WEBPACK_IMPORTED_MODULE_11_ionic_angular__["Nav"])
    ], MyApp.prototype, "nav", void 0);
    MyApp = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_10__angular_core__["Component"])({template:/*ion-inline-start:"E:\workspace\TalentApp\src\app\app.html"*/'<ion-nav #myNav [root]="rootPage"></ion-nav>'/*ion-inline-end:"E:\workspace\TalentApp\src\app\app.html"*/
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_11_ionic_angular__["Platform"],
            __WEBPACK_IMPORTED_MODULE_14__ionic_native_screen_orientation__["a" /* ScreenOrientation */],
            __WEBPACK_IMPORTED_MODULE_12__ionic_native_status_bar__["a" /* StatusBar */],
            __WEBPACK_IMPORTED_MODULE_13__ionic_native_splash_screen__["a" /* SplashScreen */],
            __WEBPACK_IMPORTED_MODULE_9__provider_utils_AppUtils__["a" /* APPUtils */],
            __WEBPACK_IMPORTED_MODULE_8__provider_utils_UiUtils__["a" /* UiUtils */],
            __WEBPACK_IMPORTED_MODULE_11_ionic_angular__["App"],
            __WEBPACK_IMPORTED_MODULE_5__provider_utils_StorageUtils__["a" /* StorageUtils */],
            __WEBPACK_IMPORTED_MODULE_3__provider_Api__["a" /* Api */],
            __WEBPACK_IMPORTED_MODULE_15__ionic_native_app_minimize__["a" /* AppMinimize */],
            __WEBPACK_IMPORTED_MODULE_11_ionic_angular__["Events"]])
    ], MyApp);
    return MyApp;
}());

//# sourceMappingURL=app.component.js.map

/***/ }),

/***/ 1272:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "c", function() { return ModalFromRightEnter; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "d", function() { return ModalFromRightLeave; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "b", function() { return ModalFromBottomtEnter; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return ModalFromBottomLeave; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "e", function() { return ModalFromTopEnter; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "f", function() { return ModalFromTopLeave; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "g", function() { return ModalScaleEnter; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "h", function() { return ModalScaleLeave; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_ionic_angular__ = __webpack_require__(22);
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();

/**
 * 从右面侧滑进入
 */
var ModalFromRightEnter = /** @class */ (function (_super) {
    __extends(ModalFromRightEnter, _super);
    function ModalFromRightEnter() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    ModalFromRightEnter.prototype.init = function () {
        _super.prototype.init.call(this);
        var ele = this.enteringView.pageRef().nativeElement;
        var backdrop = new __WEBPACK_IMPORTED_MODULE_0_ionic_angular__["Animation"](this.plt, ele.querySelector('ion-backdrop'));
        backdrop.beforeStyles({ 'z-index': 0, 'opacity': 0.3, 'visibility': 'visible' });
        var wrapper = new __WEBPACK_IMPORTED_MODULE_0_ionic_angular__["Animation"](this.plt, ele.querySelector('.modal-wrapper'));
        wrapper.beforeStyles({ 'opacity': 1 });
        wrapper.fromTo('transform', 'translateX(100%)', 'translateX(20%)');
        var contentWrapper = new __WEBPACK_IMPORTED_MODULE_0_ionic_angular__["Animation"](this.plt, ele.querySelector('ion-content.content'));
        contentWrapper.beforeStyles({ 'width': '80%' });
        this
            .element(this.enteringView.pageRef())
            .duration(300)
            .easing('cubic-bezier(.25, 1.1, .25, 1)')
            .add(backdrop)
            .add(wrapper)
            .add(contentWrapper);
    };
    return ModalFromRightEnter;
}(__WEBPACK_IMPORTED_MODULE_0_ionic_angular__["PageTransition"]));

/**
 * 向右面侧滑消失
 */
var ModalFromRightLeave = /** @class */ (function (_super) {
    __extends(ModalFromRightLeave, _super);
    function ModalFromRightLeave() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    ModalFromRightLeave.prototype.init = function () {
        _super.prototype.init.call(this);
        var ele = this.leavingView.pageRef().nativeElement;
        var backdrop = new __WEBPACK_IMPORTED_MODULE_0_ionic_angular__["Animation"](this.plt, ele.querySelector('ion-backdrop'));
        backdrop.beforeStyles({ 'visibility': 'hidden' });
        var wrapper = new __WEBPACK_IMPORTED_MODULE_0_ionic_angular__["Animation"](this.plt, ele.querySelector('.modal-wrapper'));
        wrapper.fromTo('transform', 'translateX(20%)', 'translateX(100%)');
        this
            .element(this.leavingView.pageRef())
            .duration(300)
            .easing('cubic-bezier(.25, .1, .25, 1)')
            .add(backdrop)
            .add(wrapper);
    };
    return ModalFromRightLeave;
}(__WEBPACK_IMPORTED_MODULE_0_ionic_angular__["PageTransition"]));

/**
 * 从底部滑入
 * 只显示50%页面大小
 */
var ModalFromBottomtEnter = /** @class */ (function (_super) {
    __extends(ModalFromBottomtEnter, _super);
    function ModalFromBottomtEnter() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    ModalFromBottomtEnter.prototype.init = function () {
        _super.prototype.init.call(this);
        var ele = this.enteringView.pageRef().nativeElement;
        var backdrop = new __WEBPACK_IMPORTED_MODULE_0_ionic_angular__["Animation"](this.plt, ele.querySelector('ion-backdrop'));
        backdrop.beforeStyles({ 'z-index': 0, 'opacity': 0.3, 'visibility': 'visible' });
        var wrapper = new __WEBPACK_IMPORTED_MODULE_0_ionic_angular__["Animation"](this.plt, ele.querySelector('.modal-wrapper'));
        wrapper.beforeStyles({ 'opacity': 1 });
        wrapper.fromTo('transform', 'translateY(100%)', 'translateY(50%)');
        /*
        const contentWrapper = new Animation(this.plt, ele.querySelector('ion-content.content'));
        contentWrapper.beforeStyles({'height': '50%'});*/
        this
            .element(this.enteringView.pageRef())
            .duration(300)
            .easing('cubic-bezier(.25, 1.1, .25, 1)')
            .add(backdrop)
            .add(wrapper);
        //.add(contentWrapper);
    };
    return ModalFromBottomtEnter;
}(__WEBPACK_IMPORTED_MODULE_0_ionic_angular__["PageTransition"]));

/**
 * 向底部滑出
 */
var ModalFromBottomLeave = /** @class */ (function (_super) {
    __extends(ModalFromBottomLeave, _super);
    function ModalFromBottomLeave() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    ModalFromBottomLeave.prototype.init = function () {
        _super.prototype.init.call(this);
        var ele = this.leavingView.pageRef().nativeElement;
        var backdrop = new __WEBPACK_IMPORTED_MODULE_0_ionic_angular__["Animation"](this.plt, ele.querySelector('ion-backdrop'));
        backdrop.beforeStyles({ 'visibility': 'hidden' });
        var wrapper = new __WEBPACK_IMPORTED_MODULE_0_ionic_angular__["Animation"](this.plt, ele.querySelector('.modal-wrapper'));
        wrapper.fromTo('transform', 'translateY(50%)', 'translateY(-100%)');
        this
            .element(this.leavingView.pageRef())
            .duration(300)
            .easing('cubic-bezier(.25, .1, .25, 1)')
            .add(backdrop)
            .add(wrapper);
    };
    return ModalFromBottomLeave;
}(__WEBPACK_IMPORTED_MODULE_0_ionic_angular__["PageTransition"]));

/**
 * 从顶部滑入
 * 只显示50%页面大小
 */
var ModalFromTopEnter = /** @class */ (function (_super) {
    __extends(ModalFromTopEnter, _super);
    function ModalFromTopEnter() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    ModalFromTopEnter.prototype.init = function () {
        _super.prototype.init.call(this);
        var ele = this.enteringView.pageRef().nativeElement;
        var backdrop = new __WEBPACK_IMPORTED_MODULE_0_ionic_angular__["Animation"](this.plt, ele.querySelector('ion-backdrop'));
        backdrop.beforeStyles({ 'z-index': 0, 'opacity': 0.3, 'visibility': 'visible' });
        var wrapper = new __WEBPACK_IMPORTED_MODULE_0_ionic_angular__["Animation"](this.plt, ele.querySelector('.modal-wrapper'));
        wrapper.beforeStyles({ 'opacity': 1, 'height': '50%' });
        wrapper.fromTo('transform', 'translateY(-100%)', 'translateY(0%)');
        /*
        const contentWrapper = new Animation(this.plt, ele.querySelector('ion-content.content'));
        contentWrapper.beforeStyles({'height': '50%'});*/
        this
            .element(this.enteringView.pageRef())
            .duration(300)
            .easing('cubic-bezier(.25, 1.1, .25, 1)')
            .add(backdrop)
            .add(wrapper);
        //.add(contentWrapper);
    };
    return ModalFromTopEnter;
}(__WEBPACK_IMPORTED_MODULE_0_ionic_angular__["PageTransition"]));

/**
 * 向顶部滑出
 */
var ModalFromTopLeave = /** @class */ (function (_super) {
    __extends(ModalFromTopLeave, _super);
    function ModalFromTopLeave() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    ModalFromTopLeave.prototype.init = function () {
        _super.prototype.init.call(this);
        var ele = this.leavingView.pageRef().nativeElement;
        var backdrop = new __WEBPACK_IMPORTED_MODULE_0_ionic_angular__["Animation"](this.plt, ele.querySelector('ion-backdrop'));
        backdrop.beforeStyles({ 'visibility': 'hidden' });
        var wrapper = new __WEBPACK_IMPORTED_MODULE_0_ionic_angular__["Animation"](this.plt, ele.querySelector('.modal-wrapper'));
        wrapper.fromTo('transform', 'translateY(0%)', 'translateY(-100%)');
        this
            .element(this.leavingView.pageRef())
            .duration(300)
            .easing('cubic-bezier(.25, .1, .25, 1)')
            .add(backdrop)
            .add(wrapper);
    };
    return ModalFromTopLeave;
}(__WEBPACK_IMPORTED_MODULE_0_ionic_angular__["PageTransition"]));

var ModalScaleEnter = /** @class */ (function (_super) {
    __extends(ModalScaleEnter, _super);
    function ModalScaleEnter() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    ModalScaleEnter.prototype.init = function () {
        _super.prototype.init.call(this);
        var ele = this.enteringView.pageRef().nativeElement;
        var wrapper = new __WEBPACK_IMPORTED_MODULE_0_ionic_angular__["Animation"](this.plt, ele.querySelector('.modal-wrapper'));
        wrapper.fromTo('transform', 'scale(0)', 'scale(1)');
        this
            .element(this.enteringView.pageRef())
            .duration(400)
            .easing('cubic-bezier(.1, .7, .1, 1)')
            .add(wrapper);
    };
    return ModalScaleEnter;
}(__WEBPACK_IMPORTED_MODULE_0_ionic_angular__["PageTransition"]));

var ModalScaleLeave = /** @class */ (function (_super) {
    __extends(ModalScaleLeave, _super);
    function ModalScaleLeave() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    ModalScaleLeave.prototype.init = function () {
        _super.prototype.init.call(this);
        var ele = this.leavingView.pageRef().nativeElement;
        var wrapper = new __WEBPACK_IMPORTED_MODULE_0_ionic_angular__["Animation"](this.plt, ele.querySelector('.modal-wrapper'));
        wrapper.fromTo('transform', 'scale(1)', 'scale(0)');
        this
            .element(this.leavingView.pageRef())
            .duration(400)
            .easing('cubic-bezier(.1, .7, .1, 1)')
            .add(wrapper);
    };
    return ModalScaleLeave;
}(__WEBPACK_IMPORTED_MODULE_0_ionic_angular__["PageTransition"]));

//# sourceMappingURL=modal-transitions.js.map

/***/ }),

/***/ 155:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return DateUtils; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};

var DateUtils = /** @class */ (function () {
    function DateUtils() {
    }
    /**
     * 日期对象转为日期字符串
     * @param date 需要格式化的日期对象
     * @param sFormat 输出格式,默认为yyyy-MM-dd                         年：y，月：M，日：d，时：h，分：m，秒：s
     * @example  dateFormat(new Date())                                "2017-02-28"
     * @example  dateFormat(new Date(),'yyyy-MM-dd')                   "2017-02-28"
     * @example  dateFormat(new Date(),'yyyy-MM-dd hh:mm:ss')         "2017-02-28 09:24:00"
     * @example  dateFormat(new Date(),'hh:mm')                       "09:24"
     * @example  dateFormat(new Date(),'yyyy-MM-ddThh:mm:ss+08:00')   "2017-02-28T09:24:00+08:00"
     * @returns {string}
     */
    DateUtils.dateFormat = function (date, sFormat) {
        if (sFormat === void 0) { sFormat = 'yyyy-MM-dd'; }
        var time = {
            Year: 0,
            TYear: '0',
            Month: 0,
            TMonth: '0',
            Day: 0,
            TDay: '0',
            Hour: 0,
            THour: '0',
            hour: 0,
            Thour: '0',
            Minute: 0,
            TMinute: '0',
            Second: 0,
            TSecond: '0',
            Millisecond: 0
        };
        time.Year = date.getFullYear();
        time.TYear = String(time.Year).substr(2);
        time.Month = date.getMonth() + 1;
        time.TMonth = time.Month < 10 ? "0" + time.Month : String(time.Month);
        time.Day = date.getDate();
        time.TDay = time.Day < 10 ? "0" + time.Day : String(time.Day);
        time.Hour = date.getHours();
        time.THour = time.Hour < 10 ? "0" + time.Hour : String(time.Hour);
        time.hour = time.Hour < 13 ? time.Hour : time.Hour - 12;
        time.Thour = time.hour < 10 ? "0" + time.hour : String(time.hour);
        time.Minute = date.getMinutes();
        time.TMinute = time.Minute < 10 ? "0" + time.Minute : String(time.Minute);
        time.Second = date.getSeconds();
        time.TSecond = time.Second < 10 ? "0" + time.Second : String(time.Second);
        time.Millisecond = date.getMilliseconds();
        return sFormat.replace(/yyyy/ig, String(time.Year))
            .replace(/yyy/ig, String(time.Year))
            .replace(/yy/ig, time.TYear)
            .replace(/y/ig, time.TYear)
            .replace(/MM/g, time.TMonth)
            .replace(/M/g, String(time.Month))
            .replace(/dd/ig, time.TDay)
            .replace(/d/ig, String(time.Day))
            .replace(/HH/g, time.THour)
            .replace(/H/g, String(time.Hour))
            .replace(/hh/g, time.Thour)
            .replace(/h/g, String(time.hour))
            .replace(/mm/g, time.TMinute)
            .replace(/m/g, String(time.Minute))
            .replace(/ss/ig, time.TSecond)
            .replace(/s/ig, String(time.Second))
            .replace(/fff/ig, String(time.Millisecond));
    };
    /**
     * 计算增加后的日期
     * @param interval 按什么（年，月，日，小时）计算
     * @param number 计算值
     * @param date 当前日期
     */
    DateUtils.dateAdd = function (interval, number, date) {
        switch (interval) {
            //年
            case "y": {
                date.setFullYear(date.getFullYear() + number);
                return date;
            }
            //季度
            case "q": {
                date.setMonth(date.getMonth() + number * 3);
                return date;
            }
            case "m": {
                date.setMonth(date.getMonth() + number);
                return date;
            }
            case "w": {
                date.setDate(date.getDate() + number * 7);
                return date;
            }
            case "d": {
                date.setDate(date.getDate() + number);
                return date;
            }
            case "h": {
                date.setHours(date.getHours() + number);
                return date;
            }
            case "m": {
                date.setMinutes(date.getMinutes() + number);
                return date;
            }
            case "s": {
                date.setSeconds(date.getSeconds() + number);
                return date;
            }
            default: {
                date.setDate(date.getDate() + number);
                return date;
            }
        }
    };
    /**
     * 计算减去后的日期
     * @param interval 按什么（年，月，日，小时）计算
     * @param number 计算值
     * @param date 当前日期
     */
    DateUtils.dateSub = function (interval, number, date) {
        switch (interval) {
            //年
            case "y": {
                date.setFullYear(date.getFullYear() - number);
                return date;
            }
            //季度
            case "q": {
                date.setMonth(date.getMonth() - number * 3);
                return date;
            }
            case "m": {
                date.setMonth(date.getMonth() - number);
                return date;
            }
            case "w": {
                date.setDate(date.getDate() - number * 7);
                return date;
            }
            case "d": {
                date.setDate(date.getDate() - number);
                return date;
            }
            case "h": {
                date.setHours(date.getHours() - number);
                return date;
            }
            case "m": {
                date.setMinutes(date.getMinutes() - number);
                return date;
            }
            case "s": {
                date.setSeconds(date.getSeconds() - number);
                return date;
            }
            default: {
                date.setDate(date.getDate() - number);
                return date;
            }
        }
    };
    DateUtils = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [])
    ], DateUtils);
    return DateUtils;
}());

//# sourceMappingURL=DateUtils.js.map

/***/ }),

/***/ 156:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return ChatUtils; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__entity_DialogList__ = __webpack_require__(251);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__model_ListItemData__ = __webpack_require__(658);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__model_ChatMessage__ = __webpack_require__(250);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__UiUtils__ = __webpack_require__(76);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__Api__ = __webpack_require__(49);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5_ionic_angular__ = __webpack_require__(22);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__Config__ = __webpack_require__(48);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__Constants__ = __webpack_require__(67);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__StorageUtils__ = __webpack_require__(92);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__provider_utils_DateUtils__ = __webpack_require__(155);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11_typeorm__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_12__entity_Dialog__ = __webpack_require__(252);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};













//import { LocalNotifications } from '@ionic-native/local-notifications';
/**
 * 消息处理工具
 */
var ChatUtils = /** @class */ (function () {
    function ChatUtils(local, api, events, uiUtils) {
        this.local = local;
        this.api = api;
        this.events = events;
        this.uiUtils = uiUtils;
        this.config = __WEBPACK_IMPORTED_MODULE_6__Config__["a" /* Config */].getInstance();
        if (!this.config.isWeb) {
            this.dialogListDB = Object(__WEBPACK_IMPORTED_MODULE_11_typeorm__["o" /* getRepository */])('dialog_list');
            this.dialogDB = Object(__WEBPACK_IMPORTED_MODULE_11_typeorm__["o" /* getRepository */])('dialog');
        }
    }
    /**
     * 统计所有消息未读数
    */
    ChatUtils.prototype.initUnReadTotal = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            var chat_list, list, i, i;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!!this.config.isWeb) return [3 /*break*/, 2];
                        return [4 /*yield*/, this.dialogListDB.find()];
                    case 1:
                        chat_list = _a.sent();
                        if (chat_list) {
                            list = new Array();
                            for (i = 0; i < chat_list.length; i++) {
                                list.push(JSON.parse(chat_list[i].content));
                            }
                            this.config.unReadTotal = 0;
                            if (list) {
                                for (i = 0; i < list.length; i++) {
                                    this.config.unReadTotal += list[i].unread_count;
                                }
                                if (this.config.unReadTotal < 0) {
                                    this.config.unReadTotal = 0;
                                }
                            }
                        }
                        return [3 /*break*/, 3];
                    case 2:
                        this.local.get(__WEBPACK_IMPORTED_MODULE_7__Constants__["a" /* Constants */].LocalStorage.DialogList).then(function (list) {
                            _this.config.unReadTotal = 0;
                            if (list) {
                                for (var i = 0; i < list.length; i++) {
                                    _this.config.unReadTotal += list[i].unread_count;
                                }
                                if (_this.config.unReadTotal < 0) {
                                    _this.config.unReadTotal = 0;
                                }
                            }
                        });
                        _a.label = 3;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * 收到消息
     *
     */
    ChatUtils.prototype.messageReceiveUpdate = function (message) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            var current_dlid, isExist, messageType, messageContent, chat_list, list, i, i, _shield, dialog;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        isExist = false;
                        /*
                        if(jmessage.extras && jmessage.extras.type && jmessage.extras.content){
                            messageType = jmessage.extras.type;
                            messageContent = jmessage.extras.content;
                        }else{
                            messageType = "text";
                            messageContent = jmessage.text;
                        }
                        console.log("messageReceiveUpdate");
                        console.log(jmessage);*/
                        if (message) {
                            messageType = message.type;
                            messageContent = message.content;
                        }
                        if (!!this.config.isWeb) return [3 /*break*/, 10];
                        return [4 /*yield*/, this.dialogListDB.find()];
                    case 1:
                        chat_list = _a.sent();
                        list = new Array();
                        for (i = 0; i < chat_list.length; i++) {
                            list.push(JSON.parse(chat_list[i].content));
                        }
                        if (!list) return [3 /*break*/, 8];
                        i = 0;
                        _a.label = 2;
                    case 2:
                        if (!(i < list.length)) return [3 /*break*/, 7];
                        if (!(list[i].dialogue_jmusername == message.toUserName)) return [3 /*break*/, 6];
                        if (!(messageType == __WEBPACK_IMPORTED_MODULE_2__model_ChatMessage__["a" /* ChatMessage */].SHIELD)) return [3 /*break*/, 3];
                        _shield = void 0;
                        if (messageContent == 'true') {
                            _shield = true;
                        }
                        else {
                            _shield = false;
                        }
                        this.updateDialogueShield(list[i].dialogue_jmusername, _shield, false);
                        return [3 /*break*/, 5];
                    case 3:
                        list[i].last_message_type = messageType;
                        list[i].last_message = this.formatMessageContent(messageType, messageContent);
                        list[i].last_message_time = __WEBPACK_IMPORTED_MODULE_10__provider_utils_DateUtils__["a" /* DateUtils */].dateFormat(new Date(message.dateTime), 'yyyy-MM-ddTHH:mm:ss+08:00');
                        list[i].unread_count += 1;
                        dialog = new __WEBPACK_IMPORTED_MODULE_0__entity_DialogList__["a" /* DialogList */]();
                        dialog.dialog_user = message.toUserName;
                        dialog.content = JSON.stringify(list[i]);
                        return [4 /*yield*/, this.dialogListDB.save(dialog)];
                    case 4:
                        _a.sent(); //更新对话列表
                        _a.label = 5;
                    case 5:
                        isExist = true;
                        return [3 /*break*/, 7];
                    case 6:
                        i++;
                        return [3 /*break*/, 2];
                    case 7:
                        if (isExist) {
                            //更新对话列表,重新排序
                            this.updateDialogList();
                            this.initUnReadTotal();
                            //this.updateChatList(current_dlid,message);
                        }
                        else {
                            //新的会话
                            this.api.getChatDialogue(message.toUserName)
                                .subscribe(function (res) { return __awaiter(_this, void 0, void 0, function () {
                                var dialog;
                                return __generator(this, function (_a) {
                                    switch (_a.label) {
                                        case 0:
                                            console.log(res);
                                            res.last_message = this.formatMessageContent(res.last_message_type, res.last_message);
                                            //list.push(res);
                                            current_dlid = res.dlid;
                                            dialog = new __WEBPACK_IMPORTED_MODULE_0__entity_DialogList__["a" /* DialogList */]();
                                            dialog.dialog_user = message.toUserName;
                                            dialog.content = JSON.stringify(res);
                                            dialog.datetime = res.last_message_time;
                                            return [4 /*yield*/, this.dialogListDB.insert(dialog)];
                                        case 1:
                                            _a.sent();
                                            //更新对话列表,重新排序
                                            this.updateDialogList();
                                            return [2 /*return*/];
                                    }
                                });
                            }); }, function (err) {
                                console.log(err.msg);
                            });
                        }
                        return [3 /*break*/, 9];
                    case 8:
                        this.api.getChatDialogue(message.toUserName)
                            .subscribe(function (res) { return __awaiter(_this, void 0, void 0, function () {
                            var dialog;
                            return __generator(this, function (_a) {
                                switch (_a.label) {
                                    case 0:
                                        console.log(res);
                                        //let list = new Array();
                                        res.last_message = this.formatMessageContent(res.last_message_type, res.last_message);
                                        dialog = new __WEBPACK_IMPORTED_MODULE_0__entity_DialogList__["a" /* DialogList */]();
                                        dialog.dialog_user = message.toUserName;
                                        dialog.content = JSON.stringify(res);
                                        dialog.datetime = res.last_message_time;
                                        return [4 /*yield*/, this.dialogListDB.insert(dialog)];
                                    case 1:
                                        _a.sent();
                                        //更新对话列表,重新排序
                                        this.updateDialogList();
                                        return [2 /*return*/];
                                }
                            });
                        }); }, function (err) {
                            console.log(err.msg);
                        });
                        _a.label = 9;
                    case 9: return [3 /*break*/, 11];
                    case 10:
                        this.local.get(__WEBPACK_IMPORTED_MODULE_7__Constants__["a" /* Constants */].LocalStorage.DialogList).then(function (list) {
                            if (list) {
                                for (var i = 0; i < list.length; i++) {
                                    if (list[i].dialogue_jmusername == message.toUserName) {
                                        if (messageType == __WEBPACK_IMPORTED_MODULE_2__model_ChatMessage__["a" /* ChatMessage */].SHIELD) {
                                            _this.updateDialogueShield(list[i].dlid, messageContent, false);
                                        }
                                        list[i].last_message_type = messageType;
                                        list[i].last_message = _this.formatMessageContent(messageType, messageContent);
                                        list[i].last_message_time = __WEBPACK_IMPORTED_MODULE_10__provider_utils_DateUtils__["a" /* DateUtils */].dateFormat(new Date(message.dateTime), 'yyyy-MM-ddTHH:mm:ss+08:00');
                                        list[i].unread_count += 1;
                                        current_dlid = list[i].dlid;
                                        isExist = true;
                                        break;
                                    }
                                }
                                /**
                                 * 如果会话已经存在，直接更新内容
                                 * 如果会话不存在，获取对话信息
                                 */
                                if (isExist) {
                                    console.log(list);
                                    _this.local.set(__WEBPACK_IMPORTED_MODULE_7__Constants__["a" /* Constants */].LocalStorage.DialogList, list);
                                    _this.config.dialogList = list;
                                    //this.events.publish("jmessage:update",message); 
                                }
                                else {
                                    //新的会话
                                    _this.api.getChatDialogue(message.toUserName)
                                        .subscribe(function (res) {
                                        console.log(res);
                                        res.last_message = _this.formatMessageContent(res.last_message_type, res.last_message);
                                        list.push(res);
                                        current_dlid = res.dlid;
                                        //dialogue_user = res.dialogue_user;
                                        //notification_id = res.dialogue_numberid;
                                        _this.local.set(__WEBPACK_IMPORTED_MODULE_7__Constants__["a" /* Constants */].LocalStorage.DialogList, list);
                                        _this.config.dialogList = list;
                                        //this.events.publish("jmessage:update",this.getChatMessageByJM(jmessage)); 
                                    }, function (err) {
                                        console.log(err.msg);
                                    });
                                }
                            }
                            else {
                                _this.api.getChatDialogue(message.toUserName)
                                    .subscribe(function (res) {
                                    console.log(res);
                                    var list = new Array();
                                    res.last_message = _this.formatMessageContent(res.last_message_type, res.last_message);
                                    list.push(res);
                                    _this.local.set(__WEBPACK_IMPORTED_MODULE_7__Constants__["a" /* Constants */].LocalStorage.DialogList, list);
                                    _this.config.dialogList = list;
                                    //this.events.publish("jmessage:update",this.getChatMessageByJM(jmessage)); 
                                }, function (err) {
                                    console.log(err.msg);
                                });
                            }
                            _this.config.dialogList = _this.transform(_this.config.dialogList, "last_message_time", true); //重新排序
                            //this.events.publish("jmessage:list","list");
                        });
                        _a.label = 11;
                    case 11: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * 数组去除重复元素
     * 根据id判断
     * @param list
     */
    ChatUtils.prototype.unique = function (list) {
        list.sort(); //先排序
        var res = [list[0]];
        for (var i = 0; i < list.length; i++) {
            if (list[i].id !== res[res.length - 1].id) {
                res.push(list[i]);
            }
        }
        return res;
    };
    /**
     * 离线消息
     * @param jmessageList
     *
     * 收到离线消息后，格式化成：
     * msg = {id : dlid,list : { jmessage}}
     * 再保存至本地
     */
    ChatUtils.prototype.offlineMessageUpdate = function (jmessageList) {
        var _this = this;
        var arrayId = new Array();
        //提取消息
        for (var item in jmessageList) {
            this.messageReceiveUpdate(jmessageList[item]); //更新本地对话列表最后一条消息
            var msg = new __WEBPACK_IMPORTED_MODULE_1__model_ListItemData__["b" /* MessageItemData */]();
            msg.userName = jmessageList[item].from.username;
            arrayId.push(msg);
        }
        console.log(arrayId);
        console.log("unique");
        arrayId = this.unique(arrayId); //合并数组
        console.log(arrayId);
        //提取消息，合并到同一对话中
        for (var item in jmessageList) {
            for (var id in arrayId) {
                if (arrayId[id]) {
                    if (jmessageList[item].from.username == arrayId[id].userName) {
                        arrayId[id].list.push(this.getChatMessageByJM(jmessageList[item]));
                    }
                }
            }
        }
        console.log("messageArray");
        console.log(arrayId);
        for (var id in arrayId) {
            this.getDialogIdByJmUserId(arrayId[id].userName).then(function (dlid) { return __awaiter(_this, void 0, void 0, function () {
                var _a, _b, _i, item, chat;
                return __generator(this, function (_c) {
                    switch (_c.label) {
                        case 0:
                            arrayId[id].id = dlid;
                            _a = [];
                            for (_b in arrayId[id].list)
                                _a.push(_b);
                            _i = 0;
                            _c.label = 1;
                        case 1:
                            if (!(_i < _a.length)) return [3 /*break*/, 4];
                            item = _a[_i];
                            chat = new __WEBPACK_IMPORTED_MODULE_12__entity_Dialog__["a" /* Dialog */]();
                            chat.dialog_id = arrayId[id].id;
                            chat.content = JSON.stringify(arrayId[id].list[item]);
                            return [4 /*yield*/, this.dialogDB.insert(chat)];
                        case 2:
                            _c.sent();
                            _c.label = 3;
                        case 3:
                            _i++;
                            return [3 /*break*/, 1];
                        case 4: return [2 /*return*/];
                    }
                });
            }); });
        }
    };
    /**
     * 根据极光user id 获取对话dlid
     * @param jm_user_name
     */
    ChatUtils.prototype.getDialogIdByJmUserId = function (jm_user_name) {
        var _this = this;
        var isExist = false;
        return new Promise(function (resolve) { return __awaiter(_this, void 0, void 0, function () {
            var chat_list, list, i, i;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.dialogListDB.find()];
                    case 1:
                        chat_list = _a.sent();
                        list = new Array();
                        for (i = 0; i < chat_list.length; i++) {
                            list.push(JSON.parse(chat_list[i].content));
                        }
                        if (list) {
                            isExist = true;
                        }
                        if (isExist) {
                            for (i = 0; i < list.length; i++) {
                                if (list[i].dialogue_jmusername == jm_user_name) {
                                    resolve(list[i].dlid);
                                }
                            }
                        }
                        else {
                            this.api.getChatDialogue(jm_user_name)
                                .subscribe(function (res) {
                                console.log(res);
                                resolve(res.dlid);
                            }, function (err) {
                                console.log(err.msg);
                            });
                        }
                        return [2 /*return*/];
                }
            });
        }); });
    };
    /**
     * 根据极光信息，格式化为本地信息
     * @param jmessage
     */
    ChatUtils.prototype.getChatMessageByJM = function (jmessage) {
        var messageType;
        var messageContent;
        //console.log("getChatMessageByJM");
        //console.log(jmessage.extras);
        if (jmessage.extras && jmessage.extras.type) {
            messageType = jmessage.extras.type;
            messageContent = jmessage.extras.content;
        }
        else {
            messageType = "text";
            messageContent = jmessage.text;
        }
        var chatMessage = new __WEBPACK_IMPORTED_MODULE_2__model_ChatMessage__["a" /* ChatMessage */]();
        chatMessage.type = messageType;
        chatMessage.content = messageContent;
        chatMessage.toUserName = jmessage.from.username;
        if (jmessage.from.username == __WEBPACK_IMPORTED_MODULE_6__Config__["a" /* Config */].getInstance().jm_login_user) {
            chatMessage.direct = "to";
        }
        else {
            chatMessage.direct = "from";
        }
        chatMessage.dateTime = __WEBPACK_IMPORTED_MODULE_10__provider_utils_DateUtils__["a" /* DateUtils */].dateFormat(new Date(jmessage.createTime), 'yyyy-MM-ddTHH:mm:ss+08:00');
        return chatMessage;
    };
    ChatUtils.prototype.getMessageByXiaoMi = function (message) {
        var chatMessage = new __WEBPACK_IMPORTED_MODULE_2__model_ChatMessage__["a" /* ChatMessage */]();
        return chatMessage;
    };
    /**
     * 更新消息内容列表
     * @param dlid
     * @param chatMessage
     */
    ChatUtils.prototype.updateChatList = function (dlid, chatMessage) {
        return __awaiter(this, void 0, void 0, function () {
            var chat, _a, list, count, i;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        chat = new __WEBPACK_IMPORTED_MODULE_12__entity_Dialog__["a" /* Dialog */]();
                        chat.dialog_id = dlid;
                        chat.content = JSON.stringify(chatMessage);
                        return [4 /*yield*/, this.dialogDB.insert(chat)];
                    case 1:
                        _b.sent();
                        return [4 /*yield*/, this.dialogDB.findAndCount({ dialog_id: dlid })];
                    case 2:
                        _a = _b.sent(), list = _a[0], count = _a[1];
                        if (!(count > 10)) return [3 /*break*/, 6];
                        i = 0;
                        _b.label = 3;
                    case 3:
                        if (!(i < count - 10)) return [3 /*break*/, 6];
                        return [4 /*yield*/, this.dialogDB.remove(list[i])];
                    case 4:
                        _b.sent();
                        _b.label = 5;
                    case 5:
                        i++;
                        return [3 /*break*/, 3];
                    case 6:
                        //ChatDetailsPage中接收处理消息
                        this.events.publish("jmessage:update", dlid);
                        return [2 /*return*/];
                }
            });
        });
    };
    /**
     * 处理消息通知栏点击
     */
    ChatUtils.prototype.getNotificationParams = function (msg) {
        var _this = this;
        var isExist = false;
        var return_params = {
            "chatId": "",
            "toUser": "",
            "toJmUserId": "",
            "toUserId": "",
            "positionId": "",
            "dialogueType": "" //判断是否为学校公众号
        };
        return new Promise(function (resolve) { return __awaiter(_this, void 0, void 0, function () {
            var chat_list, list, i, i;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.dialogListDB.find()];
                    case 1:
                        chat_list = _a.sent();
                        if (chat_list) {
                            isExist = true;
                        }
                        if (isExist) {
                            list = new Array();
                            for (i = 0; i < chat_list.length; i++) {
                                list.push(JSON.parse(chat_list[i].content));
                            }
                            for (i = 0; i < list.length; i++) {
                                if (list[i].dialogue_jmusername == msg.from.username) {
                                    return_params.chatId = list[i].dlid;
                                    return_params.toUser = list[i].dialogue_user;
                                    return_params.toJmUserId = msg.from.username;
                                    return_params.toUserId = list[i].dialogue_accountid;
                                    return_params.positionId = list[i].positionid;
                                    return_params.dialogueType = list[i].dialogue_account_type;
                                    resolve(return_params);
                                }
                            }
                        }
                        else {
                            this.api.getChatDialogue(msg.from.username)
                                .subscribe(function (res) {
                                console.log(res);
                                return_params.chatId = res.dlid;
                                return_params.toUser = res.dialogue_user;
                                return_params.toJmUserId = res.dialogue_jmusername;
                                return_params.toUserId = res.dialogue_accountid;
                                return_params.positionId = res.positionid;
                                return_params.dialogueType = res.dialogue_account_type;
                                resolve(return_params);
                            }, function (err) {
                                console.log(err.msg);
                            });
                        }
                        return [2 /*return*/];
                }
            });
        }); });
    };
    /*
    clearNotification(id : any){
        console.log("clearNotification");
        this.localNotifications.isPresent(id).then((isPresent)=>{
            console.log(isPresent);
            this.localNotifications.clear(id).then((result) => {
                console.log("clearNotification: " + result);
            });
            this.localNotifications.cancel(id);
        })
    }*/
    /**
     * 清除所有通知栏消息
     
    clearAllNotification(){
        this.localNotifications.clearAll();
        this.localNotifications.cancelAll();
    }*/
    /**
     * 发送消息
     * @param id 对话列表 dlid
     * @param params ChatMessage
     */
    ChatUtils.prototype.messageSendUpdate = function (toUser, params) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            var chat, message;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!!this.config.isWeb) return [3 /*break*/, 7];
                        if (!toUser) return [3 /*break*/, 5];
                        return [4 /*yield*/, this.dialogListDB.findOne({ dialog_user: toUser })];
                    case 1:
                        chat = _a.sent();
                        console.log("dialogListDB.findOne");
                        console.log(chat);
                        if (!chat) return [3 /*break*/, 3];
                        message = JSON.parse(chat.content);
                        message.last_message_type = params.type;
                        message.last_message = this.formatMessageContent(params.type, params.content);
                        message.last_message_time = params.dateTime;
                        chat.content = JSON.stringify(message);
                        return [4 /*yield*/, this.dialogListDB.save(chat)];
                    case 2:
                        _a.sent();
                        return [3 /*break*/, 4];
                    case 3:
                        this.api.getChatDialogue(params.toUserName)
                            .subscribe(function (res) { return __awaiter(_this, void 0, void 0, function () {
                            var new_chat;
                            return __generator(this, function (_a) {
                                switch (_a.label) {
                                    case 0:
                                        console.log(res);
                                        res.last_message = this.formatMessageContent(res.last_message_type, res.last_message);
                                        new_chat = new __WEBPACK_IMPORTED_MODULE_0__entity_DialogList__["a" /* DialogList */]();
                                        new_chat.dialog_user = params.toUserName;
                                        new_chat.content = JSON.stringify(res);
                                        new_chat.datetime = res.last_message_time;
                                        return [4 /*yield*/, this.dialogListDB.insert(new_chat)];
                                    case 1:
                                        _a.sent();
                                        return [2 /*return*/];
                                }
                            });
                        }); }, function (err) {
                            console.log(err.msg);
                        });
                        _a.label = 4;
                    case 4: return [3 /*break*/, 6];
                    case 5:
                        this.api.getChatDialogue(params.toUserName)
                            .subscribe(function (res) { return __awaiter(_this, void 0, void 0, function () {
                            var new_chat;
                            return __generator(this, function (_a) {
                                switch (_a.label) {
                                    case 0:
                                        console.log(res);
                                        res.last_message = this.formatMessageContent(res.last_message_type, res.last_message);
                                        new_chat = new __WEBPACK_IMPORTED_MODULE_0__entity_DialogList__["a" /* DialogList */]();
                                        new_chat.dialog_user = params.toUserName;
                                        new_chat.content = JSON.stringify(res);
                                        new_chat.datetime = res.last_message_time;
                                        return [4 /*yield*/, this.dialogListDB.insert(new_chat)];
                                    case 1:
                                        _a.sent();
                                        return [2 /*return*/];
                                }
                            });
                        }); }, function (err) {
                            console.log(err.msg);
                        });
                        _a.label = 6;
                    case 6:
                        //更新对话列表，重新排序
                        this.updateDialogList();
                        return [3 /*break*/, 8];
                    case 7:
                        this.local.get(__WEBPACK_IMPORTED_MODULE_7__Constants__["a" /* Constants */].LocalStorage.DialogList).then(function (dialogList) {
                            if (dialogList) {
                                var is_exist = false;
                                for (var i = 0; i < dialogList.length; i++) {
                                    if (dialogList[i].dialogue_jmusername == toUser) {
                                        dialogList[i].last_message_type = params.type;
                                        dialogList[i].last_message = _this.formatMessageContent(params.type, params.content);
                                        dialogList[i].last_message_time = params.dateTime;
                                        is_exist = true;
                                        break;
                                    }
                                }
                                if (is_exist) {
                                    _this.config.dialogList = _this.transform(dialogList, "last_message_time", true);
                                    _this.local.set(__WEBPACK_IMPORTED_MODULE_7__Constants__["a" /* Constants */].LocalStorage.DialogList, _this.config.dialogList);
                                    console.log("对话列表");
                                    console.log(_this.config.dialogList);
                                    //对话列表已存在，但对话不存在
                                }
                                else {
                                    _this.api.getChatDialogue(params.toUserName)
                                        .subscribe(function (res) {
                                        console.log(res);
                                        res.last_message = _this.formatMessageContent(res.last_message_type, res.last_message);
                                        dialogList.push(res);
                                        _this.local.set(__WEBPACK_IMPORTED_MODULE_7__Constants__["a" /* Constants */].LocalStorage.DialogList, dialogList);
                                        _this.config.dialogList = _this.transform(dialogList, "last_message_time", true);
                                    }, function (err) {
                                        console.log(err.msg);
                                    });
                                }
                                //对话列表不存在
                            }
                            else {
                                _this.api.getChatDialogue(params.toUserName)
                                    .subscribe(function (res) {
                                    console.log(res);
                                    var list = new Array();
                                    res.last_message = _this.formatMessageContent(res.last_message_type, res.last_message);
                                    list.push(res);
                                    _this.local.set(__WEBPACK_IMPORTED_MODULE_7__Constants__["a" /* Constants */].LocalStorage.DialogList, list);
                                    _this.config.dialogList = _this.transform(list, "last_message_time", true);
                                }, function (err) {
                                    console.log(err.msg);
                                });
                            }
                        });
                        _a.label = 8;
                    case 8: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * 更新对话列表
    */
    ChatUtils.prototype.updateDialogList = function () {
        return __awaiter(this, void 0, void 0, function () {
            var list, dialog_list, i;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.dialogListDB.find()];
                    case 1:
                        list = _a.sent();
                        dialog_list = new Array();
                        for (i = 0; i < list.length; i++) {
                            dialog_list.push(JSON.parse(list[i].content));
                        }
                        console.log("updateDialogList");
                        console.log(dialog_list);
                        this.config.dialogList = this.transform(dialog_list, "last_message_time", true);
                        return [2 /*return*/];
                }
            });
        });
    };
    /**
     * 消息内容格式化
     * 对话列表最后一条信息和通知栏显示信息
     * @param type
     * @param content
     */
    ChatUtils.prototype.formatMessageContent = function (type, content) {
        var message = "";
        switch (type) {
            case __WEBPACK_IMPORTED_MODULE_2__model_ChatMessage__["a" /* ChatMessage */].TEXT:
                message = content;
                break;
            case __WEBPACK_IMPORTED_MODULE_2__model_ChatMessage__["a" /* ChatMessage */].POSITION:
                message = "[职位信息]";
                break;
            case __WEBPACK_IMPORTED_MODULE_2__model_ChatMessage__["a" /* ChatMessage */].TALENT:
                message = "[职位信息]";
                break;
            case __WEBPACK_IMPORTED_MODULE_2__model_ChatMessage__["a" /* ChatMessage */].RESUME:
                message = "[简历信息]";
                break;
            case __WEBPACK_IMPORTED_MODULE_2__model_ChatMessage__["a" /* ChatMessage */].WECHAT:
                message = "[微信号]";
                break;
            case __WEBPACK_IMPORTED_MODULE_2__model_ChatMessage__["a" /* ChatMessage */].IMAGE:
                message = "[图片]";
                break;
            case __WEBPACK_IMPORTED_MODULE_2__model_ChatMessage__["a" /* ChatMessage */].INVITATION:
                message = "[面试邀请]";
                break;
            case __WEBPACK_IMPORTED_MODULE_2__model_ChatMessage__["a" /* ChatMessage */].REPLY:
                message = "[面试回复]";
                break;
            case __WEBPACK_IMPORTED_MODULE_2__model_ChatMessage__["a" /* ChatMessage */].OFFER:
                message = "[录用消息]";
                break;
            case __WEBPACK_IMPORTED_MODULE_2__model_ChatMessage__["a" /* ChatMessage */].OFFER_REPLY:
                message = "[录用回复]";
                break;
            case __WEBPACK_IMPORTED_MODULE_2__model_ChatMessage__["a" /* ChatMessage */].SHIELD:
                message = "[对话屏蔽]";
                break;
            case __WEBPACK_IMPORTED_MODULE_2__model_ChatMessage__["a" /* ChatMessage */].MILKROUND:
                message = "[双选会]";
                break;
            case __WEBPACK_IMPORTED_MODULE_2__model_ChatMessage__["a" /* ChatMessage */].CAMPUSTALK:
                message = "[宣讲会]";
                break;
            case __WEBPACK_IMPORTED_MODULE_2__model_ChatMessage__["a" /* ChatMessage */].MULTITEXT:
                //message = "[通知]";
                var _msg = JSON.parse(content);
                message = _msg.content;
                break;
            default:
                message = "[消息]";
                break;
        }
        return message;
    };
    /**
     * 屏蔽对话
     * @param dlid
     * @param is_shield
     * @isActive 主动屏蔽 被屏蔽
     */
    ChatUtils.prototype.updateDialogueShield = function (toUser, is_shield, isActive) {
        if (isActive === void 0) { isActive = true; }
        return __awaiter(this, void 0, void 0, function () {
            var chat, message;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!!this.config.isWeb) return [3 /*break*/, 3];
                        return [4 /*yield*/, this.dialogListDB.findOne({ dialog_user: toUser })];
                    case 1:
                        chat = _a.sent();
                        console.log("updateDialogueShield");
                        console.log(toUser);
                        console.log(is_shield);
                        message = JSON.parse(chat.content);
                        if (isActive) {
                            message.is_active_shield = is_shield;
                        }
                        else {
                            message.is_shielded = is_shield;
                        }
                        message.last_message_type = __WEBPACK_IMPORTED_MODULE_2__model_ChatMessage__["a" /* ChatMessage */].SHIELD;
                        message.last_message = this.formatMessageContent(__WEBPACK_IMPORTED_MODULE_2__model_ChatMessage__["a" /* ChatMessage */].SHIELD, "");
                        message.last_message_time = __WEBPACK_IMPORTED_MODULE_10__provider_utils_DateUtils__["a" /* DateUtils */].dateFormat(new Date(), 'yyyy-MM-ddTHH:mm:ss+08:00');
                        chat.content = JSON.stringify(message);
                        console.log(chat.content);
                        return [4 /*yield*/, this.dialogListDB.save(chat)];
                    case 2:
                        _a.sent();
                        this.updateDialogList();
                        return [3 /*break*/, 3];
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * 进入对话时，更新对话列表中的未读数
     * @param id
     */
    ChatUtils.prototype.updateRead = function (toUserName) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            var chat_list, content, i;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!!this.config.isWeb) return [3 /*break*/, 4];
                        return [4 /*yield*/, this.dialogListDB.findOne({ dialog_user: toUserName })];
                    case 1:
                        chat_list = _a.sent();
                        console.log("updateRead");
                        console.log(chat_list);
                        if (!chat_list) return [3 /*break*/, 3];
                        content = JSON.parse(chat_list.content);
                        if (this.config.unReadTotal > 0) {
                            this.config.unReadTotal -= content.unread_count;
                        }
                        else {
                            this.config.unReadTotal = 0;
                        }
                        content.unread_count = 0;
                        chat_list.content = JSON.stringify(content);
                        return [4 /*yield*/, this.dialogListDB.save(chat_list)];
                    case 2:
                        _a.sent();
                        _a.label = 3;
                    case 3:
                        if (this.config.dialogList) {
                            for (i = 0; i < this.config.dialogList.length; i++) {
                                if (this.config.dialogList[i].dialog_user == toUserName) {
                                    this.config.dialogList[i].unread_count = 0;
                                    break;
                                }
                            }
                        }
                        return [3 /*break*/, 5];
                    case 4:
                        this.local.get(__WEBPACK_IMPORTED_MODULE_7__Constants__["a" /* Constants */].LocalStorage.DialogList).then(function (list) {
                            if (list) {
                                for (var i = 0; i < list.length; i++) {
                                    if (list[i].dialogue_jmusername == toUserName) {
                                        if (_this.config.unReadTotal > 0) {
                                            _this.config.unReadTotal -= list[i].unread_count;
                                        }
                                        else {
                                            _this.config.unReadTotal = 0;
                                        }
                                        list[i].unread_count = 0;
                                        break;
                                    }
                                }
                                console.log("updateRead");
                                console.log(_this.config.unReadTotal);
                                _this.local.set(__WEBPACK_IMPORTED_MODULE_7__Constants__["a" /* Constants */].LocalStorage.DialogList, list);
                                if (_this.config.dialogList) {
                                    for (var i = 0; i < _this.config.dialogList.length; i++) {
                                        if (_this.config.dialogList[i].dlid == toUserName) {
                                            _this.config.dialogList[i].unread_count = 0;
                                            break;
                                        }
                                    }
                                }
                                else {
                                    _this.config.dialogList = list;
                                }
                            }
                        });
                        _a.label = 5;
                    case 5: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * 置顶
     * @param id
     * @param is_top
     */
    ChatUtils.prototype.setTopChat = function (toUser, is_top) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            var chat, content, dialog, i;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!!this.config.isWeb) return [3 /*break*/, 3];
                        return [4 /*yield*/, this.dialogListDB.findOne({ dialog_user: toUser })];
                    case 1:
                        chat = _a.sent();
                        content = JSON.parse(chat.content);
                        content.is_top = is_top;
                        dialog = new __WEBPACK_IMPORTED_MODULE_0__entity_DialogList__["a" /* DialogList */]();
                        dialog.dialog_user = toUser;
                        dialog.content = JSON.stringify(content);
                        return [4 /*yield*/, this.dialogListDB.save(dialog)];
                    case 2:
                        _a.sent();
                        return [3 /*break*/, 4];
                    case 3:
                        this.local.get(__WEBPACK_IMPORTED_MODULE_7__Constants__["a" /* Constants */].LocalStorage.DialogList).then(function (list) {
                            for (var i = 0; i < list.length; i++) {
                                if (list[i].dialogue_jmusername == toUser) {
                                    list[i].is_top = is_top;
                                    break;
                                }
                            }
                            _this.local.set(__WEBPACK_IMPORTED_MODULE_7__Constants__["a" /* Constants */].LocalStorage.DialogList, list);
                        });
                        _a.label = 4;
                    case 4:
                        for (i = 0; i < __WEBPACK_IMPORTED_MODULE_6__Config__["a" /* Config */].getInstance().dialogList.length; i++) {
                            if (__WEBPACK_IMPORTED_MODULE_6__Config__["a" /* Config */].getInstance().dialogList[i].dialog_user == toUser) {
                                __WEBPACK_IMPORTED_MODULE_6__Config__["a" /* Config */].getInstance().dialogList[i].is_top = is_top;
                                break;
                            }
                        }
                        return [2 /*return*/];
                }
            });
        });
    };
    /**
     * 对话列表排序 按最新对话时间
     * @param value
     * @param field
     * @param desc
     */
    ChatUtils.prototype.transform = function (value, field, desc) {
        var _this = this;
        if (desc === void 0) { desc = true; }
        if (field === null || field === '')
            return value;
        if (!desc)
            desc = false;
        var descNumber = desc ? 1 : -1;
        if (value instanceof Array) {
            return value.sort(function (l, r) {
                if (_this.isDate(l[field]) < _this.isDate(r[field]))
                    return (1 * descNumber);
                if (_this.isDate(l[field]) > _this.isDate(r[field]))
                    return (-1 * descNumber);
                return 0;
            });
        }
        return 0;
    };
    ChatUtils.prototype.isDate = function (field) {
        if (isNaN(Date.parse(field))) {
            return field;
        }
        return Date.parse(field);
    };
    ChatUtils = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_9__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_8__StorageUtils__["a" /* StorageUtils */],
            __WEBPACK_IMPORTED_MODULE_4__Api__["a" /* Api */],
            __WEBPACK_IMPORTED_MODULE_5_ionic_angular__["Events"],
            __WEBPACK_IMPORTED_MODULE_3__UiUtils__["a" /* UiUtils */]])
    ], ChatUtils);
    return ChatUtils;
}());

//# sourceMappingURL=ChatUtils.js.map

/***/ }),

/***/ 249:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return Validators; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_forms__ = __webpack_require__(28);
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};


var Validators = /** @class */ (function (_super) {
    __extends(Validators, _super);
    function Validators() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Validators_1 = Validators;
    Validators.isEmpty = function (value) {
        return value == null || typeof value === 'string' && value.length === 0;
    };
    Validators.isNotEmpty = function (value) {
        return !Validators_1.isEmpty(value);
    };
    /*E-mail*/
    Validators.isEmail = function (vaule) {
        var Expression = /^([a-zA-Z0-9_-])+@([a-zA-Z0-9_-])+((.[a-zA-Z0-9_-]{2,3}){1,2})$/;
        var objExp = new RegExp(Expression);
        if (objExp.test(vaule) == true) {
            return true;
        }
        else {
            return false;
        }
    };
    /**
     * 判断URL地址
     * @param url
     */
    Validators.checkURL = function (url) {
        //let Expression = /http(s)?:\/\/([\w-]+\.)+[\w-]+(\/[\w- .\/?%&=]*)?/;
        var Expression = "^((https|http|ftp|rtsp|mms)?://)"
            + "?(([0-9a-z_!~*'().&=+$%-]+: )?[0-9a-z_!~*'().&=+$%-]+@)?" //ftp的user@ 
            + "(([0-9]{1,3}\.){3}[0-9]{1,3}" // IP形式的URL- 199.194.52.184 
            + "|" // 允许IP和DOMAIN（域名）
            + "([0-9a-z_!~*'()-]+\.)*" // 域名- www. 
            + "([0-9a-z][0-9a-z-]{0,61})?[0-9a-z]\." // 二级域名 
            + "[a-z]{2,6})" // first level domain- .com or .museum 
            + "(:[0-9]{1,4})?" // 端口- :80 
            + "((/?)|" // a slash isn't required if there is no file name 
            + "(/[0-9a-z_!~*'().;?:@&=+$,%#-]+)+/?)$";
        var objExp = new RegExp(Expression);
        if (objExp.test(url) == true) {
            return true;
        }
        else {
            return false;
        }
    };
    Validators.isMobilePhone = function (phone) {
        var Expression = /^1[3|4|5|7|6|8][0-9]{9}$/;
        var objExp = new RegExp(Expression);
        if (objExp.test(phone) == true) {
            return true;
        }
        else {
            return false;
        }
    };
    Validators.isPassword = function (pwd) {
        var Expression = /^(?![0-9]+$)(?![a-zA-Z]+$)[0-9A-Za-z]{6,12}$/; //不为纯数字或字母
        var objExp = new RegExp(Expression);
        if (objExp.test(pwd) == true) {
            return true;
        }
        else {
            return false;
        }
    };
    /*手机号码*/
    Validators.phone = function (control) {
        return Validators_1.validatorsByPattern('phone', control, '1[0-9]{10,10}');
    };
    /*中文*/
    Validators.chinese = function (control) {
        return Validators_1.validatorsByPattern('chinese', control, '[(\u4e00-\u9fa5)]+');
    };
    /*英文、数字包括下划线*/
    Validators.legallyNamed = function (control) {
        return Validators_1.validatorsByPattern('legallyNamed', control, '[A-Za-z0-9_]+');
    };
    Validators.validatorsByPattern = function (name, control, pattern) {
        var validatorFn = Validators_1.pattern(pattern)(control);
        if (validatorFn != null) {
            validatorFn[name] = validatorFn['pattern'];
        }
        return validatorFn;
    };
    Validators = Validators_1 = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])()
    ], Validators);
    return Validators;
    var Validators_1;
}(__WEBPACK_IMPORTED_MODULE_1__angular_forms__["Validators"]));

//# sourceMappingURL=Validators.js.map

/***/ }),

/***/ 250:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return ChatMessage; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "b", function() { return JmMessage; });
/* unused harmony export TalentMessage */
/**
 * 消息
 */
var ChatMessage = /** @class */ (function () {
    function ChatMessage() {
    }
    ChatMessage.TEXT = "text";
    ChatMessage.POSITION = "position"; //职位
    ChatMessage.TALENT = "talent";
    ChatMessage.RESUME = "resume"; //我的简历
    ChatMessage.IMAGE = "image"; //图片
    ChatMessage.INVITATION = "invitation"; //邀请
    ChatMessage.REPLY = "reply"; //邀请回复
    ChatMessage.WECHAT = "wechat"; //微信号
    ChatMessage.SHIELD = "shield"; //屏蔽
    ChatMessage.OFFER = "offer"; //录用
    ChatMessage.OFFER_REPLY = "offer_reply"; //录用回复
    ChatMessage.INAPPROPRIATE = "inappropriate"; //被企业标记为不合适
    ChatMessage.MILKROUND = "milkround"; //招聘会
    ChatMessage.CAMPUSTALK = "campustalk"; //宣讲会
    ChatMessage.MULTITEXT = "multitext"; //通知 富文本
    ChatMessage.ASKFORRESUME = "ask_for_resume"; //企业索要简历
    return ChatMessage;
}());

var JmMessage = /** @class */ (function () {
    function JmMessage() {
    }
    return JmMessage;
}());

/**
 * 人才信息
 */
var TalentMessage = /** @class */ (function () {
    function TalentMessage() {
    }
    return TalentMessage;
}());

//# sourceMappingURL=ChatMessage.js.map

/***/ }),

/***/ 251:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return DialogList; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_typeorm__ = __webpack_require__(6);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};

/**
 * 消息列表表
 */
var DialogList = /** @class */ (function () {
    function DialogList() {
    }
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0_typeorm__["f" /* PrimaryColumn */])(),
        __metadata("design:type", String)
    ], DialogList.prototype, "dialog_user", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0_typeorm__["a" /* Column */])({ "nullable": true }),
        __metadata("design:type", String)
    ], DialogList.prototype, "content", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0_typeorm__["k" /* UpdateDateColumn */])(),
        __metadata("design:type", Object)
    ], DialogList.prototype, "datetime", void 0);
    DialogList = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0_typeorm__["b" /* Entity */])('dialog_list')
    ], DialogList);
    return DialogList;
}());

//# sourceMappingURL=DialogList.js.map

/***/ }),

/***/ 252:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return Dialog; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_typeorm__ = __webpack_require__(6);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};

/**
 * 消息内容表
 */
var Dialog = /** @class */ (function () {
    function Dialog() {
    }
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0_typeorm__["g" /* PrimaryGeneratedColumn */])(),
        __metadata("design:type", Number)
    ], Dialog.prototype, "id", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0_typeorm__["a" /* Column */])(),
        Object(__WEBPACK_IMPORTED_MODULE_0_typeorm__["d" /* Index */])(),
        __metadata("design:type", String)
    ], Dialog.prototype, "dialog_id", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0_typeorm__["a" /* Column */])({ "nullable": true }),
        __metadata("design:type", String)
    ], Dialog.prototype, "content", void 0);
    Dialog = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0_typeorm__["b" /* Entity */])('dialog')
    ], Dialog);
    return Dialog;
}());

//# sourceMappingURL=Dialog.js.map

/***/ }),

/***/ 265:
/***/ (function(module, exports) {

function webpackEmptyAsyncContext(req) {
	// Here Promise.resolve().then() is used instead of new Promise() to prevent
	// uncatched exception popping up in devtools
	return Promise.resolve().then(function() {
		throw new Error("Cannot find module '" + req + "'.");
	});
}
webpackEmptyAsyncContext.keys = function() { return []; };
webpackEmptyAsyncContext.resolve = webpackEmptyAsyncContext;
module.exports = webpackEmptyAsyncContext;
webpackEmptyAsyncContext.id = 265;

/***/ }),

/***/ 266:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return HttpService; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__utils_UiUtils__ = __webpack_require__(76);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__utils_EncryptUtils__ = __webpack_require__(648);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__utils_DateUtils__ = __webpack_require__(155);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__Constants__ = __webpack_require__(67);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__Config__ = __webpack_require__(48);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__utils_AppUtils__ = __webpack_require__(123);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__angular_http__ = __webpack_require__(649);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8_rxjs_add_operator_toPromise__ = __webpack_require__(394);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8_rxjs_add_operator_toPromise___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_8_rxjs_add_operator_toPromise__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9_rxjs__ = __webpack_require__(157);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9_rxjs___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_9_rxjs__);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};










var HttpService = /** @class */ (function () {
    function HttpService(http, appUtils, uiUtils, encrypt) {
        this.http = http;
        this.appUtils = appUtils;
        this.uiUtils = uiUtils;
        this.encrypt = encrypt;
        this.headers = new __WEBPACK_IMPORTED_MODULE_7__angular_http__["a" /* Headers */]();
        this.httpTimeOut = 8000; //http timeout设置
        this.config = __WEBPACK_IMPORTED_MODULE_4__Config__["a" /* Config */].getInstance(); //实例化config
    }
    HttpService_1 = HttpService;
    HttpService.prototype.setHeaders = function (_header) {
        this.headers = _header;
    };
    HttpService.prototype.getHeaders = function () {
        return this.headers;
    };
    HttpService.prototype.request = function (api_url, is_agent, options) {
        var _this = this;
        if (is_agent === void 0) { is_agent = false; }
        var url = this.replaceUrl(api_url, is_agent);
        if (options.headers == undefined) {
            options.headers = new __WEBPACK_IMPORTED_MODULE_7__angular_http__["a" /* Headers */]();
        }
        if (is_agent) {
            options.headers.append(__WEBPACK_IMPORTED_MODULE_3__Constants__["a" /* Constants */].Header.ClientId, this.encrypt.encrypt(__WEBPACK_IMPORTED_MODULE_3__Constants__["a" /* Constants */].ClientId));
        }
        else {
            options.headers.append(__WEBPACK_IMPORTED_MODULE_3__Constants__["a" /* Constants */].Header.ClientId, __WEBPACK_IMPORTED_MODULE_3__Constants__["a" /* Constants */].ClientId);
            //options.headers.append(Constants.Header.ClientSecret,Constants.ClientSecret);
            options.headers.append(__WEBPACK_IMPORTED_MODULE_3__Constants__["a" /* Constants */].Header.AccessToken, this.config.token);
            options.headers.append(__WEBPACK_IMPORTED_MODULE_3__Constants__["a" /* Constants */].Header.AccountId, this.config.account_id);
        }
        var observable = __WEBPACK_IMPORTED_MODULE_9_rxjs__["Observable"].create(function (observer) {
            console.log('%c 请求前 %c', 'color:blue', '', 'url=>', url, 'options=>', options);
            _this.http.request(url, options)
                .subscribe(function (res) {
                console.log('%c 请求成功 %c', 'color:green', '', 'url=>', url, 'options=>', options, 'res=>', res);
                observer.next(res);
                observer.complete();
            }, function (err) {
                console.log('%c 请求失败 %c', 'color:red', '', 'url=>', url, 'options=>', options, 'err=>', err);
                //observer.error(err);
                if (0 === err.status) {
                    _this.uiUtils.showToast("无法连接网络,请检查网络设置", "bottom");
                    /*this.uiUtils.confirmDialog('网络错误','连接服务器失败！请稍后重试','退出','重试').then(()=>{
                        this.platform.exitApp();
                    },()=>{
                        //this.navCtrl.setRoot(this.navCtrl.getActive().component);
                    });
                    
                    this.uiUtils.confirmDialogOneBtn('网络错误','连接服务器失败！请稍后重试').then(()=>{
                        this.platform.exitApp();
                    });*/
                    observer.error(err);
                }
                else {
                    var errorMsg = _this.requestFailed(url, options, err); //处理请求失败
                    observer.error(errorMsg);
                }
            });
        });
        observable = observable.map(function (res) {
            try {
                return res.json();
            }
            catch (e) {
                return "{}";
            }
        });
        /*.retryWhen(e => e.scan<number>((errorCount, err) => {
            console.log(err);
            if (errorCount >= 2) {
                throw err;
            }
            return errorCount + 1;
        }, 0).delay(1000 * 3));
        .retryWhen(attempt => {
            return attempt.flatMap(res => {
                console.log("retryWhen res");
                console.log(res);
              // if it's the first round and an authentication error try to refresh token
                if (500 === res.status || 0 === res.status) {
                    return this.uiUtils.confirmDialogOneBtn('错误','服务器错误！请稍后重试').then(()=>{
                                this.platform.exitApp();
                            });
                }else if(403 === res.status || 401 === res.status){
                   this.refreshToken();
                }else{
                    return Observable.throw(res);
                }
                
            })
        }).delay(1000 * 3);*/
        return observable;
    };
    /**
     *  var params = new URLSearchParams();
     *  params.set(‘search‘, term); // the user‘s search value
     *  params.set(‘action‘, ‘opensearch‘);
     *  params.set(‘format‘, ‘json‘);
     *
     */
    HttpService.prototype.get = function (url, paramMap, is_agent) {
        if (paramMap === void 0) { paramMap = undefined; }
        if (is_agent === void 0) { is_agent = false; }
        return this.request(url, is_agent, new __WEBPACK_IMPORTED_MODULE_7__angular_http__["e" /* RequestOptions */]({
            method: __WEBPACK_IMPORTED_MODULE_7__angular_http__["d" /* RequestMethod */].Get,
            search: HttpService_1.buildURLSearchParams(paramMap)
        }));
    };
    // 默认Content-Type为application/json;
    //let body = JSON.stringify({product}); 
    HttpService.prototype.post = function (url, body, is_agent) {
        if (body === void 0) { body = undefined; }
        if (is_agent === void 0) { is_agent = false; }
        return this.request(url, is_agent, new __WEBPACK_IMPORTED_MODULE_7__angular_http__["e" /* RequestOptions */]({
            method: __WEBPACK_IMPORTED_MODULE_7__angular_http__["d" /* RequestMethod */].Post,
            body: body,
            headers: new __WEBPACK_IMPORTED_MODULE_7__angular_http__["a" /* Headers */]({
                'Content-Type': 'application/json; charset=UTF-8'
            })
        }));
    };
    HttpService.prototype.postFormData = function (url, paramMap, is_agent) {
        if (paramMap === void 0) { paramMap = null; }
        if (is_agent === void 0) { is_agent = false; }
        return this.request(url, is_agent, new __WEBPACK_IMPORTED_MODULE_7__angular_http__["e" /* RequestOptions */]({
            method: __WEBPACK_IMPORTED_MODULE_7__angular_http__["d" /* RequestMethod */].Post,
            //search: HttpService.buildURLSearchParams(paramMap).toString(),
            body: this.buildPostParams(paramMap),
            headers: new __WEBPACK_IMPORTED_MODULE_7__angular_http__["a" /* Headers */]({
                'Content-Type': 'application/x-www-form-urlencoded; charset=UTF-8'
            })
        }));
    };
    HttpService.prototype.put = function (url, body, is_agent) {
        if (body === void 0) { body = null; }
        if (is_agent === void 0) { is_agent = false; }
        return this.request(url, is_agent, new __WEBPACK_IMPORTED_MODULE_7__angular_http__["e" /* RequestOptions */]({
            method: __WEBPACK_IMPORTED_MODULE_7__angular_http__["d" /* RequestMethod */].Put,
            body: body
        }));
    };
    HttpService.prototype.delete = function (url, paramMap, is_agent) {
        if (paramMap === void 0) { paramMap = null; }
        if (is_agent === void 0) { is_agent = false; }
        return this.request(url, is_agent, new __WEBPACK_IMPORTED_MODULE_7__angular_http__["e" /* RequestOptions */]({
            method: __WEBPACK_IMPORTED_MODULE_7__angular_http__["d" /* RequestMethod */].Delete,
            search: HttpService_1.buildURLSearchParams(paramMap).toString()
        }));
    };
    HttpService.prototype.patch = function (url, body, is_agent) {
        if (body === void 0) { body = null; }
        if (is_agent === void 0) { is_agent = false; }
        return this.request(url, is_agent, new __WEBPACK_IMPORTED_MODULE_7__angular_http__["e" /* RequestOptions */]({
            method: __WEBPACK_IMPORTED_MODULE_7__angular_http__["d" /* RequestMethod */].Patch,
            body: body
        }));
    };
    HttpService.prototype.head = function (url, paramMap, is_agent) {
        if (paramMap === void 0) { paramMap = null; }
        if (is_agent === void 0) { is_agent = false; }
        return this.request(url, is_agent, new __WEBPACK_IMPORTED_MODULE_7__angular_http__["e" /* RequestOptions */]({
            method: __WEBPACK_IMPORTED_MODULE_7__angular_http__["d" /* RequestMethod */].Head,
            search: HttpService_1.buildURLSearchParams(paramMap).toString()
        }));
    };
    HttpService.prototype.options = function (url, paramMap, is_agent) {
        if (paramMap === void 0) { paramMap = null; }
        if (is_agent === void 0) { is_agent = false; }
        return this.request(url, is_agent, new __WEBPACK_IMPORTED_MODULE_7__angular_http__["e" /* RequestOptions */]({
            method: __WEBPACK_IMPORTED_MODULE_7__angular_http__["d" /* RequestMethod */].Options,
            search: HttpService_1.buildURLSearchParams(paramMap).toString()
        }));
    };
    HttpService.prototype.buildPostParams = function (params) {
        var paramsArray = [];
        Object.keys(params).forEach(function (key) {
            //console.log(params[key] instanceof Object);
            if (params[key] instanceof Array) {
                params[key].forEach(function (val) {
                    paramsArray.push(key + '[' + params[key].indexOf(val) + ']' + '=' + encodeURIComponent(val));
                });
            }
            else if (params[key] instanceof Object) {
                Object.keys(params[key]).forEach(function (keys) {
                    paramsArray.push(key + '[' + keys + ']' + '=' + encodeURIComponent(params[key][keys]));
                });
            }
            else {
                paramsArray.push(key + '=' + encodeURIComponent(params[key]));
            }
        });
        params = paramsArray.join("&");
        return params;
    };
    /**
    * 将对象转为查询参数
    * @param paramMap
    * @returns {URLSearchParams}
    */
    HttpService.buildURLSearchParams = function (paramMap) {
        var params = new __WEBPACK_IMPORTED_MODULE_7__angular_http__["f" /* URLSearchParams */]();
        if (!paramMap) {
            return params;
        }
        for (var key in paramMap) {
            var val = paramMap[key];
            if (val instanceof Date) {
                val = __WEBPACK_IMPORTED_MODULE_2__utils_DateUtils__["a" /* DateUtils */].dateFormat(val, 'yyyy-MM-dd hh:mm:ss');
            }
            params.set(key, val);
        }
        return params;
    };
    /**
     * 处理请求失败事件
     * @param url
     * @param options
     * @param err
     */
    HttpService.prototype.requestFailed = function (url, options, err) {
        //console.log('%c 请求失败 %c', 'color:red', '', 'url', url, 'options', options, 'err', err);
        var errorJson = {
            "code": 0,
            "msg": '',
            "error": err
        };
        var status = err.status;
        /*
        if (err instanceof TimeoutError) {
            return;
        }*/
        if (!this.appUtils.isConnecting()) {
            errorJson.code = -1;
            errorJson.msg = '没有网络连接，请检查网络设置';
            this.uiUtils.alertDialog("错误", errorJson.msg);
        }
        else {
            errorJson.code = status;
            if (status === 0) {
                errorJson.msg = '请求失败，请求响应出错，请稍后再试';
            }
            else if (status === 404) {
                errorJson.msg = '请求失败，未找到请求地址，请稍后再试';
            }
            else if (status === 500) {
                errorJson.msg = '请求失败，服务器出错，请稍后再试';
            }
            else {
                errorJson.code = err.Errcode;
                errorJson.msg = err.Errmsg;
            }
        }
        //this.uiUtils.alertDialog("错误",errorJson.msg);
        return errorJson;
    };
    /**
     * url中如果有双斜杠替换为单斜杠
     * 如:http://88.128.18.144:8080//api//demo.替换后http://88.128.18.144:8080/api/demo
     * @param url
     * @returns {string}
     */
    HttpService.prototype.replaceUrl = function (url, is_agent) {
        if (is_agent === void 0) { is_agent = false; }
        //if (url.indexOf('http://') == -1) {
        if (is_agent) {
            url = __WEBPACK_IMPORTED_MODULE_3__Constants__["a" /* Constants */].AgentApiUrl + url;
        }
        else {
            url = __WEBPACK_IMPORTED_MODULE_3__Constants__["a" /* Constants */].ApiUrl + url;
        }
        //}
        return url;
    };
    HttpService = HttpService_1 = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_6__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_7__angular_http__["b" /* Http */],
            __WEBPACK_IMPORTED_MODULE_5__utils_AppUtils__["a" /* APPUtils */],
            __WEBPACK_IMPORTED_MODULE_0__utils_UiUtils__["a" /* UiUtils */],
            __WEBPACK_IMPORTED_MODULE_1__utils_EncryptUtils__["a" /* EncryptUtils */]])
    ], HttpService);
    return HttpService;
    var HttpService_1;
}());

//# sourceMappingURL=HttpService.js.map

/***/ }),

/***/ 309:
/***/ (function(module, exports, __webpack_require__) {

var map = {
	"../pages/about/about.module": [
		1274,
		119
	],
	"../pages/binding-mobile/binding-mobile.module": [
		1275,
		95
	],
	"../pages/binding-student-id/binding-student-id.module": [
		1276,
		94
	],
	"../pages/campus-college-info/campus-college-info.module": [
		1277,
		40
	],
	"../pages/campus-company/campus-company.module": [
		1278,
		33
	],
	"../pages/campus-employment-offices/campus-employment-offices.module": [
		1279,
		127
	],
	"../pages/campus-file-search/campus-file-search.module": [
		1280,
		93
	],
	"../pages/campus-nav-more/campus-nav-more.module": [
		1281,
		118
	],
	"../pages/campus-online-faq-create/campus-online-faq-create.module": [
		1282,
		92
	],
	"../pages/campus-online-faq/campus-online-faq.module": [
		1283,
		91
	],
	"../pages/campus-position/campus-position.module": [
		1284,
		32
	],
	"../pages/campus-talk/campus-talk.module": [
		1285,
		39
	],
	"../pages/campus/campus.module": [
		1286,
		31
	],
	"../pages/chat-details/chat-details.module": [
		1287,
		4
	],
	"../pages/chat-faq/chat-faq.module": [
		1288,
		90
	],
	"../pages/chat-filter/chat-filter.module": [
		1289,
		89
	],
	"../pages/chat-message-language/chat-message-language.module": [
		1290,
		88
	],
	"../pages/chat-more-options/chat-more-options.module": [
		1291,
		49
	],
	"../pages/chat/chat.module": [
		1292,
		0
	],
	"../pages/college-campus-talk/college-campus-talk.module": [
		1293,
		87
	],
	"../pages/college-career-consult-details/college-career-consult-details.module": [
		1294,
		30
	],
	"../pages/college-career-consult/college-career-consult.module": [
		1295,
		29
	],
	"../pages/college-faculty-details/college-faculty-details.module": [
		1296,
		28
	],
	"../pages/college-faculty/college-faculty.module": [
		1297,
		86
	],
	"../pages/college-info-search/college-info-search.module": [
		1298,
		85
	],
	"../pages/college-job-info-details/college-job-info-details.module": [
		1299,
		27
	],
	"../pages/college-job-info/college-job-info.module": [
		1300,
		84
	],
	"../pages/college-milk-round/college-milk-round.module": [
		1301,
		83
	],
	"../pages/college-position-brief-details/college-position-brief-details.module": [
		1302,
		26
	],
	"../pages/college-position-brief/college-position-brief.module": [
		1303,
		82
	],
	"../pages/college/college.module": [
		1304,
		25
	],
	"../pages/company/company.module": [
		1305,
		38
	],
	"../pages/feedback/feedback.module": [
		1306,
		81
	],
	"../pages/image-view/image-view.module": [
		1307,
		126
	],
	"../pages/interview-agenda/interview-agenda.module": [
		1308,
		3
	],
	"../pages/interview-details/interview-details.module": [
		1309,
		24
	],
	"../pages/job-details/job-details.module": [
		1310,
		23
	],
	"../pages/job-intension/job-intension.module": [
		1311,
		47
	],
	"../pages/job-list/job-list.module": [
		1312,
		2
	],
	"../pages/job-subscription/job-subscription.module": [
		1313,
		97
	],
	"../pages/login-college/login-college.module": [
		1314,
		45
	],
	"../pages/login-for-test/login-for-test.module": [
		1315,
		80
	],
	"../pages/login-position-skill/login-position-skill.module": [
		1316,
		79
	],
	"../pages/login-position/login-position.module": [
		1317,
		78
	],
	"../pages/login-student-id/login-student-id.module": [
		1318,
		77
	],
	"../pages/login-user-profile/login-user-profile.module": [
		1319,
		22
	],
	"../pages/login-user-skill/login-user-skill.module": [
		1320,
		76
	],
	"../pages/login/login.module": [
		1321,
		75
	],
	"../pages/message-details/message-details.module": [
		1322,
		21
	],
	"../pages/message/message.module": [
		1323,
		5
	],
	"../pages/milk-round-live-position/milk-round-live-position.module": [
		1324,
		20
	],
	"../pages/milk-round-live/milk-round-live.module": [
		1326,
		19
	],
	"../pages/milk-round/milk-round.module": [
		1325,
		37
	],
	"../pages/modal-image-cropper/modal-image-cropper.module": [
		1327,
		117
	],
	"../pages/modal-input/modal-input.module": [
		1328,
		116
	],
	"../pages/modal-notification/modal-notification.module": [
		1329,
		125
	],
	"../pages/modal-share/modal-share.module": [
		1331,
		74
	],
	"../pages/my-chat-history/my-chat-history.module": [
		1330,
		18
	],
	"../pages/my-collection/my-collection.module": [
		1332,
		17
	],
	"../pages/my-delivery/my-delivery.module": [
		1333,
		16
	],
	"../pages/my-order/my-order.module": [
		1334,
		15
	],
	"../pages/my-profile-email/my-profile-email.module": [
		1335,
		73
	],
	"../pages/my-profile-name/my-profile-name.module": [
		1336,
		72
	],
	"../pages/my-profile-wechat/my-profile-wechat.module": [
		1337,
		71
	],
	"../pages/my-profile/my-profile.module": [
		1338,
		50
	],
	"../pages/my-qr-code/my-qr-code.module": [
		1339,
		48
	],
	"../pages/my-resume-certificate-agency/my-resume-certificate-agency.module": [
		1340,
		115
	],
	"../pages/my-resume-certificate-name/my-resume-certificate-name.module": [
		1341,
		114
	],
	"../pages/my-resume-certificate/my-resume-certificate.module": [
		1342,
		70
	],
	"../pages/my-resume-education-editor/my-resume-education-editor.module": [
		1343,
		44
	],
	"../pages/my-resume-interested/my-resume-interested.module": [
		1344,
		14
	],
	"../pages/my-resume-match-description/my-resume-match-description.module": [
		1345,
		113
	],
	"../pages/my-resume-match-link/my-resume-match-link.module": [
		1346,
		112
	],
	"../pages/my-resume-match-name/my-resume-match-name.module": [
		1347,
		111
	],
	"../pages/my-resume-match-post/my-resume-match-post.module": [
		1348,
		110
	],
	"../pages/my-resume-match/my-resume-match.module": [
		1349,
		13
	],
	"../pages/my-resume-more/my-resume-more.module": [
		1350,
		41
	],
	"../pages/my-resume-opus-description/my-resume-opus-description.module": [
		1351,
		109
	],
	"../pages/my-resume-opus-link/my-resume-opus-link.module": [
		1352,
		108
	],
	"../pages/my-resume-opus-name/my-resume-opus-name.module": [
		1353,
		107
	],
	"../pages/my-resume-opus/my-resume-opus.module": [
		1354,
		12
	],
	"../pages/my-resume-preview/my-resume-preview.module": [
		1355,
		11
	],
	"../pages/my-resume-training-course/my-resume-training-course.module": [
		1356,
		106
	],
	"../pages/my-resume-training-name/my-resume-training-name.module": [
		1357,
		105
	],
	"../pages/my-resume-training/my-resume-training.module": [
		1358,
		69
	],
	"../pages/my-resume-viewed/my-resume-viewed.module": [
		1359,
		10
	],
	"../pages/my-resume-work-description-template/my-resume-work-description-template.module": [
		1360,
		9
	],
	"../pages/my-resume-work-description/my-resume-work-description.module": [
		1361,
		68
	],
	"../pages/my-resume-work-editor/my-resume-work-editor.module": [
		1362,
		1
	],
	"../pages/my-resume-work-title/my-resume-work-title.module": [
		1363,
		104
	],
	"../pages/my-resume/my-resume.module": [
		1364,
		43
	],
	"../pages/my-skill-add/my-skill-add.module": [
		1365,
		67
	],
	"../pages/my-skill-editor/my-skill-editor.module": [
		1366,
		66
	],
	"../pages/my-skill/my-skill.module": [
		1367,
		65
	],
	"../pages/my/my.module": [
		1368,
		64
	],
	"../pages/position-add/position-add.module": [
		1369,
		63
	],
	"../pages/position-skill-add/position-skill-add.module": [
		1370,
		62
	],
	"../pages/position-skill-editor/position-skill-editor.module": [
		1371,
		61
	],
	"../pages/position-skill-select/position-skill-select.module": [
		1372,
		60
	],
	"../pages/privacy-policy/privacy-policy.module": [
		1373,
		103
	],
	"../pages/publisher/publisher.module": [
		1374,
		8
	],
	"../pages/report/report.module": [
		1375,
		59
	],
	"../pages/rest-password/rest-password.module": [
		1376,
		58
	],
	"../pages/scanner/scanner.module": [
		1377,
		102
	],
	"../pages/search/search.module": [
		1378,
		7
	],
	"../pages/select-city-district-modal/select-city-district-modal.module": [
		1379,
		124
	],
	"../pages/select-city-modal/select-city-modal.module": [
		1380,
		101
	],
	"../pages/select-city/select-city.module": [
		1381,
		123
	],
	"../pages/select-skill-modal/select-skill-modal.module": [
		1382,
		57
	],
	"../pages/selector-industry/selector-industry.module": [
		1383,
		56
	],
	"../pages/selector/selector.module": [
		1384,
		96
	],
	"../pages/setup-user-mobile/setup-user-mobile.module": [
		1385,
		55
	],
	"../pages/setup-user-password/setup-user-password.module": [
		1386,
		54
	],
	"../pages/setup/setup.module": [
		1387,
		53
	],
	"../pages/signup-center/signup-center.module": [
		1388,
		52
	],
	"../pages/student-info/student-info.module": [
		1389,
		46
	],
	"../pages/subscription-add/subscription-add.module": [
		1390,
		51
	],
	"../pages/subscription-editor/subscription-editor.module": [
		1391,
		42
	],
	"../pages/tabs/tabs.module": [
		1392,
		128
	],
	"../pages/wap-campus-talk/wap-campus-talk.module": [
		1393,
		36
	],
	"../pages/wap-chat-default/wap-chat-default.module": [
		1394,
		100
	],
	"../pages/wap-company/wap-company.module": [
		1395,
		35
	],
	"../pages/wap-default/wap-default.module": [
		1396,
		122
	],
	"../pages/wap-job-list-default/wap-job-list-default.module": [
		1397,
		6
	],
	"../pages/wap-login-student-id/wap-login-student-id.module": [
		1398,
		99
	],
	"../pages/wap-milk-round/wap-milk-round.module": [
		1399,
		34
	],
	"../pages/wap-my-default/wap-my-default.module": [
		1400,
		98
	],
	"../pages/wap-tabs/wap-tabs.module": [
		1401,
		121
	],
	"../pages/welcome/welcome.module": [
		1402,
		120
	]
};
function webpackAsyncContext(req) {
	var ids = map[req];
	if(!ids)
		return Promise.reject(new Error("Cannot find module '" + req + "'."));
	return __webpack_require__.e(ids[1]).then(function() {
		return __webpack_require__(ids[0]);
	});
};
webpackAsyncContext.keys = function webpackAsyncContextKeys() {
	return Object.keys(map);
};
webpackAsyncContext.id = 309;
module.exports = webpackAsyncContext;

/***/ }),

/***/ 48:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return Config; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};

var Config = /** @class */ (function () {
    function Config() {
        this.myPageTabBadgeCount = 0;
        this.chatPageTabBadgeCount = 0;
        //引导页面
        this.loginGuide = false;
        this.isIOS = false;
        this.isWeb = false;
        /**
         * 键盘显示/隐藏
         */
        this.isKeyboardShow = false;
        this.jm_login_fail = false;
        this.goworkla_jm_test = 'T_PIFJ4BXI';
        /**
         * 用户全局变量
         */
        this.user = {
            "name": '',
            "sex": '',
            "avatar": '',
            "school": '',
            "schoolCode": '',
            "schoolLogo": '',
            "major": '',
            "wechat": '',
            "email": '',
            "targetCity": '',
            "targetCityCode": ''
        };
        this.studentId = ""; //学号
        this.userMobile = "";
        this.collegeId = ""; //学校id
        this.maleDefaultAvatar = "assets/img/male-default.png";
        this.femaleDefaultAvatar = "assets/img/female-default.png";
        this.userDefaultAvatar = "assets/img/user-default-avatar.png";
        this.companyDefaultLogo = "assets/img/company-default-logo.png";
        /**
         * 简历参数
         */
        this.education = new Array(); //教育经历
        //职位方向 过滤条件
        this.jobTarget = {
            expect_salary: null,
            expect_salary_text: "",
            industry: [],
            subid: null,
            work_city: [],
            work_nature: null,
            work_nature_text: "",
        };
        this.entryTime = { "code": "", "text": "" }; //入职时间
        this.skills = new Array(); //技能
        this.proSkills = new Array(); //通用技能
        this.career = new Array(); //职位方向
        this.industry = new Array(); //用户选择的行业
        this.resumeLevel = 0; //简历完整度
        this.unReadTotal = 0; //总未读消息数
        this.enterConversation = false; //判断是否进入一对一对话，不在计未读消息数量
        this.currentChatUser = ''; //当前聊天用户
        /**
         * 通知栏
         * 禁止通知:
         * 1.对话列表页面
         * 2.当前对话页面，如果其他人（不是当前对话人）发消息提示
         *
         */
        this.showNotification = true;
        this.currentChatId = null;
        this.dialogueShieldArray = new Array();
        /**
         * 设置
         */
        this.setup = { "notification": false }; //true: 开启免打扰；false: 关闭免打扰。
        /**
         * 搜索历史
         */
        this.searchHistory = new Array();
        if (!Config_1.isCreating) {
            throw new Error("You can't call new in Config Singleton instance!");
        }
    }
    Config_1 = Config;
    Config.getInstance = function () {
        if (Config_1.instance == null) {
            Config_1.isCreating = true;
            Config_1.instance = new Config_1();
            Config_1.isCreating = false;
        }
        return Config_1.instance;
    };
    Config.isCreating = false;
    Config = Config_1 = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [])
    ], Config);
    return Config;
    var Config_1;
}());

//# sourceMappingURL=Config.js.map

/***/ }),

/***/ 49:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return Api; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__Config__ = __webpack_require__(48);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__http_HttpService__ = __webpack_require__(266);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__angular_core__ = __webpack_require__(0);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};



var Api = /** @class */ (function () {
    function Api(http) {
        this.http = http;
    }
    /**
     * 获取手机短信验证码(使用代理)
     */
    Api.prototype.getSMS = function (params) {
        return this.http.postFormData("topsystem/smsvcode/app", params, true);
    };
    /**
     * 获取code(使用代理)
     */
    Api.prototype.getCode = function (params) {
        return this.http.postFormData("user/mobile/sms", params, true);
    };
    /**
     * 学号获取code(使用代理)
     */
    Api.prototype.getCodeForStudentId = function (params) {
        return this.http.postFormData("user/login/college/no", params, true);
    };
    /**
     * 通过code获取token(使用代理)
     */
    Api.prototype.getToken = function (params) {
        return this.http.postFormData("api/oauth2/access_token/", params, true);
    };
    Api.prototype.getAccount = function () {
        return this.http.get("account_user/talent");
    };
    Api.prototype.getUserInfo = function () {
        return this.http.get("user");
    };
    Api.prototype.getStudentIdByMobile = function (params) {
        return this.http.postFormData("user/nobymobile", params, true);
    };
    Api.prototype.restPassword = function (params) {
        return this.http.postFormData("user/password/resetbymobile", params, true);
    };
    /**
     * 获取极光web初始化参数
     * {
            "appkey": "",
            "random_str": "",
            "signature": "",
            "timestamp": ""
        }
     */
    Api.prototype.getJmInitData = function () {
        return this.http.get("im/auth_payload");
    };
    /**
     * 测试接口(使用代理)
     */
    Api.prototype.loginForTest = function (params) {
        return this.http.postFormData("user/login/test/" + params.loginname + "/" + params.password, params, true);
    };
    /**
     * 引导页面数据
     * 职位总数
     */
    Api.prototype.getPositionTotal = function (params) {
        return this.http.get("topsystem/dataconfig/position/data", params);
    };
    //获取匹配职位数
    Api.prototype.getRecommendationTotal = function () {
        return this.http.get("position/recommendation/count");
    };
    Api.prototype.checkStudentMobile = function (mobile) {
        return this.http.get("talent/" + mobile + "/bindno/check");
    };
    //检测是否绑定学号（检测学校是否已导入学生信息）
    Api.prototype.checkStudentId = function () {
        return this.http.post("student/talent/check");
    };
    //绑定学号
    Api.prototype.bindingStudentId = function (params) {
        return this.http.postFormData("student/bind/talent", params);
    };
    //手机号绑定
    Api.prototype.bindingMobile = function (params) {
        return this.http.postFormData("talent/bindno/merge", params);
    };
    /**
     * 在线
     */
    Api.prototype.online = function () {
        return this.http.get("account/refresh/onlinetime");
    };
    /**
     * 获取简历信息
     */
    Api.prototype.getResume = function () {
        return this.http.get("resume/default");
    };
    //获取分享简历key
    Api.prototype.getResumeShareKey = function (resumeid, channels) {
        return this.http.get("resume/" + resumeid + "/share/" + channels + "/key");
    };
    Api.prototype.getResumeFromKey = function (key) {
        return this.http.get("resume/" + key + "/view/share");
    };
    /**
     * 创建人才账户及简历
     * 获取accound id和resume id
     * 极光用户和密码
     */
    Api.prototype.registerUserInfo = function (params) {
        return this.http.postFormData("talent/onestep", params);
    };
    /**
     * 获取推荐的职位类别
     */
    Api.prototype.getRecommendedJob = function () {
        return this.http.get("resume/post_type");
    };
    //获取推荐非订阅职位类别
    Api.prototype.getOtherJob = function () {
        return this.http.get("resume/post_type/other");
    };
    Api.prototype.updateJobSubscription = function (params) {
        return this.http.post("resume/" + __WEBPACK_IMPORTED_MODULE_0__Config__["a" /* Config */].getInstance().resume_id + "/job_target/career/update", params);
    };
    Api.prototype.updateCareer = function (params) {
        return this.http.post("resume/" + __WEBPACK_IMPORTED_MODULE_0__Config__["a" /* Config */].getInstance().resume_id + "/career/update", params);
    };
    //根据选择的职位类别 获取专业技能标签
    Api.prototype.getCareerSkill = function () {
        return this.http.get("resume/career/skill");
    };
    //修改简历职位技能标签
    Api.prototype.updateProSkill = function (params) {
        return this.http.post("resume/" + __WEBPACK_IMPORTED_MODULE_0__Config__["a" /* Config */].getInstance().resume_id + "/pro_skill/update", params);
    };
    /**
     * 获取用户订阅职位
     */
    Api.prototype.getJobSubscription = function () {
        return this.http.get("resume/" + __WEBPACK_IMPORTED_MODULE_0__Config__["a" /* Config */].getInstance().resume_id + "/job_target/career");
    };
    /**
     * 获取简历意向职位
     */
    Api.prototype.getJobFilter = function () {
        return this.http.get("resume/" + __WEBPACK_IMPORTED_MODULE_0__Config__["a" /* Config */].getInstance().resume_id + "/job_target");
    };
    Api.prototype.updateJobFilter = function (params) {
        return this.http.postFormData("/resume/" + __WEBPACK_IMPORTED_MODULE_0__Config__["a" /* Config */].getInstance().resume_id + "/job_target/update", params);
    };
    /**
     * 首页
     * 搜索
     */
    Api.prototype.jobSearch = function (params) {
        return this.http.get("position/searcher", params);
    };
    //猜你想搜
    Api.prototype.jobKeyword = function () {
        //return this.http.get("position/keyword");
        return this.http.get("resume/keywords");
    };
    /**
     * 首页
     * 获取职位推荐
     */
    Api.prototype.getJobRecommend = function (params) {
        return this.http.get("position/recommendation", params);
    };
    Api.prototype.getJobDetails = function (id) {
        return this.http.get("position/" + id + "/public");
    };
    //获取热门城市
    Api.prototype.getHotCity = function () {
        return this.http.get("position/hot/city");
    };
    /**
     * 获取企业和hr信息
     */
    Api.prototype.getCompanyById = function (departmentid) {
        return this.http.get("department/" + departmentid + "/public");
    };
    Api.prototype.getCompanyAllJob = function (numberid) {
        return this.http.get("department/" + numberid + "/position/list");
    };
    Api.prototype.getCompanyAllPosition = function (departmentid, collegeid) {
        return this.http.get("department/position/list/public?departmentid=" + departmentid + "&collegeid=" + collegeid);
    };
    Api.prototype.getPublisherAllJob = function (numberid) {
        return this.http.get("department/" + numberid + "/position");
    };
    //获取企业招聘会，宣讲会
    Api.prototype.getCompanyAllMC = function (params) {
        return this.http.get("mc/department/apply/list", params);
    };
    /**
     * 收藏
     */
    Api.prototype.postLike = function (numberid) {
        return this.http.post("position/" + numberid + "/like");
    };
    Api.prototype.postUnLike = function (numberid) {
        return this.http.post("position/" + numberid + "/unlike");
    };
    /**
     *  简历投递
     */
    Api.prototype.deliverResume = function (params) {
        return this.http.postFormData("delivery", params);
    };
    /**
     * 热门职位
     */
    Api.prototype.getJobHot = function (params) {
        return this.http.get("position/hot", params);
    };
    /**
     * 根据名称模糊匹配返回字典
     * 需要添加 级别 level
     */
    Api.prototype.matchSearch = function (dicttype, params) {
        return this.http.get("dict/" + dicttype + "/matching", params);
    };
    Api.prototype.getDict = function (dicttype) {
        return this.http.get("dict/" + dicttype);
    };
    //获取子集
    Api.prototype.getDictChild = function (dicttype, parentcode) {
        return this.http.get("dict/" + dicttype + "/" + parentcode);
    };
    Api.prototype.getDictContrast = function (source_dict_type, source_code, result_dict_type) {
        return this.http.get("dict/contrast/" + source_dict_type + "/" + source_code + "/" + result_dict_type);
    };
    /**
     * 消息(聊天)
     */
    Api.prototype.getChatDialogueList = function (params) {
        return this.http.get("im/dialogue/list", params);
    };
    //获取所有对话列表
    Api.prototype.getChatDialogueAllList = function () {
        return this.http.get("im/dialogue/alllist");
    };
    Api.prototype.getChatList = function (id, params) {
        return this.http.get("im/chat/" + id + "/list", params);
    };
    Api.prototype.sendChat = function (params) {
        return this.http.post("im/chat/create", params);
    };
    Api.prototype.sendChatImage = function (params) {
        return this.http.post("im/image/upload", params);
    };
    Api.prototype.getChatDialogue = function (jm_user_name) {
        return this.http.get("im/dialogue/" + jm_user_name);
    };
    Api.prototype.setChatRead = function (dlid) {
        return this.http.post("im/chat/" + dlid + "/read");
    };
    Api.prototype.getChatMenu = function (accountid) {
        return this.http.get("im/official_account/" + accountid + "/menu");
    };
    Api.prototype.getDialogueUserInfo = function (username) {
        return this.http.get("im/dialogue/" + username + "/info");
    };
    Api.prototype.registerPush = function (params) {
        return this.http.post("im/push/channel", params);
    };
    //获取招聘会
    Api.prototype.getMilkRoundById = function (id) {
        return this.http.get("milkround/" + id + "/public");
    };
    Api.prototype.milkRoundSignin = function (id) {
        return this.http.post("milkround/" + id + "/signin/talent");
    };
    Api.prototype.getMilkRoundCompanyList = function (id, params) {
        return this.http.get("milkround/" + id + "/department/list/public", params);
    };
    //预约招聘会
    Api.prototype.reminderMilkRoundById = function (id) {
        return this.http.post("milkround/" + id + "/apply/talent");
    };
    //获取预约招聘会
    Api.prototype.getMilkRoundOrder = function (params) {
        return this.http.get("milkround/apply/list/talent", params);
    };
    /**
     * 获取弹幕 招聘会现场
     * @param id
     */
    Api.prototype.getLiveMilkRoundBulletScreen = function (id) {
        return this.http.get("milkround/" + id + "/live/barrage");
    };
    //获取招聘现场企业
    Api.prototype.getLiveMilkRoundList = function (id, params) {
        return this.http.get("milkround/" + id + "/live/talent", params);
    };
    Api.prototype.getLiveMilkRoundPositionList = function (id, params) {
        return this.http.get("milkround/" + id + "/live/talent/position/list", params);
    };
    //获取宣讲会
    Api.prototype.getCampustalkById = function (id) {
        return this.http.get("campustalk/" + id + "/public");
    };
    //预约宣讲会
    Api.prototype.reminderCampustalkById = function (id) {
        return this.http.post("campustalk/" + id + "/reserve");
    };
    //获取预约宣讲会
    Api.prototype.getCampustalkOrder = function (params) {
        return this.http.get("campustalk/reserve/list", params);
    };
    //检查投递状态
    Api.prototype.chatCheck = function (params) {
        return this.http.post("im/chat/check", params);
    };
    //置顶
    Api.prototype.topChat = function (id) {
        return this.http.post("im/dialogue/" + id + "/top");
    };
    Api.prototype.shieldChat = function (id) {
        return this.http.post("im/dialogue/" + id + "/shield");
    };
    Api.prototype.reportChat = function (id, code) {
        return this.http.post("im/dialogue/" + id + "/tip_off?reason=" + code);
    };
    //筛选
    Api.prototype.getChatFilterPostType = function () {
        return this.http.get("im/dialogue/list/post_type");
    };
    /**
     * 面试
     */
    Api.prototype.getInterviewAgenda = function (params) {
        return this.http.get("interview/talent/list", params);
    };
    Api.prototype.getInterviewDetails = function (id) {
        return this.http.get("interview/talent/" + id);
    };
    Api.prototype.reponseInterview = function (interviewid, feedback_status) {
        return this.http.post("interview/" + interviewid + "/feedback?feedback_status=" + feedback_status);
    };
    Api.prototype.reponseOffer = function (interviewid, res) {
        return this.http.post("interview/" + interviewid + "/feedback/offer?is_entry=" + res);
    };
    /**
     * 我的
     * 获取简历完整度
     */
    Api.prototype.getResumeLevel = function () {
        return this.http.get("resume/" + __WEBPACK_IMPORTED_MODULE_0__Config__["a" /* Config */].getInstance().resume_id + "/level");
    };
    Api.prototype.getCount = function () {
        return this.http.get("talent/listcount/simple");
    };
    //沟通过
    Api.prototype.getMyChatHistory = function (params) {
        return this.http.get("im/dialogue/list/position", params);
    };
    //已投递
    Api.prototype.getMyDelivery = function (params) {
        return this.http.get("delivery/mydelivery", params);
    };
    /**
     * 获取人才信息
     */
    Api.prototype.getProfile = function () {
        return this.http.get("talent");
    };
    Api.prototype.getAvatar = function () {
        return this.http.get("talent/profile_picture");
    };
    Api.prototype.updateProfile = function (params) {
        return this.http.postFormData("talent/update/app", params);
    };
    Api.prototype.updateProfileAddress = function (params) {
        return this.http.postFormData("talent/address/update", params);
    };
    Api.prototype.updateAvatar = function (params) {
        return this.http.postFormData("talent/profile_picture/app", params);
    };
    //User用户（没有accound id）
    Api.prototype.updateUserAvatar = function (params) {
        return this.http.postFormData("user/update/avatar/app", params);
    };
    Api.prototype.updateUserName = function (params) {
        return this.http.postFormData("talent/name/update", params);
    };
    Api.prototype.updateUserGender = function (params) {
        return this.http.postFormData("talent/gender/update", params);
    };
    Api.prototype.updateUserOverseaWork = function (params) {
        return this.http.postFormData("talent/overseas_work/update", params);
    };
    Api.prototype.updateUserBirthday = function (params) {
        return this.http.postFormData("talent/birthdate/update", params);
    };
    Api.prototype.updateWechat = function (params) {
        return this.http.postFormData("talent/wechat/update", params);
    };
    Api.prototype.updateEmail = function (params) {
        return this.http.postFormData("talent/email/update", params);
    };
    Api.prototype.updateEntryTime = function (params) {
        return this.http.postFormData("/resume/" + __WEBPACK_IMPORTED_MODULE_0__Config__["a" /* Config */].getInstance().resume_id + "/entry", params);
    };
    /**
     * 添加教育经历
     *
     */
    Api.prototype.addEducation = function (params) {
        return this.http.postFormData("resume/" + __WEBPACK_IMPORTED_MODULE_0__Config__["a" /* Config */].getInstance().resume_id + "/education_backgrounds/create", params);
    };
    Api.prototype.getEducationById = function (id) {
        return this.http.get("resume/" + __WEBPACK_IMPORTED_MODULE_0__Config__["a" /* Config */].getInstance().resume_id + "/education_backgrounds/" + id);
    };
    Api.prototype.updateEducationById = function (params, subid) {
        return this.http.postFormData("resume/" + __WEBPACK_IMPORTED_MODULE_0__Config__["a" /* Config */].getInstance().resume_id + "/education_backgrounds/" + subid + "/update", params);
    };
    Api.prototype.deleteEducationById = function (subid) {
        return this.http.post("resume/" + __WEBPACK_IMPORTED_MODULE_0__Config__["a" /* Config */].getInstance().resume_id + "/education_backgrounds/" + subid + "/delete");
    };
    /**
     * 添加工作经历
     */
    Api.prototype.addWork = function (params) {
        return this.http.postFormData("resume/" + __WEBPACK_IMPORTED_MODULE_0__Config__["a" /* Config */].getInstance().resume_id + "/work_experience/create", params);
    };
    Api.prototype.getWorkById = function (id) {
        return this.http.get("resume/" + __WEBPACK_IMPORTED_MODULE_0__Config__["a" /* Config */].getInstance().resume_id + "/work_experience/" + id);
    };
    Api.prototype.getJobPostList = function () {
        return this.http.get("/resume/post_type/other");
    };
    Api.prototype.updateWorkById = function (params, subid) {
        return this.http.postFormData("resume/" + __WEBPACK_IMPORTED_MODULE_0__Config__["a" /* Config */].getInstance().resume_id + "/work_experience/" + subid + "/update", params);
    };
    Api.prototype.deleteWorkById = function (subid) {
        return this.http.post("resume/" + __WEBPACK_IMPORTED_MODULE_0__Config__["a" /* Config */].getInstance().resume_id + "/work_experience/" + subid + "/delete");
    };
    //获取工作描述模板
    Api.prototype.getWorkDescriptionModel = function (post_type) {
        return this.http.get("position/" + post_type + "/post_desc");
    };
    /**
     * 作品
     */
    Api.prototype.addOpus = function (params) {
        return this.http.postFormData("resume/" + __WEBPACK_IMPORTED_MODULE_0__Config__["a" /* Config */].getInstance().resume_id + "/works/create", params);
    };
    Api.prototype.getOpusById = function (id) {
        return this.http.get("resume/" + __WEBPACK_IMPORTED_MODULE_0__Config__["a" /* Config */].getInstance().resume_id + "/works/" + id);
    };
    Api.prototype.updateOpusById = function (params, subid) {
        return this.http.postFormData("resume/" + __WEBPACK_IMPORTED_MODULE_0__Config__["a" /* Config */].getInstance().resume_id + "/works/" + subid + "/update", params);
    };
    Api.prototype.deleteOpusById = function (subid) {
        return this.http.post("resume/" + __WEBPACK_IMPORTED_MODULE_0__Config__["a" /* Config */].getInstance().resume_id + "/works/" + subid + "/delete");
    };
    /**
     * 上传图片
     */
    Api.prototype.uploadPhoto = function (params) {
        return this.http.postFormData("resume/" + __WEBPACK_IMPORTED_MODULE_0__Config__["a" /* Config */].getInstance().resume_id + "/uploadimage", params);
    };
    /**
     * 项目比赛
     */
    Api.prototype.addMatch = function (params) {
        return this.http.postFormData("resume/" + __WEBPACK_IMPORTED_MODULE_0__Config__["a" /* Config */].getInstance().resume_id + "/project_experience/create", params);
    };
    Api.prototype.getMatchById = function (id) {
        return this.http.get("resume/" + __WEBPACK_IMPORTED_MODULE_0__Config__["a" /* Config */].getInstance().resume_id + "/project_experience/" + id);
    };
    Api.prototype.updateMatchById = function (params, subid) {
        return this.http.postFormData("resume/" + __WEBPACK_IMPORTED_MODULE_0__Config__["a" /* Config */].getInstance().resume_id + "/project_experience/" + subid + "/update", params);
    };
    Api.prototype.deleteMatchById = function (subid) {
        return this.http.post("resume/" + __WEBPACK_IMPORTED_MODULE_0__Config__["a" /* Config */].getInstance().resume_id + "/project_experience/" + subid + "/delete");
    };
    /**
     * 培训经历
     */
    Api.prototype.addTraining = function (params) {
        return this.http.postFormData("resume/" + __WEBPACK_IMPORTED_MODULE_0__Config__["a" /* Config */].getInstance().resume_id + "/training_experience/create", params);
    };
    Api.prototype.getTrainingById = function (id) {
        return this.http.get("resume/" + __WEBPACK_IMPORTED_MODULE_0__Config__["a" /* Config */].getInstance().resume_id + "/training_experience/" + id);
    };
    Api.prototype.updateTrainingById = function (params, subid) {
        return this.http.postFormData("resume/" + __WEBPACK_IMPORTED_MODULE_0__Config__["a" /* Config */].getInstance().resume_id + "/training_experience/" + subid + "/update", params);
    };
    Api.prototype.deleteTrainingById = function (subid) {
        return this.http.post("resume/" + __WEBPACK_IMPORTED_MODULE_0__Config__["a" /* Config */].getInstance().resume_id + "/training_experience/" + subid + "/delete");
    };
    /**
     * 证书
     */
    Api.prototype.addCertificate = function (params) {
        return this.http.postFormData("resume/" + __WEBPACK_IMPORTED_MODULE_0__Config__["a" /* Config */].getInstance().resume_id + "/certificates/create", params);
    };
    Api.prototype.getCertificateById = function (id) {
        return this.http.get("resume/" + __WEBPACK_IMPORTED_MODULE_0__Config__["a" /* Config */].getInstance().resume_id + "/certificates/" + id);
    };
    Api.prototype.updateCertificateById = function (params, subid) {
        return this.http.postFormData("resume/" + __WEBPACK_IMPORTED_MODULE_0__Config__["a" /* Config */].getInstance().resume_id + "/certificates/" + subid + "/update", params);
    };
    Api.prototype.deleteCertificateById = function (subid) {
        return this.http.post("resume/" + __WEBPACK_IMPORTED_MODULE_0__Config__["a" /* Config */].getInstance().resume_id + "/certificates/" + subid + "/delete");
    };
    /**
     * 技能
     */
    Api.prototype.updateSkill = function (params) {
        return this.http.post("resume/" + __WEBPACK_IMPORTED_MODULE_0__Config__["a" /* Config */].getInstance().resume_id + "/skill/update", params);
    };
    //获取推荐技能，包括专业技能和通用技能
    Api.prototype.getSkillRecommend = function (params) {
        return this.http.get("resume/skill", params);
    };
    //根据订阅的职位获取简历技能标签
    Api.prototype.getSkillByCareer = function () {
        return this.http.get("resume/" + __WEBPACK_IMPORTED_MODULE_0__Config__["a" /* Config */].getInstance().resume_id + "/career/skill");
    };
    /**
     * 谁看过我（简历浏览记录）
     */
    Api.prototype.getResumeView = function (params) {
        return this.http.get("resume/view", params);
    };
    //对我感兴趣
    Api.prototype.getResumeArchived = function (params) {
        return this.http.get("resume/archived", params);
    };
    /**
     * 收藏
     */
    Api.prototype.getCollection = function (params) {
        return this.http.get("position/like", params);
    };
    /**
     * 意见反馈
     */
    Api.prototype.postFeedback = function (params) {
        return this.http.postFormData("feedback", params);
    };
    /**
     * 修改人才姓名
     */
    Api.prototype.updateName = function (params) {
        return this.http.postFormData("talent/name/update", params);
    };
    //app升级检测
    Api.prototype.checkAppUpdate = function () {
        return this.http.get("topsystem/talent/app_version/newest");
    };
    //获取用户信息
    Api.prototype.getUserMobile = function () {
        return this.http.get("user");
    };
    //修改用户手机号
    Api.prototype.updateUserMobile = function (params) {
        return this.http.postFormData("user/mobile/change", params);
    };
    Api.prototype.updateUserPassword = function (params) {
        return this.http.postFormData("user/password/change", params);
    };
    //校园
    //学校主页
    Api.prototype.getCollegeById = function (id) {
        return this.http.get("college/" + id);
    };
    Api.prototype.getCollegeByCode = function (code) {
        return this.http.get("college/code/" + code);
    };
    //学校招聘会
    Api.prototype.getCollegeMilkRound = function (params) {
        return this.http.get("milkround/list/public", params);
    };
    //学校外招聘会
    Api.prototype.getOtherCollegeMilkRound = function (collegeid, params) {
        return this.http.get("milkround/" + collegeid + "/other/list/public", params);
    };
    //学校宣讲会
    Api.prototype.getCollegeCampusTalk = function (params) {
        return this.http.get("campustalk/list/public", params);
    };
    //学校外宣讲会
    Api.prototype.getOtherCollegeCampusTalk = function (collegeid, params) {
        return this.http.get("campustalk/" + collegeid + "/other/list/public", params);
    };
    Api.prototype.campusTalkSignin = function (id) {
        return this.http.post("campustalk/" + id + "/signin");
    };
    //招聘简章
    Api.prototype.getPositionBreif = function (params) {
        return this.http.get("position_brief/list/public", params);
    };
    //招聘简章详情
    Api.prototype.getPositionBreifDetail = function (numberid) {
        return this.http.get("position_brief/n" + numberid + "/public");
    };
    //就业信息列表
    Api.prototype.getArticle = function (params) {
        return this.http.get("article/list/public", params);
    };
    Api.prototype.getArticleDetailById = function (id) {
        return this.http.get("article/" + id + "/public");
    };
    //校园头部广告
    Api.prototype.getCollegeBanner = function (params) {
        return this.http.get("booth/list/public", params);
    };
    //学校导航栏
    Api.prototype.getCollegeNav = function (collegeid, nav_category) {
        return this.http.get("nav/" + collegeid + "/" + nav_category + "/info");
    };
    Api.prototype.getCollegeFaq = function (collegeid) {
        return this.http.get("consult/" + collegeid + "/list/public");
    };
    Api.prototype.createCollegeFaq = function (collegeid, params) {
        return this.http.postFormData("consult/" + collegeid + "/create", params);
    };
    Api.prototype.collegeSearchFile = function (collegeid, params) {
        return this.http.get("student/" + collegeid + "/archives_query", params);
    };
    //学生获取高校合作公司信息列表
    Api.prototype.getCollegeCompany = function (params) {
        return this.http.get("cooperation/college/list", params);
    };
    Api.prototype.getCollegeCompanyOfWap = function (collegeid, params) {
        return this.http.get("cooperation/college/" + collegeid + "/list", params);
    };
    //获取院系列表
    Api.prototype.getCollegeFaculty = function (id) {
        return this.http.get("college/" + id + "/faculty/list/public");
    };
    //获取学校专业
    Api.prototype.getCollegeFacultyMajor = function (id) {
        return this.http.get("major/" + id + "/list/public");
    };
    //职业咨询
    Api.prototype.getCollegeCareerConsult = function (params) {
        return this.http.get("careerconsult/list/public", params);
    };
    Api.prototype.getCollegeCareerConsultDetails = function (id) {
        return this.http.get("careerconsult/n" + id + "/public");
    };
    //咨询预约
    Api.prototype.collegeCareerConsultOrder = function (id, params) {
        return this.http.post("careerconsult/n" + id + "/apply", params);
    };
    //咨询预约列表
    Api.prototype.getCollegeCareerConsultOrderList = function (params) {
        return this.http.get("careerconsult/apply/talent/list", params);
    };
    //学籍信息
    Api.prototype.getStudentInfo = function () {
        return this.http.get("student/talent");
    };
    Api.prototype.updateStudentInfo = function (sid, params) {
        return this.http.postFormData("student/" + sid + "/talent/update", params);
    };
    //推荐企业 校友企业
    Api.prototype.getCollegeDepartment = function (params) {
        return this.http.get("department/college/list/public", params);
    };
    //签约中心
    Api.prototype.getSignupReceiptList = function (params) {
        return this.http.get("signup/talent/receipt/list", params);
    };
    //获取系统广告
    Api.prototype.getSystemAdv = function () {
        return this.http.get("booth/client/apptalent/list/public");
    };
    Api.prototype.getImToken = function () {
        return this.http.get("api/mimc/token");
    };
    Api = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_2__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__http_HttpService__["a" /* HttpService */]])
    ], Api);
    return Api;
}());

//# sourceMappingURL=Api.js.map

/***/ }),

/***/ 648:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return EncryptUtils; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};

var EncryptUtils = /** @class */ (function () {
    function EncryptUtils() {
        //JS加密
        this.convertDate = function (date) {
            var res = date.getFullYear() + ',' + (date.getMonth() + 1) + ',' + date.getDate() + ',' + date.getHours() + ',' + date.getMinutes() + ',' + date.getSeconds();
            return res;
        };
    }
    //JS加密
    EncryptUtils.prototype.encrypt = function (clientId) {
        var CryptoJS = window.CryptoJS;
        var data = clientId + '--' + this.convertDate(new Date());
        var key = CryptoJS.enc.Utf8.parse('607490BE-18CA-43D7-B11A-57E2621B');
        var iv = CryptoJS.enc.Utf8.parse('2D59831C-78AC-4227-B3F3-CE656636');
        var encrypted = CryptoJS.AES.encrypt(data, key, {
            iv: iv,
            mode: CryptoJS.mode.CBC,
            padding: CryptoJS.pad.Pkcs7
        });
        return encrypted.ciphertext.toString(CryptoJS.enc.Base64);
    };
    ;
    EncryptUtils = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])()
    ], EncryptUtils);
    return EncryptUtils;
}());

//# sourceMappingURL=EncryptUtils.js.map

/***/ }),

/***/ 656:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return XiaoMiMessage; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__ChatUtils__ = __webpack_require__(156);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__model_ChatMessage__ = __webpack_require__(250);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__Constants__ = __webpack_require__(67);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__Config__ = __webpack_require__(48);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5_ionic_angular__ = __webpack_require__(22);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6_typeorm__ = __webpack_require__(6);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};







var XiaoMiMessage = /** @class */ (function () {
    function XiaoMiMessage(events, 
        //private localNotifications: LocalNotifications,
        chatUtils, modalCtrl) {
        this.events = events;
        this.chatUtils = chatUtils;
        this.modalCtrl = modalCtrl;
        this.messageCount = 10;
        XiaoMiMessage_1.instance = this;
        this.config = __WEBPACK_IMPORTED_MODULE_3__Config__["a" /* Config */].getInstance();
    }
    XiaoMiMessage_1 = XiaoMiMessage;
    /**
     * IM初始化 注册监听 小米IM登录
     * @param appAccount 登录账号
     */
    XiaoMiMessage.prototype.login = function (appAccount) {
        var proxyServiceParams = {
            "url": __WEBPACK_IMPORTED_MODULE_2__Constants__["a" /* Constants */].ApiUrl + "api/mimc/token",
            "client_id": __WEBPACK_IMPORTED_MODULE_2__Constants__["a" /* Constants */].ClientId,
            "access_token": this.config.token,
            "accountid": this.config.account_id,
        };
        xiaomiIM.init(appAccount, proxyServiceParams);
        xiaomiIM.addStatusListener(this.statusChangeListener);
        xiaomiIM.addReceiveMsgListener(this.receiveMsgListener);
        xiaomiIM.addServerAckListener(this.serverAckListener);
        xiaomiIM.addDisconnListener(this.disconnectListener);
        xiaomiIM.login();
    };
    /**
     * 获取对话列表
     */
    XiaoMiMessage.prototype.getDialogList = function () {
        return new Promise(function (resolve, reject) {
            xiaomiIM.getDialogList().then(function (res) {
                console.log("getDialogList");
                console.log(res);
                var list = new Array();
                if (res.data.length > 0) {
                    var disMsg = new Base64();
                    var dateTime = void 0;
                    for (var i = 0; i < res.data.length; i++) {
                        var date = new Date(parseInt(res.data[i].timestamp));
                        dateTime = date.getFullYear() + "-" + (date.getMonth() + 1) + "-" + date.getDate() + " " + date.getHours() + ":" + date.getMinutes() + ":" + date.getSeconds();
                        var model = {
                            "toUser": res.data[i].name,
                            "last_message": JSON.parse(disMsg.decode(res.data[i].lastMessage.payload)).content,
                            "dateTime": dateTime,
                            "extra": JSON.parse(res.data[i].extra)
                        };
                        list.push(model);
                    }
                    //XiaoMiMessage.instance.config.dialogList = list;
                    resolve(list);
                }
            }, function (error) {
                console.log(error);
                reject(error);
            });
        });
    };
    /**
     * 获取历史消息
     * 指的是拉取从指定的时间戳utcToTime(不包含utcToTime)向前count条的A与B之间的聊天记录。
     * @param toUser 对方用户名
     * @param uctime 时间戳
     *
     */
    XiaoMiMessage.prototype.getMessageHistory = function (toUser, uctime) {
        return __awaiter(this, void 0, void 0, function () {
            var res, list, disMsg, content, dateTime, i, date, chatMessage;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, xiaomiIM.getMessageList(toUser, XiaoMiMessage_1.instance.messageCount, uctime)];
                    case 1:
                        res = _a.sent();
                        console.log("getMessageList");
                        console.log(res);
                        list = new Array();
                        if (res.data && res.data.messages.length > 0) {
                            disMsg = new Base64();
                            content = void 0, dateTime = void 0;
                            for (i = 0; i < res.data.messages.length; i++) {
                                //console.log(disMsg.decode(res.data.messages[i].payload));
                                try {
                                    content = JSON.parse(disMsg.decode(res.data.messages[i].payload)).content;
                                }
                                catch (err) {
                                    console.log(err);
                                }
                                date = new Date(parseInt(res.data.messages[i].ts));
                                dateTime = date.getFullYear() + "-" + (date.getMonth() + 1) + "-" + date.getDate() + " " + date.getHours() + ":" + date.getMinutes() + ":" + date.getSeconds();
                                chatMessage = new __WEBPACK_IMPORTED_MODULE_1__model_ChatMessage__["a" /* ChatMessage */]();
                                chatMessage.type = res.data.messages[i].bizType;
                                chatMessage.content = content;
                                chatMessage.dateTime = dateTime;
                                chatMessage.toUserName = res.data.messages[i].fromAccount;
                                if (res.data.messages[i].fromAccount == __WEBPACK_IMPORTED_MODULE_3__Config__["a" /* Config */].getInstance().jm_login_user) {
                                    chatMessage.direct = "to";
                                }
                                else {
                                    chatMessage.direct = "from";
                                }
                                list.push(chatMessage);
                            }
                            //通过时间戳获取 更多历史消息
                            XiaoMiMessage_1.instance.lastMessageTs = res.data.messages[0].ts;
                        }
                        else {
                            console.log("没有历史消息");
                        }
                        //console.log(list);
                        return [2 /*return*/, list];
                }
            });
        });
    };
    /**
     * 获取历史消息
     * 指的是拉取从指定的时间戳utcToTime(不包含utcToTime)向前count条的A与B之间的聊天记录。
     * @param toUser 对方用户名
     * @param uctime 时间戳
    getMessageList(toUser,uctime,loadMore = false){
        xiaomiIM.getMessageList(toUser,XiaoMiMessage.instance.messageCount,uctime).then((res)=>{
            console.log("getMessageList");
            console.log(res);
            if(res.data.messages.length > 0){
                var disMsg = new Base64();
                var list = new Array();
                let content,dateTime;
                for(let i = 0;i < res.data.messages.length;i++){
                    //console.log(disMsg.decode(res.data.messages[i].payload));
                    content = JSON.parse(disMsg.decode(res.data.messages[i].payload)).content;
                    //console.log(res.data.messages[i].fromAccount +" : " + content);
                    var date = new Date(parseInt(res.data.messages[i].ts));
                    
                    dateTime = date.getFullYear() + "-" + (date.getMonth() + 1) + "-" + date.getDate() + " " + date.getHours() + ":" + date.getMinutes() + ":" + date.getSeconds();
                    
                    let chatMessage = new ChatMessage();
                    chatMessage.type = res.data.messages[i].bizType;
                    chatMessage.content = content;
                    chatMessage.dateTime = dateTime;
                    chatMessage.toUserName = res.data.messages[i].fromAccount;
                    if(res.data.messages[i].fromAccount == Config.getInstance().jm_login_user){
                        chatMessage.direct = "to";
                    }else{
                        chatMessage.direct = "from";
                    }

                    list.push(chatMessage);
                }
                //console.log(list);

                //通过时间戳获取 更多历史消息
                XiaoMiMessage.instance.lastMessageTs = res.data.messages[0].ts;

                if(loadMore){
                    XiaoMiMessage.instance.events.publish("im:messageLoadMore",list);
                }else{
                    XiaoMiMessage.instance.events.publish("im:messageList",list);
                }
                
            }else{
                console.log("没有历史消息");
            }
            
        },(error)=>{
            console.log(error);
        })
    }*/
    /**
     * 加载更多 历史消息
     * @param toUser
     */
    XiaoMiMessage.prototype.loadMore = function (toUser) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!XiaoMiMessage_1.instance.lastMessageTs) return [3 /*break*/, 2];
                        console.log("加载更多");
                        return [4 /*yield*/, this.getMessageHistory(toUser, XiaoMiMessage_1.instance.lastMessageTs)];
                    case 1: return [2 /*return*/, _a.sent()];
                    case 2: return [2 /*return*/];
                }
            });
        });
    };
    //登录状态监听
    XiaoMiMessage.prototype.statusChangeListener = function (bindResult, errType, errReason, errDesc) {
        if (bindResult) {
            console.log("login succeed");
            XiaoMiMessage_1.instance.events.publish("im:login", "succeed");
        }
        else {
            console.log("login failed.errReason=" + errReason + ",errDesc=" + errDesc + ",errType=" + errType);
            XiaoMiMessage_1.instance.events.publish("im:login", "fail");
        }
    };
    /**
     * 消息接收监听
     * @param message
     */
    XiaoMiMessage.prototype.receiveMsgListener = function (message) {
        return __awaiter(this, void 0, void 0, function () {
            var date, msgDate, chatMessage, dialogListDB, chat, message_1, dialogListDB, chat, message_2;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        date = new Date(parseInt(message.getTimeStamp()));
                        //console.log("time: " + date.getFullYear() + "-" + (date.getMonth() + 1) + "-" + date.getDate() + " " + date.getHours() + ":" + date.getMinutes() + ":" + date.getSeconds() + " " + date.getMilliseconds());
                        console.log(message);
                        //var disMsg = new Base64();
                        console.log("biztype=" + message.getBizType());
                        //console.log(message.getFromAccount() + " to " + mimc_appAccount + ":" + disMsg.decode(JSON.parse(message.getPayload()).content));
                        console.log("消息来自：" + message.getFromAccount());
                        console.log("消息内容：" + JSON.parse(message.getPayload()).content);
                        console.log("消息Sequence：" + message.getSequence());
                        console.log("消息packageId：" + message.getPacketId());
                        msgDate = date.getFullYear() + "-" + (date.getMonth() + 1) + "-" + date.getDate() + " " + date.getHours() + ":" + date.getMinutes() + ":" + date.getSeconds();
                        chatMessage = new __WEBPACK_IMPORTED_MODULE_1__model_ChatMessage__["a" /* ChatMessage */]();
                        chatMessage.type = message.getBizType();
                        chatMessage.content = JSON.parse(message.getPayload()).content;
                        chatMessage.dateTime = msgDate;
                        chatMessage.toUserName = message.getFromAccount();
                        if (message.getFromAccount() == __WEBPACK_IMPORTED_MODULE_3__Config__["a" /* Config */].getInstance().jm_login_user) {
                            chatMessage.direct = "to";
                        }
                        else {
                            chatMessage.direct = "from";
                        }
                        if (!(XiaoMiMessage_1.instance.config.currentChatUser == message.getFromAccount())) return [3 /*break*/, 4];
                        XiaoMiMessage_1.instance.events.publish("im:receive", chatMessage);
                        dialogListDB = Object(__WEBPACK_IMPORTED_MODULE_6_typeorm__["o" /* getRepository */])('dialog_list');
                        return [4 /*yield*/, dialogListDB.findOne({ dialog_user: message.getFromAccount() })];
                    case 1:
                        chat = _a.sent();
                        if (!chat) return [3 /*break*/, 3];
                        message_1 = JSON.parse(chat.content);
                        message_1.last_message_type = chatMessage.type;
                        message_1.last_message = XiaoMiMessage_1.instance.chatUtils.formatMessageContent(chatMessage.type, chatMessage.content);
                        message_1.last_message_time = chatMessage.dateTime;
                        chat.content = JSON.stringify(message_1);
                        return [4 /*yield*/, dialogListDB.save(chat)];
                    case 2:
                        _a.sent();
                        //更新对话列表，重新排序
                        XiaoMiMessage_1.instance.chatUtils.updateDialogList();
                        _a.label = 3;
                    case 3: return [3 /*break*/, 9];
                    case 4:
                        if (!(message.getFromAccount() == XiaoMiMessage_1.instance.config.jm_login_user)) return [3 /*break*/, 8];
                        console.log("消息来自其他端");
                        dialogListDB = Object(__WEBPACK_IMPORTED_MODULE_6_typeorm__["o" /* getRepository */])('dialog_list');
                        return [4 /*yield*/, dialogListDB.findOne({ dialog_user: message.getToAccount() })];
                    case 5:
                        chat = _a.sent();
                        if (!chat) return [3 /*break*/, 7];
                        message_2 = JSON.parse(chat.content);
                        message_2.last_message_type = chatMessage.type;
                        message_2.last_message = XiaoMiMessage_1.instance.chatUtils.formatMessageContent(chatMessage.type, chatMessage.content);
                        message_2.last_message_time = chatMessage.dateTime;
                        chat.content = JSON.stringify(message_2);
                        return [4 /*yield*/, dialogListDB.save(chat)];
                    case 6:
                        _a.sent();
                        //更新对话列表，重新排序
                        XiaoMiMessage_1.instance.chatUtils.updateDialogList();
                        _a.label = 7;
                    case 7: return [3 /*break*/, 9];
                    case 8:
                        //更新对话列表
                        console.log("更新对话列表");
                        XiaoMiMessage_1.instance.chatUtils.messageReceiveUpdate(chatMessage);
                        _a.label = 9;
                    case 9: return [2 /*return*/];
                }
            });
        });
    };
    //发送消息后，服务器接收到消息ack的回调
    XiaoMiMessage.prototype.serverAckListener = function (packetId, sequence, timeStamp, errMsg) {
        console.log("receive msg ack:" + packetId + ",sequence=" + sequence + ",ts=" + timeStamp);
        return;
    };
    XiaoMiMessage.prototype.disconnectListener = function () {
        console.log("XiaoMiMessage disconnect");
        XiaoMiMessage_1.instance.events.publish("im:disconnect");
    };
    /**
     * 发送消息
     * @param toUser 对方名称
     * @param message 消息体
     */
    XiaoMiMessage.prototype.send = function (toUser, msgType, message) {
        return new Promise(function (resolve, reject) {
            xiaomiIM.sendMsg(toUser, msgType, message).then(function (res) {
                console.log("发送成功");
                resolve(res);
            }, function (error) {
                reject(error);
            });
        });
    };
    XiaoMiMessage.prototype.updateExtra = function (toUser, extra) {
        xiaomiIM.updateDialogExtra(toUser, extra).then(function (res) {
            console.log(res);
        }, function (error) {
            console.log(error);
        });
    };
    //退出
    XiaoMiMessage.prototype.logout = function () {
        xiaomiIM.logout();
    };
    XiaoMiMessage.prototype.isInBlackList = function (toUser) {
        xiaomiIM.isInBlackList(toUser).then(function (res) {
            console.log(res);
        }, function (error) {
            console.log(error);
        });
    };
    XiaoMiMessage = XiaoMiMessage_1 = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_4__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_5_ionic_angular__["Events"],
            __WEBPACK_IMPORTED_MODULE_0__ChatUtils__["a" /* ChatUtils */],
            __WEBPACK_IMPORTED_MODULE_5_ionic_angular__["ModalController"]])
    ], XiaoMiMessage);
    return XiaoMiMessage;
    var XiaoMiMessage_1;
}());

var Base64 = function () {
    var _keyStr = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=";
    this.encode = function (input) {
        var output = "";
        var chr1, chr2, chr3, enc1, enc2, enc3, enc4;
        var i = 0;
        input = _utf8_encode(input);
        while (i < input.length) {
            chr1 = input.charCodeAt(i++);
            chr2 = input.charCodeAt(i++);
            chr3 = input.charCodeAt(i++);
            enc1 = chr1 >> 2;
            enc2 = ((chr1 & 3) << 4) | (chr2 >> 4);
            enc3 = ((chr2 & 15) << 2) | (chr3 >> 6);
            enc4 = chr3 & 63;
            if (isNaN(chr2)) {
                enc3 = enc4 = 64;
            }
            else if (isNaN(chr3)) {
                enc4 = 64;
            }
            output = output +
                _keyStr.charAt(enc1) + _keyStr.charAt(enc2) +
                _keyStr.charAt(enc3) + _keyStr.charAt(enc4);
        }
        return output;
    };
    this.decode = function (input) {
        var output = "";
        var chr1, chr2, chr3;
        var enc1, enc2, enc3, enc4;
        var i = 0;
        input = input.replace(/[^A-Za-z0-9\+\/\=]/g, "");
        while (i < input.length) {
            enc1 = _keyStr.indexOf(input.charAt(i++));
            enc2 = _keyStr.indexOf(input.charAt(i++));
            enc3 = _keyStr.indexOf(input.charAt(i++));
            enc4 = _keyStr.indexOf(input.charAt(i++));
            chr1 = (enc1 << 2) | (enc2 >> 4);
            chr2 = ((enc2 & 15) << 4) | (enc3 >> 2);
            chr3 = ((enc3 & 3) << 6) | enc4;
            output = output + String.fromCharCode(chr1);
            if (enc3 != 64) {
                output = output + String.fromCharCode(chr2);
            }
            if (enc4 != 64) {
                output = output + String.fromCharCode(chr3);
            }
        }
        output = _utf8_decode(output);
        return output;
    };
    var _utf8_encode = function (string) {
        string = string.replace(/\r\n/g, "\n");
        var utftext = "";
        for (var n = 0; n < string.length; n++) {
            var c = string.charCodeAt(n);
            if (c < 128) {
                utftext += String.fromCharCode(c);
            }
            else if ((c > 127) && (c < 2048)) {
                utftext += String.fromCharCode((c >> 6) | 192);
                utftext += String.fromCharCode((c & 63) | 128);
            }
            else {
                utftext += String.fromCharCode((c >> 12) | 224);
                utftext += String.fromCharCode(((c >> 6) & 63) | 128);
                utftext += String.fromCharCode((c & 63) | 128);
            }
        }
        return utftext;
    };
    var _utf8_decode = function (utftext) {
        var string = "";
        var i = 0;
        var c = 0;
        var c2 = 0, c3 = 0;
        while (i < utftext.length) {
            c = utftext.charCodeAt(i);
            if (c < 128) {
                string += String.fromCharCode(c);
                i++;
            }
            else if ((c > 191) && (c < 224)) {
                c2 = utftext.charCodeAt(i + 1);
                string += String.fromCharCode(((c & 31) << 6) | (c2 & 63));
                i += 2;
            }
            else {
                c2 = utftext.charCodeAt(i + 1);
                c3 = utftext.charCodeAt(i + 2);
                string += String.fromCharCode(((c & 15) << 12) | ((c2 & 63) << 6) | (c3 & 63));
                i += 3;
            }
        }
        return string;
    };
};
//# sourceMappingURL=XiaoMiMessage.js.map

/***/ }),

/***/ 658:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return ListItemData; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "b", function() { return MessageItemData; });
var ListItemData = /** @class */ (function () {
    function ListItemData() {
    }
    return ListItemData;
}());

var MessageItemData = /** @class */ (function () {
    function MessageItemData() {
        this.list = [];
    }
    return MessageItemData;
}());

//# sourceMappingURL=ListItemData.js.map

/***/ }),

/***/ 659:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CameraUtils; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__UiUtils__ = __webpack_require__(76);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__ionic_native_camera__ = __webpack_require__(253);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3_ionic_angular__ = __webpack_require__(22);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4_rxjs__ = __webpack_require__(157);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4_rxjs___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_4_rxjs__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__ionic_native_file__ = __webpack_require__(148);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};






var CameraUtils = /** @class */ (function () {
    function CameraUtils(camera, actionSheetCtrl, platform, file, uiUtils) {
        this.camera = camera;
        this.actionSheetCtrl = actionSheetCtrl;
        this.platform = platform;
        this.file = file;
        this.uiUtils = uiUtils;
    }
    CameraUtils.prototype.showCameraActionSheet = function () {
        var _this = this;
        var actionSheet = this.actionSheetCtrl.create({
            title: '编辑头像',
            buttons: [
                {
                    text: '照相机拍照',
                    icon: !this.platform.is('ios') ? 'camera' : null,
                    handler: function () {
                        _this.pictureFromCamera();
                    }
                }, {
                    text: '相册中选取',
                    icon: !this.platform.is('ios') ? 'image' : null,
                    handler: function () {
                        _this.pictureFromGallery();
                    }
                }, {
                    text: '取消',
                    icon: !this.platform.is('ios') ? 'close' : null,
                    role: 'destructive',
                    handler: function () {
                        console.log('Cancel clicked');
                    }
                }
            ]
        });
        actionSheet.present();
    };
    CameraUtils.prototype.pictureFromCamera = function () {
        var options = {
            quality: 90,
            destinationType: this.camera.DestinationType.DATA_URL,
            encodingType: this.camera.EncodingType.JPEG,
            mediaType: this.camera.MediaType.PICTURE,
            correctOrientation: true,
            allowEdit: false,
            saveToPhotoAlbum: false
        };
        return this.capturePhoto(options);
    };
    CameraUtils.prototype.pictureFromGallery = function () {
        //Added PictureSourceType.PHOTOLIBRARY to access from gallery.
        var options = {
            quality: 90,
            destinationType: this.camera.DestinationType.DATA_URL,
            encodingType: this.camera.EncodingType.JPEG,
            sourceType: this.camera.PictureSourceType.PHOTOLIBRARY,
            mediaType: this.camera.MediaType.PICTURE,
            correctOrientation: true,
            allowEdit: false,
            saveToPhotoAlbum: false
        };
        return this.capturePhoto(options);
    };
    CameraUtils.prototype.capturePhoto = function (options) {
        var _this = this;
        /*try {
          //Result is a base64 image but can be changed to use a filepath.
          //this.config.user.avatar = `data:image/jpeg;base64,${result}`;
          return this.camera.getPicture(options);
    
        }catch (e) {
          console.error(e);
        }*/
        return __WEBPACK_IMPORTED_MODULE_4_rxjs__["Observable"].create(function (observer) {
            _this.camera.getPicture(options).then(function (imgData) {
                //observer.next('data:image/jpg;base64,' + imgData);
                observer.next(imgData);
            }).catch(function (err) {
                if (err == 20) {
                    _this.uiUtils.showToast('没有权限,请在设置中开启权限');
                    return;
                }
                if (String(err).indexOf('cancel') != -1) {
                    return;
                }
                console.log('getPicture:' + err);
            });
        });
    };
    /**
    * 根据图片绝对路径转化为base64字符串
    * @param path 绝对路径
    */
    CameraUtils.prototype.convertImgToBase64 = function (path) {
        var _this = this;
        return __WEBPACK_IMPORTED_MODULE_4_rxjs__["Observable"].create(function (observer) {
            _this.file.resolveLocalFilesystemUrl(path).then(function (fileEnter) {
                fileEnter.file(function (file) {
                    var reader = new FileReader();
                    reader.onloadend = function (e) {
                        observer.next(this.result);
                    };
                    reader.readAsDataURL(file);
                });
            }).catch(function (err) {
                console.log(err, '根据图片绝对路径转化为base64字符串失败');
            });
        });
    };
    CameraUtils = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_2__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__ionic_native_camera__["a" /* Camera */],
            __WEBPACK_IMPORTED_MODULE_3_ionic_angular__["ActionSheetController"],
            __WEBPACK_IMPORTED_MODULE_3_ionic_angular__["Platform"],
            __WEBPACK_IMPORTED_MODULE_5__ionic_native_file__["a" /* File */],
            __WEBPACK_IMPORTED_MODULE_0__UiUtils__["a" /* UiUtils */]])
    ], CameraUtils);
    return CameraUtils;
}());

//# sourceMappingURL=CameraUtils.js.map

/***/ }),

/***/ 662:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return User; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_typeorm__ = __webpack_require__(6);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};

/**
 * 用户信息表
 * 用于保存：用户姓名，头像等
 */
var User = /** @class */ (function () {
    function User() {
    }
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0_typeorm__["g" /* PrimaryGeneratedColumn */])(),
        __metadata("design:type", Number)
    ], User.prototype, "id", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0_typeorm__["a" /* Column */])({ "nullable": true }),
        __metadata("design:type", String)
    ], User.prototype, "name", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0_typeorm__["a" /* Column */])({ "nullable": true }),
        __metadata("design:type", String)
    ], User.prototype, "sex", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0_typeorm__["a" /* Column */])({ "nullable": true }),
        __metadata("design:type", String)
    ], User.prototype, "avatar", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0_typeorm__["a" /* Column */])({ "nullable": true }),
        __metadata("design:type", String)
    ], User.prototype, "school", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0_typeorm__["a" /* Column */])({ "nullable": true }),
        __metadata("design:type", String)
    ], User.prototype, "schoolCode", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0_typeorm__["a" /* Column */])({ "nullable": true }),
        __metadata("design:type", String)
    ], User.prototype, "schoolLogo", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0_typeorm__["a" /* Column */])({ "nullable": true }),
        __metadata("design:type", String)
    ], User.prototype, "major", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0_typeorm__["a" /* Column */])({ "nullable": true }),
        __metadata("design:type", String)
    ], User.prototype, "wechat", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0_typeorm__["a" /* Column */])({ "nullable": true }),
        __metadata("design:type", String)
    ], User.prototype, "email", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0_typeorm__["a" /* Column */])({ "nullable": true }),
        __metadata("design:type", String)
    ], User.prototype, "targetCity", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0_typeorm__["a" /* Column */])({ "nullable": true }),
        __metadata("design:type", String)
    ], User.prototype, "targetCityCode", void 0);
    User = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0_typeorm__["b" /* Entity */])('user')
    ], User);
    return User;
}());

//# sourceMappingURL=User.js.map

/***/ }),

/***/ 663:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return Account; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_typeorm__ = __webpack_require__(6);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};

/**
 * 账户信息数据库
 * 用于保存：用户token,account_id,极光账号等
 */
var Account = /** @class */ (function () {
    function Account() {
    }
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0_typeorm__["g" /* PrimaryGeneratedColumn */])(),
        __metadata("design:type", Number)
    ], Account.prototype, "id", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0_typeorm__["a" /* Column */])({ "nullable": true }),
        __metadata("design:type", String)
    ], Account.prototype, "token", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0_typeorm__["a" /* Column */])({ "nullable": true }),
        __metadata("design:type", String)
    ], Account.prototype, "refresh_token", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0_typeorm__["a" /* Column */])({ "nullable": true }),
        __metadata("design:type", String)
    ], Account.prototype, "token_expires", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0_typeorm__["a" /* Column */])({ "nullable": true }),
        __metadata("design:type", String)
    ], Account.prototype, "account_id", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0_typeorm__["a" /* Column */])({ "nullable": true }),
        __metadata("design:type", String)
    ], Account.prototype, "resume_id", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0_typeorm__["a" /* Column */])({ "nullable": true }),
        __metadata("design:type", String)
    ], Account.prototype, "resume_number", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0_typeorm__["a" /* Column */])({ "nullable": true }),
        __metadata("design:type", String)
    ], Account.prototype, "jm_user", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0_typeorm__["a" /* Column */])({ "nullable": true }),
        __metadata("design:type", String)
    ], Account.prototype, "jm_pwd", void 0);
    Account = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0_typeorm__["b" /* Entity */])('account')
    ], Account);
    return Account;
}());

//# sourceMappingURL=Account.js.map

/***/ }),

/***/ 664:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CompanyService; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__provider_Api__ = __webpack_require__(49);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__services_BaseService__ = __webpack_require__(91);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__angular_core__ = __webpack_require__(0);
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};



var CompanyService = /** @class */ (function (_super) {
    __extends(CompanyService, _super);
    function CompanyService(api) {
        var _this = _super.call(this) || this;
        _this.api = api;
        return _this;
    }
    CompanyService.prototype.getCompanyById = function (id) {
        var _this = this;
        this.page.showLoading();
        this.subscription.add(this.api.getCompanyById(id)
            .subscribe(function (res) {
            console.log(res);
            if (res) {
                _this.page.setData(res);
            }
            _this.page.hideLoading();
        }, function (err) {
            _this.page.showMsg(err.msg);
            _this.page.hideLoading();
        }));
    };
    CompanyService.prototype.getAllJob = function (id, collegeid) {
        var _this = this;
        this.page.showLoading();
        this.subscription.add(this.api.getCompanyAllPosition(id, collegeid)
            .subscribe(function (res) {
            console.log(res);
            if (res) {
                _this.page.setAllJob(res);
            }
            _this.page.hideLoading();
        }, function (err) {
            //this.page.showMsg(err.msg);
            _this.page.hideLoading();
        }));
    };
    //获取宣讲会和招聘会
    CompanyService.prototype.getMC = function (params) {
        var _this = this;
        this.subscription.add(this.api.getCompanyAllMC(params)
            .subscribe(function (res) {
            console.log(res);
            if (res) {
                _this.page.setMC(res);
            }
        }, function (err) {
            _this.page.showMsg(err.msg);
        }));
    };
    CompanyService = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_2__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_0__provider_Api__["a" /* Api */]])
    ], CompanyService);
    return CompanyService;
}(__WEBPACK_IMPORTED_MODULE_1__services_BaseService__["a" /* BaseService */]));

//# sourceMappingURL=CompanyService.js.map

/***/ }),

/***/ 665:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return CampusTalkService; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__provider_Api__ = __webpack_require__(49);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__services_BaseService__ = __webpack_require__(91);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__angular_core__ = __webpack_require__(0);
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};



var CampusTalkService = /** @class */ (function (_super) {
    __extends(CampusTalkService, _super);
    function CampusTalkService(api) {
        var _this = _super.call(this) || this;
        _this.api = api;
        return _this;
    }
    CampusTalkService.prototype.get = function (id) {
        var _this = this;
        this.page.showLoading();
        this.subscription.add(this.api.getCampustalkById(id)
            .subscribe(function (res) {
            if (res) {
                _this.page.setData(res);
            }
            _this.page.hideLoading();
        }, function (err) {
            _this.page.hideLoading();
            if (err.error.status == 404) {
                _this.page.showMsg("宣讲会已失效！");
            }
        }));
    };
    CampusTalkService.prototype.reminder = function (id) {
        var _this = this;
        this.page.showLoading();
        this.subscription.add(this.api.reminderCampustalkById(id)
            .subscribe(function (res) {
            console.log(res);
            _this.page.reminderDone();
            _this.page.hideLoading();
        }, function (err) {
            _this.page.showMsg(err.msg);
            _this.page.hideLoading();
        }));
    };
    CampusTalkService.prototype.signin = function (id) {
        var _this = this;
        this.page.showLoading();
        this.subscription.add(this.api.campusTalkSignin(id)
            .subscribe(function (res) {
            console.log(res);
            //this.page.showMsg("签到成功！");
            _this.page.signinDone();
            _this.page.hideLoading();
        }, function (err) {
            //this.page.showMsg(err.msg);
            if (err.error.status == 409) {
                _this.page.showMsg("已签到！");
            }
            _this.page.hideLoading();
        }));
    };
    CampusTalkService.prototype.getCompany = function (id) {
        var _this = this;
        this.subscription.add(this.api.getCompanyById(id)
            .subscribe(function (res) {
            console.log(res);
            if (res) {
                _this.page.setCompanyData(res);
            }
        }, function (err) {
            //this.page.showMsg(err.msg);
        }));
    };
    CampusTalkService = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_2__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_0__provider_Api__["a" /* Api */]])
    ], CampusTalkService);
    return CampusTalkService;
}(__WEBPACK_IMPORTED_MODULE_1__services_BaseService__["a" /* BaseService */]));

//# sourceMappingURL=CampusTalkService.js.map

/***/ }),

/***/ 666:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return PopoverComponent; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(22);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};


var PopoverComponent = /** @class */ (function () {
    function PopoverComponent(viewCtrl, navParams) {
        this.viewCtrl = viewCtrl;
        this.navParams = navParams;
        this.popoverItemList = [{ icon: '', name: '置顶对话', key: 1 },
            { icon: '', name: '查看资料', key: 2 },
            { icon: '', name: '查看TA的资料', key: 3 },
            { icon: '', name: '屏蔽消息', key: 4 },
            { icon: '', name: '举报', key: 5 }];
        this.chatProperty = this.navParams.get("chatProperty");
    }
    PopoverComponent.prototype.setSelected = function (selectedItem) {
        this.viewCtrl.dismiss(selectedItem);
    };
    PopoverComponent = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'popover',template:/*ion-inline-start:"E:\workspace\TalentApp\src\components\popover\popover.html"*/'<ion-list style="padding-top:10px;" no-lines>\n    <!--\n    <button ion-item *ngFor="let item of popoverItemList" (click)="setSelected(item.key)">\n        {{item.name}}\n    </button>\n-->\n    <ion-item (click)="setSelected(1)" *ngIf="chatProperty.is_top == false">\n        <ion-avatar item-start>\n            <img src="assets/img/chat-top-icon.png" style="width:20px;height:20px;" />\n        </ion-avatar>\n        <span style="color:#333;font-size:15px;">置顶当前对话</span>\n    </ion-item>\n    <ion-item (click)="setSelected(1)" *ngIf="chatProperty.is_top == true">\n        <ion-avatar item-start>\n            <img src="assets/img/chat-top-icon.png" style="width:20px;height:20px;" />\n        </ion-avatar>\n        <span style="color:#333;font-size:15px;">取消置顶对话</span>\n    </ion-item>\n    <ion-item (click)="setSelected(2)">\n        <ion-avatar item-start>\n            <img src="assets/img/chat-glasses-icon.png" style="width:20px;height:20px;" />\n        </ion-avatar>\n        <span style="color:#333;font-size:15px;">查看公司信息</span>\n    </ion-item>\n    <ion-item (click)="setSelected(3)">\n        <ion-avatar item-start>\n            <img src="assets/img/chat-view-icon.png" style="width:20px;height:20px;" />\n        </ion-avatar>\n        <span style="color:#333;font-size:15px;"> 查看TA的资料</span>\n    </ion-item>\n    <ion-item (click)="setSelected(4)" *ngIf="chatProperty.is_active_shield == false">\n        <ion-avatar item-start>\n            <img src="assets/img/chat-shield-icon.png" style="width:20px;height:20px;" />\n        </ion-avatar>\n        <span style="color:#333;font-size:15px;">屏蔽消息</span>\n    </ion-item>\n    <ion-item (click)="setSelected(4)" *ngIf="chatProperty.is_active_shield == true">\n        <ion-avatar item-start>\n            <img src="assets/img/chat-shield-icon.png" style="width:20px;height:20px;" />\n        </ion-avatar>\n        <span style="color:#333;font-size:15px;">取消屏蔽</span>\n    </ion-item>\n    <ion-item (click)="setSelected(5)">\n        <ion-avatar item-start>\n            <img src="assets/img/chat-report-icon.png" style="width:20px;height:20px;" />\n        </ion-avatar>\n        <span style="color:#333;font-size:15px;">举报</span>\n    </ion-item>\n</ion-list>'/*ion-inline-end:"E:\workspace\TalentApp\src\components\popover\popover.html"*/
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1_ionic_angular__["ViewController"],
            __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["NavParams"]])
    ], PopoverComponent);
    return PopoverComponent;
}());

//# sourceMappingURL=popover.js.map

/***/ }),

/***/ 669:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return MilkRoundService; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__provider_Api__ = __webpack_require__(49);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__services_BaseService__ = __webpack_require__(91);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__angular_core__ = __webpack_require__(0);
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};



var MilkRoundService = /** @class */ (function (_super) {
    __extends(MilkRoundService, _super);
    function MilkRoundService(api) {
        var _this = _super.call(this) || this;
        _this.api = api;
        return _this;
    }
    MilkRoundService.prototype.get = function (id) {
        var _this = this;
        this.page.showLoading();
        this.subscription.add(this.api.getMilkRoundById(id)
            .subscribe(function (res) {
            console.log(res);
            if (res) {
                _this.page.setData(res);
            }
            _this.page.hideLoading();
        }, function (err) {
            _this.page.hideLoading();
            if (err.error.status == 404) {
                _this.page.showMsg("招聘会已失效！");
            }
        }));
    };
    MilkRoundService.prototype.signin = function (id) {
        var _this = this;
        this.page.showLoading();
        this.subscription.add(this.api.milkRoundSignin(id)
            .subscribe(function (res) {
            console.log(res);
            //this.page.showMsg("签到成功！");
            _this.page.signinDone();
            _this.page.hideLoading();
        }, function (err) {
            //this.page.showMsg(err.msg);
            if (err.error.status == 409) {
                _this.page.showMsg("已签到！");
            }
            _this.page.hideLoading();
        }));
    };
    MilkRoundService.prototype.reminder = function (id) {
        var _this = this;
        this.page.showLoading();
        this.subscription.add(this.api.reminderMilkRoundById(id)
            .subscribe(function (res) {
            console.log(res);
            if (res) {
                _this.page.reminderDone();
            }
            _this.page.hideLoading();
        }, function (err) {
            _this.page.showMsg(err.msg);
            _this.page.hideLoading();
        }));
    };
    MilkRoundService.prototype.getCompanyList = function (id, params) {
        var _this = this;
        this.page.showLoading();
        this.subscription.add(this.api.getMilkRoundCompanyList(id, params)
            .subscribe(function (res) {
            console.log(res);
            if (res) {
                _this.page.setCompanyList(res);
            }
            _this.page.hideLoading();
        }, function (err) {
            _this.page.hideLoading();
        }));
    };
    MilkRoundService.prototype.loadMoreCompany = function (id, params) {
        return this.api.getMilkRoundCompanyList(id, params);
    };
    MilkRoundService.prototype.getCompany = function (id) {
        var _this = this;
        this.subscription.add(this.api.getCompanyById(id)
            .subscribe(function (res) {
            console.log(res);
            if (res) {
                res.departmentid = id;
                _this.page.setCompanyData(res);
            }
        }, function (err) {
            //this.page.showMsg(err.msg);
            var errorMsg = JSON.parse(err.error._body);
            if (errorMsg.Errcode == "3002") {
                _this.page.jobExpired();
                _this.page.showMsg(errorMsg.Errmsg);
            }
        }));
    };
    MilkRoundService = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_2__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_0__provider_Api__["a" /* Api */]])
    ], MilkRoundService);
    return MilkRoundService;
}(__WEBPACK_IMPORTED_MODULE_1__services_BaseService__["a" /* BaseService */]));

//# sourceMappingURL=MilkRoundService.js.map

/***/ }),

/***/ 67:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return Constants; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};

var Constants = /** @class */ (function () {
    function Constants() {
    }
    /**
     * API URL
     */
    //本地
    //static ApiUrl : string = "http://192.168.0.120:801/";//API地址
    //static AgentApiUrl : string = 'http://192.168.0.120:802/';//代理地址
    //线上测试
    //static ApiUrl : string = "http://webapi.test.goworkla.cn/";//API地址
    //static AgentApiUrl : string = 'http://agent.test.goworkla.cn/';//代理地址
    //static ApiUrl : string = "http://webapi.test2.goworkla.cn/";//API地址
    //static AgentApiUrl : string = 'http://agent.test2.goworkla.cn/';//代理地址
    //生产环境
    Constants.ApiUrl = "https://webapi.goworkla.cn/"; //API地址
    Constants.AgentApiUrl = "https://agent.goworkla.cn/"; //代理地址
    Constants.ShareUrl = "https://main.goworkla.cn/share/"; //分享地址
    /**
     * 推送账号
     
    //测试环境
    static xiaomi_appId = "2882303761517878342";
    static xiaomi_appKey = "5501787897342";

    static meizu_appId = "118550";
    static meizu_appKey = "b48b1e0cf704404ea98180cbac4c4842";*/
    //生产环境
    Constants.xiaomi_appId = "2882303761517946374";
    Constants.xiaomi_appKey = "5571794614374";
    Constants.meizu_appId = "118365";
    Constants.meizu_appKey = "5559f0ba274e4987a85019e96af75828";
    /**
     * storage key name
     * 本地存储名称
     */
    Constants.LocalStorage = {
        AccessToken: "accesstoken",
        RefreshToken: "refreshtoken",
        TokenExpiresDate: "tokenexpires",
        AccountId: "accountid",
        ResumeId: "resumeid",
        ResumeNumber: "resumeNumber",
        User: "user",
        ChatFilter: "chatfilter",
        DialogList: "dialoglist",
        Setup: "setup",
        Industry: "industry",
        JmUser: "jm_user",
        JmPwd: "jm_pwd",
        SearchHistory: "search_history",
        CollegeId: "college_id",
        RegionData: "region_data" //地区字典
    };
    Constants.ClientId = "597842d6f7571bf1e597b405";
    Constants.ClientSecret = "00000000-0000-0000-0000-000000000000";
    Constants.JuniorSecretary = "JuniorSecretaryT"; //工作啦小秘书 极光账号名称
    Constants.userSkillCode = 99;
    /**
     * http header
     */
    Constants.Header = {
        AccountId: "accountid",
        AccessToken: "access_token",
        ClientId: "client_id",
        ClientSecret: "client_secret"
    };
    Constants = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Injectable"])()
    ], Constants);
    return Constants;
}());

//# sourceMappingURL=Constants.js.map

/***/ }),

/***/ 674:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return PushService; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__Constants__ = __webpack_require__(67);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(22);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__angular_core__ = __webpack_require__(0);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};



var PushService = /** @class */ (function () {
    function PushService(events) {
        this.events = events;
        console.log("PushService start");
        this.cleanListener();
        //window.addEventListener('deviceready', this.init() , false);
        //console.log(window.plugins.GwlMixPushPlugin);
    }
    /**
     * 手机厂商名称
     * Xiaomi
     * Meizu
     */
    PushService.prototype.init = function (deviceBrand) {
        console.log("PushService init");
        console.log(deviceBrand);
        switch (deviceBrand) {
            default:
            case 'xiaomi':
                window.plugins.GwlMixPushPlugin.setPushEngine([deviceBrand]);
                var appId = __WEBPACK_IMPORTED_MODULE_0__Constants__["a" /* Constants */].xiaomi_appId;
                var appKey = __WEBPACK_IMPORTED_MODULE_0__Constants__["a" /* Constants */].xiaomi_appKey;
                //开始启动注册推送
                window.plugins.GwlMixPushPlugin.registerPush([appId, appKey]);
                break;
            case 'meizu':
                window.plugins.GwlMixPushPlugin.setPushEngine([deviceBrand]);
                var appId = __WEBPACK_IMPORTED_MODULE_0__Constants__["a" /* Constants */].meizu_appId;
                var appKey = __WEBPACK_IMPORTED_MODULE_0__Constants__["a" /* Constants */].meizu_appKey;
                //window.plugins.GwlMixPushPlugin.exitPush([appId, appKey]);
                //开始启动注册推送
                window.plugins.GwlMixPushPlugin.registerPush([appId, appKey]);
                break;
            case 'honor':
            case 'huawei':
                window.plugins.GwlMixPushPlugin.setPushEngine([deviceBrand]);
                window.plugins.GwlMixPushPlugin.registerPush([]);
                break;
            case 'vivo':
                window.plugins.GwlMixPushPlugin.setPushEngine([deviceBrand]);
                window.plugins.GwlMixPushPlugin.registerPush([]);
                break;
        }
        //小米
        /*
        var deviceBrand = "Xiaomi";
        window.plugins.GwlMixPushPlugin.setPushEngine([deviceBrand]);
        var appId = "2882303761517878342";
        var appKey = "5501787897342";
        
        //开始启动注册推送
        window.plugins.GwlMixPushPlugin.registerPush([appId, appKey]);*/
        /*
        //魅族
        var deviceBrand = "Meizu";
        window.plugins.GwlMixPushPlugin.setPushEngine([deviceBrand]);
        var appId = "117142";
        var appKey = "7c9543a5d484417e8f681a6747b98f55";
        
        //开始启动注册推送
        window.plugins.GwlMixPushPlugin.registerPush([appId, appKey]);*/
        /*
        //华为 荣耀
        var deviceBrand = "huawei";
        window.plugins.GwlMixPushPlugin.setPushEngine([deviceBrand]);
        window.plugins.GwlMixPushPlugin.registerPush([]);
        */
        //Vivo
        /*
        var deviceBrand = "vivo";
        window.plugins.GwlMixPushPlugin.setPushEngine([deviceBrand]);
        //window.plugins.GwlMixPushPlugin.exitPush();//不要做off动作
        window.plugins.GwlMixPushPlugin.registerPush([]);
        
        var that = this;
        window.plugins.GwlMixPushPlugin.getRegId([],(id)=>{
            alert(id);
            if(id){
                that.onArrivedListener();
                that.onClickedListener();
            }
        },function onCallBack(error){
            alert(error);
        });*/
        var that = this;
        document.addEventListener("GwlMixPushPlugin.onRegisterPush", function onCallBack(data) {
            console.log(data);
            if (data && data.code == 200) {
                console.log('push注册成功：' + data.regId);
                if (data.regId) {
                    that.events.publish("push:register", data.regId);
                }
                /*
                window.plugins.GwlMixPushPlugin.getRegId([],(id)=>{alert(id);},function onCallBack(error){
                    alert(error);
                });
                
                window.plugins.GwlMixPushPlugin.setAlias(["Android"]);
                document.addEventListener("GwlMixPushPlugin.onSetAliasPush",function onCallBack(data) {
                    console.log("onSetAliasPush");
                    console.log(data);
                }, false);*/
                //that.onArrivedListener();
                //that.onClickedListener();
            }
            else {
                console.log('注册失败：');
            }
        }, false);
    };
    //来消息后的事件监听
    PushService.prototype.onArrivedListener = function () {
        document.addEventListener("GwlMixPushPlugin.onNotificationArrived", function onCallBack(data) {
            console.log(data);
            if (data) {
                //window.plugins.GwlMixPushPlugin.badgerApplyCount([20]);//来消息后把APP图标上的角标数字改成20
                console.log('来消息了：' + data.content);
            }
        }, false);
    };
    //点消息后的事件监听
    PushService.prototype.onClickedListener = function () {
        document.addEventListener("GwlMixPushPlugin.onNotificationClicked", function onCallBack(data) {
            console.log(data);
            if (data) {
                //window.plugins.GwlMixPushPlugin.badgerApplyCount([0]);//点消息后清空数字
                console.log('点消息了：' + data.content);
            }
        }, false);
    };
    PushService.prototype.cleanListener = function () {
        document.removeEventListener("GwlMixPushPlugin.onRegisterPush");
        //document.removeEventListener("GwlMixPushPlugin.onNotificationArrived");
        //document.removeEventListener("GwlMixPushPlugin.onNotificationClicked");
    };
    PushService = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_2__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1_ionic_angular__["Events"]])
    ], PushService);
    return PushService;
}());

//# sourceMappingURL=push.service.js.map

/***/ }),

/***/ 676:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return TabsPage; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__provider_push_service__ = __webpack_require__(674);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__provider_utils_XiaoMiMessage__ = __webpack_require__(656);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__provider_utils_AppUtils__ = __webpack_require__(123);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__TabService__ = __webpack_require__(1251);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__provider_Api__ = __webpack_require__(49);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__provider_Constants__ = __webpack_require__(67);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__provider_utils_StorageUtils__ = __webpack_require__(92);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__provider_utils_ChatUtils__ = __webpack_require__(156);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__provider_utils_UiUtils__ = __webpack_require__(76);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__provider_Config__ = __webpack_require__(48);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10_ionic_angular__ = __webpack_require__(22);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_12_date_fns_difference_in_hours__ = __webpack_require__(248);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_12_date_fns_difference_in_hours___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_12_date_fns_difference_in_hours__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_13_date_fns_add_seconds__ = __webpack_require__(93);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_13_date_fns_add_seconds___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_13_date_fns_add_seconds__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_14_typeorm__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_15__ionic_native_themeable_browser__ = __webpack_require__(606);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_16__ionic_native_device__ = __webpack_require__(675);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};


//import { DialogList } from './../../entity/DialogList';







//import { JMessageUtils } from './../../provider/utils/JMessageUtils';









var TabsPage = /** @class */ (function () {
    function TabsPage(events, navCtrl, 
        //public jm : JMessageUtils,
        uiUtils, appUtils, ref, local, api, app, service, navParams, themeableBrowser, im, push, device, chatUtils) {
        var _this = this;
        this.events = events;
        this.navCtrl = navCtrl;
        this.uiUtils = uiUtils;
        this.appUtils = appUtils;
        this.ref = ref;
        this.local = local;
        this.api = api;
        this.app = app;
        this.service = service;
        this.navParams = navParams;
        this.themeableBrowser = themeableBrowser;
        this.im = im;
        this.push = push;
        this.device = device;
        this.chatUtils = chatUtils;
        this.tab1Root = 'JobListPage';
        this.tab2Root = 'CampusPage';
        this.tab3Root = 'MessagePage'; //小米消息云通道 
        this.tab4Root = 'MyPage';
        this.jobBadgeCount = '';
        this.findBadgeCount = '';
        this.chatBadgeCount = '';
        this.myBadgeCount = '';
        this.jmLoginCount = 0;
        this.config = __WEBPACK_IMPORTED_MODULE_9__provider_Config__["a" /* Config */].getInstance();
        this.service.init(this);
        //console.log(this.device.manufacturer);
        //console.log(this.device.platform);
        console.log(this.device.uuid);
        console.log(this.device.serial);
        if (!this.config.isWeb) {
            this.accountDB = Object(__WEBPACK_IMPORTED_MODULE_14_typeorm__["o" /* getRepository */])('account');
            //this.jm.initAppIm();
            /**
             * 外部打开APP判断 跳转页面
             * 外部链接格式:gwltalent://页面/参数
             */
            this.externalInterval = setInterval(function () {
                var external_url = window.localStorage.getItem("external_load");
                if (external_url) {
                    window.localStorage.removeItem("external_load");
                    external_url = external_url.replace("gwltalent://", "");
                    var params = external_url.split("/");
                    console.log("外部链接跳转");
                    console.log(params);
                    if (params[0]) {
                        switch (params[0]) {
                            case 'job-details'://职位详情
                                _this.navCtrl.push('JobDetailsPage', { "id": params[1] });
                                break;
                            case 'resmue'://简历
                                _this.navCtrl.push('MyResumePreviewPage', { "id": params[1] });
                                break;
                            case 'campus-talk'://宣讲会
                                _this.navCtrl.push('CampusTalkPage', { "id": params[1] });
                                break;
                            case 'milk-round'://招聘会
                                _this.navCtrl.push('MilkRoundPage', { "id": params[1] });
                                break;
                            case 'milk-round-live'://招聘会现场
                                _this.navCtrl.push('MilkRoundLivePage', { "id": params[1] });
                                break;
                            case 'college'://学校主页
                                _this.navCtrl.push('CollegePage', { "id": params[1] });
                                break;
                        }
                    }
                }
            }, 1500);
            //检测升级
            this.service.checkAppUpdate();
        }
        else {
            //二维码扫描 企业 进入企业详情
            var company = this.navParams.get("company");
            if (company) {
                var params = { "company": company };
                this.navCtrl.push("CompanyPage", params);
            }
        }
        /**
         * 定时刷新在线
         * 检查token
         */
        this.onlineInterval = setInterval(function () {
            _this.online();
            _this.checkToken();
        }, 1000 * 60 * 60 * 2); //2个小时
        //极光消息登录
        //this.jMLogin();
        this.IMLogin(); //小米消息云登录
        this.initPush(); //推送初始化
        this.events.subscribe('push:register', function (value) {
            console.log('push:register');
            console.log(value);
            if (value) {
                _this.appUtils.getVersionNumber().then(function (version) {
                    var params = {
                        "uuid": _this.device.serial,
                        "regid": value,
                        "brand": _this.device.manufacturer,
                        "model": _this.device.model,
                        "operating_system": _this.device.platform,
                        "operating_system_version": _this.device.version,
                        "app_version": version
                    };
                    _this.service.postPushRegId(params);
                });
            }
        });
        var that = this;
        window.plugins.intent.setNewIntentHandler(function (Intent) {
            console.log("window.plugins.intent.setNewIntentHandler");
            console.log(Intent.action);
            if (Intent.action !== 'android.intent.action.MAIN') {
                var action = JSON.parse(Intent.action);
                console.log(action);
                console.log(action.content);
                //let content = JSON.parse(action.content);
                switch (action.type) {
                    case 'milkround':
                        that.navCtrl.push("MilkRoundPage", { id: action.content.id });
                        break;
                    case 'campustalk':
                        that.navCtrl.push("CampusTalkPage", { id: action.content.id });
                        break;
                    case 'im':
                        that.navCtrl.push("MessageDetailsPage", { toJmUserId: action.content.username });
                        break;
                }
            }
        }, function () {
            console.log('Error');
        });
        this.events.subscribe('im:disconnect', function () {
            console.log('im:disconnect-->relogin');
            _this.IMLogin();
        });
    }
    // 页面即将进入的时候,在这里可以做页面初始化的一些事情
    TabsPage.prototype.ionViewWillEnter = function () {
        console.log("tabs page will enter");
        this.checkToken();
        //检查极光登录
        /*
        this.jm.checkIsLogin().then(islogin=>{
          if(!islogin){
            this.jMLogin();
          }else{
            this.jm.onMsgReceive();
            this.openMessageNotification();
          }
        })*/
    };
    TabsPage.prototype.ionViewDidLoad = function () {
        console.log('Tabs ionViewDidLoad');
        this.chatUtils.initUnReadTotal();
        //初始化设置中的选项
        //this.initSetup();
        /**
         * 极光消息监听
         
        this.events.subscribe('jmessage:receive', (value) => {
          console.log('Tabs page jmessage:receive');
          console.log(value);
          console.log(this.config.unReadTotal);
    
          if(!this.config.enterConversation){
            this.config.unReadTotal += 1;
          }
          
          //强制更新
          if(!this.ref['destroyed']){
            this.ref.markForCheck();
            this.ref.detectChanges();
          }
    
          this.chatUtils.messageReceiveUpdate(value);
        });*/
        /**
         * 极光消息登录状态变更事件监听
         
        this.events.subscribe('jmessage:loginStateChanged', (value) => {
          console.log('jmessage:loginStateChanged');
          console.log(value);
          this.uiUtils.confirmDialog('提示','您的账号在其他平台登录,是否重新登录？(如非本人操作,请尽快修改密码)','退出', '重新登录').then(()=>{
    
            this.jm.logout();//极光退出
    
            this.jMLogin();
          },()=>{
             this.logout();
          });
        });*/
    };
    /*
    async logout(){
  
      this.local.clear();
      //this.jm.logout();//极光退出
  
      if(!this.config.isWeb){
        let dialogListDB = getRepository('dialog_list') as Repository<DialogList>;
        let dialogDB = getRepository('dialog') as Repository<Dialog>;
  
        let accountDB = getRepository('account') as Repository<Account>;
        let userDB = getRepository('user') as Repository<User>;
  
        //清除对话列表
        let list = await dialogListDB.find();
        await dialogListDB.remove(list);
  
        //清除对话内容
        let chat = await dialogDB.find();
        await dialogDB.remove(chat);
  
        //清除账户信息
        let account = await accountDB.find();
        await accountDB.remove(account);
  
        //清除用户信息
        let user = await userDB.find();
        await userDB.remove(user);
      }
  
      this.config.token = null;
      this.config.account_id = null;
      this.config.resume_id = null;
      this.config.resume_number = null;
      this.config.jm_login_fail = false;
  
      this.config.education = new Array();
      this.config.skills = new Array();
      this.config.proSkills = new Array();
      this.config.workExperiences = null;
      this.config.training = null;
      this.config.certificates = null;
      this.config.opus = null;
      this.config.project = null;
  
      this.config.user.avatar = null;
  
      this.config.jobTarget = {expect_salary : null,
        expect_salary_text : "",
        industry : [],
        subid :  null,
        work_city : [],
        work_nature : null,
        work_nature_text : "",
      };
  
      this.config.dialogueShieldArray = new Array();
      this.config.searchHistory = new Array();
  
      this.app.getRootNav().setRoot('LoginStudentIdPage');
    }*/
    //界面销毁
    TabsPage.prototype.ionViewWillUnload = function () {
        console.log('Tabs ionViewWillUnload');
        clearInterval(this.externalInterval);
        clearInterval(this.onlineInterval);
        this.service.destroy();
        this.events.unsubscribe("push:register");
        this.events.unsubscribe("im:disconnect");
    };
    //小米消息云登录
    TabsPage.prototype.IMLogin = function () {
        var _this = this;
        if (this.config.jm_login_user) {
            this.im.login(this.config.jm_login_user);
        }
        else {
            this.api.getAccount()
                .subscribe(function (res) { return __awaiter(_this, void 0, void 0, function () {
                var account;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            console.log(res);
                            if (!res.accountid) return [3 /*break*/, 5];
                            this.config.jm_login_user = res.jm_username;
                            this.config.jm_login_pwd = res.jm_password;
                            if (!!this.config.isWeb) return [3 /*break*/, 3];
                            return [4 /*yield*/, this.accountDB.findOne()];
                        case 1:
                            account = _a.sent();
                            account.jm_user = res.jm_username;
                            account.jm_pwd = res.jm_password;
                            return [4 /*yield*/, this.accountDB.save(account)];
                        case 2:
                            _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            this.local.set(__WEBPACK_IMPORTED_MODULE_5__provider_Constants__["a" /* Constants */].LocalStorage.JmUser, res.jm_username);
                            this.local.set(__WEBPACK_IMPORTED_MODULE_5__provider_Constants__["a" /* Constants */].LocalStorage.JmPwd, res.jm_password);
                            _a.label = 4;
                        case 4:
                            this.IMLogin();
                            _a.label = 5;
                        case 5: return [2 /*return*/];
                    }
                });
            }); }, function (err) {
                _this.uiUtils.showToast(err.msg);
                _this.uiUtils.hideLoading();
            });
        }
    };
    TabsPage.prototype.initPush = function () {
        this.push.init(this.device.manufacturer.toLowerCase());
    };
    /**
     * 极光IM登录
     
    jMLogin(){
      if(this.config.jm_login_user && this.config.jm_login_pwd){
  
        let params = {
          'username': this.config.jm_login_user,
          'password': this.config.jm_login_pwd
        };
        let initData = {};
  
        if(!this.config.isWeb){
          if(!this.config.jm_login_fail){
  
            this.jm.clearListener();
  
            this.jm.login(initData,params).then(res => {
              if(res == 'login'){
                console.log("极光IM登录成功");
  
                this.config.jm_login_fail = false;
                this.jmLoginCount = 0;
  
                this.jm.getNoDisturbGlobal().then(res => {
                  console.log("getNoDisturbGlobal : " + res);
                  if(!res){
                    //关闭全局消息免打扰
                    this.jm.setNoDisturbGlobal({isNoDisturb: false});
                  }
                });
  
                //通知栏点击处理
                this.jm.onOpenMessage();
  
                //防止系统杀掉极光通讯 2分钟再次登录
                //this.jmTestMessage();
              }else{
                //极光登录失败处理
                console.log("极光登录失败");
                console.log(res);
                this.jmLoginCount++;
                console.log("极光登录失败计数 :" + this.jmLoginCount);
                if(this.jmLoginCount > 5){
                  this.config.jm_login_fail = true;
                }
  
                setTimeout(() => {
                  this.jMLogin();
                },1000 * 5);
              }
            },error=>{
              //极光登录失败处理
              console.log("极光登录错误");
  
              this.jmLoginCount++;
              console.log("极光登录失败计数 :" + this.jmLoginCount);
              if(this.jmLoginCount > 5){
                this.config.jm_login_fail = true;
              }
  
              setTimeout(() => {
                this.jMLogin();
              },1000 * 5);
            });
          }
        }else{
  
          this.api.getJmInitData()
              .subscribe((res: any) => {
                console.log("获取极光web im初始化参数")
                console.log(res);
  
                this.jm.login(res,params).then(res => {
                  if(res == 'login'){
                    console.log("极光Web IM登录成功");
                  //this.uiUtils.hideLoading();
                  }else{
                    console.log(res);
  
                    setTimeout(() => {
                      this.jMLogin();
                    },1000 * 5)
                  }
                });
              });
        }
  
      }else{
        this.api.getAccount()
            .subscribe(async (res: any) => {
                console.log(res);
                if(res.accountid){
                    this.config.jm_login_user = res.jm_username;
                    this.config.jm_login_pwd = res.jm_password;
  
                    if(!this.config.isWeb){
                      let account = await this.accountDB.findOne();
                      account.jm_user = res.jm_username;
                      account.jm_pwd = res.jm_password;
  
                      await this.accountDB.save(account);
                    }else{
                      this.local.set(Constants.LocalStorage.JmUser,res.jm_username);
                      this.local.set(Constants.LocalStorage.JmPwd,res.jm_password);
                    }
  
                    this.jMLogin();
                }
            }, err => {
                this.uiUtils.showToast(err.msg);
                this.uiUtils.hideLoading();
            })
      }
    }*/
    //极光发送测试信息 防止系统杀死通讯
    /*
    jmTestMessage(){
      if(this.config.token){
        let jm_params = {
          'type': 'single',
          'username': this.config.goworkla_jm_test,
          'text' : 't',
        };
  
        this.jm.sendMessage(jm_params).then(value=>{
            console.log("极光发送测试信息");
            console.log(value);
        },(error)=>{
            console.log("测试消息发送失败");
        });
  
        setTimeout(() => {
          this.jmTestMessage();
        },1000 * 60 * 2);
      }
    }*/
    /**
     * 添加点击通知栏消息通知事件监听
     
    openMessageNotification(){
      this.jm.onOpenMessage().then((msg)=>{
        this.chatUtils.getNotificationParams(msg).then((page_params)=>{
          console.log(page_params);
          //this.uiUtils.openNewPage('ChatDetailsPage', page_params);
          this.navCtrl.push('ChatDetailsPage', page_params);
        });
      });
    }*/
    TabsPage.prototype.initSetup = function () {
        var _this = this;
        this.local.get(__WEBPACK_IMPORTED_MODULE_5__provider_Constants__["a" /* Constants */].LocalStorage.Setup).then(function (setup) {
            console.log("initSetup");
            console.log(setup);
            if (setup) {
                _this.config.setup.notification = setup.notification;
                /*
                if(!this.config.isWeb){
                  this.jm.setNoDisturbGlobal({'isNoDisturb': setup.notification});
                }*/
            }
            else {
                /*
                if(!this.config.isWeb){
                  this.jm.setNoDisturbGlobal({'isNoDisturb': this.config.setup.notification});//关闭免打扰
                }*/
                _this.local.set(__WEBPACK_IMPORTED_MODULE_5__provider_Constants__["a" /* Constants */].LocalStorage.Setup, _this.config.setup);
            }
        });
    };
    TabsPage.prototype.checkToken = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            var account, hours;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!!this.config.isWeb) return [3 /*break*/, 2];
                        return [4 /*yield*/, this.accountDB.findOne()];
                    case 1:
                        account = _a.sent();
                        if (account) {
                            console.log("TokenExpiresDate");
                            console.log(account.token_expires);
                            hours = __WEBPACK_IMPORTED_MODULE_12_date_fns_difference_in_hours__(new Date(account.token_expires), new Date());
                            console.log(hours);
                            if (hours < 5) {
                                this.refreshToken();
                            }
                        }
                        return [3 /*break*/, 3];
                    case 2:
                        this.local.get(__WEBPACK_IMPORTED_MODULE_5__provider_Constants__["a" /* Constants */].LocalStorage.TokenExpiresDate).then(function (res) {
                            console.log("TokenExpiresDate");
                            console.log(res);
                            var hours = __WEBPACK_IMPORTED_MODULE_12_date_fns_difference_in_hours__(new Date(res), new Date());
                            console.log(hours);
                            if (hours < 5) {
                                _this.refreshToken();
                            }
                        });
                        _a.label = 3;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    TabsPage.prototype.refreshToken = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            var token, account, res, params;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!!this.config.isWeb) return [3 /*break*/, 2];
                        return [4 /*yield*/, this.accountDB.findOne()];
                    case 1:
                        account = _a.sent();
                        token = account.refresh_token;
                        return [3 /*break*/, 4];
                    case 2: return [4 /*yield*/, this.local.get(__WEBPACK_IMPORTED_MODULE_5__provider_Constants__["a" /* Constants */].LocalStorage.RefreshToken)];
                    case 3:
                        res = _a.sent();
                        token = res;
                        _a.label = 4;
                    case 4:
                        params = {
                            "grant_type": "refresh_token",
                            "code": '',
                            "refresh_token": token,
                            "loginname": '',
                            "password": '',
                            "login_source": '',
                        };
                        console.log("refreshToken");
                        console.log(params);
                        this.api.getToken(params)
                            .subscribe(function (res) { return __awaiter(_this, void 0, void 0, function () {
                            var expiresDate, account;
                            return __generator(this, function (_a) {
                                switch (_a.label) {
                                    case 0:
                                        console.log("refresh_token =>" + res.access_token);
                                        this.config.token = res.access_token;
                                        expiresDate = __WEBPACK_IMPORTED_MODULE_13_date_fns_add_seconds__(new Date(), res.expires_in);
                                        console.log(expiresDate);
                                        if (!!this.config.isWeb) return [3 /*break*/, 3];
                                        return [4 /*yield*/, this.accountDB.findOne()];
                                    case 1:
                                        account = _a.sent();
                                        account.token = res.access_token;
                                        account.refresh_token = res.refresh_token;
                                        account.token_expires = expiresDate;
                                        return [4 /*yield*/, this.accountDB.save(account)];
                                    case 2:
                                        _a.sent();
                                        return [3 /*break*/, 4];
                                    case 3:
                                        this.local.set(__WEBPACK_IMPORTED_MODULE_5__provider_Constants__["a" /* Constants */].LocalStorage.AccessToken, res.access_token);
                                        this.local.set(__WEBPACK_IMPORTED_MODULE_5__provider_Constants__["a" /* Constants */].LocalStorage.RefreshToken, res.refresh_token);
                                        this.local.set(__WEBPACK_IMPORTED_MODULE_5__provider_Constants__["a" /* Constants */].LocalStorage.TokenExpiresDate, expiresDate);
                                        _a.label = 4;
                                    case 4: return [2 /*return*/];
                                }
                            });
                        }); }, function (err) {
                            _this.uiUtils.showToast(err.msg);
                        });
                        return [2 /*return*/];
                }
            });
        });
    };
    /**
     * 更新在线时间
     */
    TabsPage.prototype.online = function () {
        this.api.online()
            .subscribe(function (res) {
            console.log("online");
        }, function (err) {
            console.log(err);
        });
    };
    /**
     * APP软件检测升级
     * @param res
     */
    TabsPage.prototype.checkUpdate = function (res) {
        var _this = this;
        if (res) {
            console.log("远端版本号：" + res.version);
            this.appUtils.getVersionNumber().then(function (value) {
                console.log("本机版本号：" + value);
                if (_this.appUtils.hasNewVersion(res.version, value)) {
                    //console.log("hasNewVersion");
                    if (res.force) {
                        _this.uiUtils.confirmDialogOneBtn('软件升级', res.desc).then(function () {
                            console.log(res.url);
                            _this.checkVersion(res.url);
                            //this.appUtils.downloadApp(res.url);
                            //应用宝地址
                            //this.uiUtils.openUrlByBrowser("http://a.app.qq.com/o/simple.jsp?pkgname=gowork.student.app&from=singlemessage");
                        });
                    }
                    else {
                        _this.uiUtils.confirmDialog("软件升级", res.desc).then(function () {
                            console.log(res.url);
                            _this.checkVersion(res.url);
                            //this.appUtils.downloadApp(res.url);
                            //应用宝地址
                            //this.uiUtils.openUrlByBrowser("http://a.app.qq.com/o/simple.jsp?pkgname=gowork.student.app&from=singlemessage");
                        }, function () {
                            console.log('cancel');
                        });
                    }
                }
            });
        }
    };
    //更新版本
    TabsPage.prototype.checkVersion = function (url) {
        //浏览器插件
        var options = {
            statusbar: {
                color: '#ffffffff'
            },
            toolbar: {
                height: 44,
                color: '#f0f0f0ff'
            },
            title: {
                color: '#003264ff',
                showPageTitle: true
            },
            backButton: {
                image: 'back',
                imagePressed: 'back_pressed',
                align: 'left',
                event: 'backPressed'
            },
            forwardButton: {
                image: 'forward',
                imagePressed: 'forward_pressed',
                align: 'left',
                event: 'forwardPressed'
            },
            closeButton: {
                image: 'close',
                imagePressed: 'close_pressed',
                align: 'left',
                event: 'closePressed'
            },
            customButtons: [
                {
                    image: 'share',
                    imagePressed: 'share_pressed',
                    align: 'right',
                    event: 'sharePressed'
                }
            ],
            menu: {
                image: 'menu',
                imagePressed: 'menu_pressed',
                title: 'Test',
                cancel: 'Cancel',
                align: 'right',
                items: [
                    {
                        event: 'helloPressed',
                        label: 'Hello World!'
                    },
                    {
                        event: 'testPressed',
                        label: 'Test!'
                    }
                ]
            },
            backButtonCanClose: true
        };
        if (this.config.isIOS) {
            this.themeableBrowser.create('https://itunes.apple.com/cn/app/%E5%B7%A5%E4%BD%9C%E5%95%A6/id1358629798', '_blank', options);
        }
        else {
            this.themeableBrowser.create(url, '_system', options);
        }
    };
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_11__angular_core__["ViewChild"])('mainTabs'),
        __metadata("design:type", __WEBPACK_IMPORTED_MODULE_10_ionic_angular__["Tabs"])
    ], TabsPage.prototype, "tabs", void 0);
    TabsPage = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_11__angular_core__["Component"])({template:/*ion-inline-start:"E:\workspace\TalentApp\src\pages\tabs\tabs.html"*/'<ion-tabs #mainTabs>\n    <ion-tab [root]="tab1Root" tabTitle="首页" tabIcon="gwlhome"></ion-tab>\n    <ion-tab [root]="tab2Root" tabTitle="校园+" tabIcon="discover"></ion-tab>\n    <ion-tab [root]="tab3Root" tabTitle="消息" tabIcon="chat" [tabBadge]="config.unReadTotal" tabBadgeStyle="danger"></ion-tab>\n    <ion-tab [root]="tab4Root" tabTitle="我的" tabIcon="mine"></ion-tab>\n</ion-tabs>'/*ion-inline-end:"E:\workspace\TalentApp\src\pages\tabs\tabs.html"*/,
            providers: [__WEBPACK_IMPORTED_MODULE_3__TabService__["a" /* TabService */]]
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_10_ionic_angular__["Events"],
            __WEBPACK_IMPORTED_MODULE_10_ionic_angular__["NavController"],
            __WEBPACK_IMPORTED_MODULE_8__provider_utils_UiUtils__["a" /* UiUtils */],
            __WEBPACK_IMPORTED_MODULE_2__provider_utils_AppUtils__["a" /* APPUtils */],
            __WEBPACK_IMPORTED_MODULE_11__angular_core__["ChangeDetectorRef"],
            __WEBPACK_IMPORTED_MODULE_6__provider_utils_StorageUtils__["a" /* StorageUtils */],
            __WEBPACK_IMPORTED_MODULE_4__provider_Api__["a" /* Api */],
            __WEBPACK_IMPORTED_MODULE_10_ionic_angular__["App"],
            __WEBPACK_IMPORTED_MODULE_3__TabService__["a" /* TabService */],
            __WEBPACK_IMPORTED_MODULE_10_ionic_angular__["NavParams"],
            __WEBPACK_IMPORTED_MODULE_15__ionic_native_themeable_browser__["a" /* ThemeableBrowser */],
            __WEBPACK_IMPORTED_MODULE_1__provider_utils_XiaoMiMessage__["a" /* XiaoMiMessage */],
            __WEBPACK_IMPORTED_MODULE_0__provider_push_service__["a" /* PushService */],
            __WEBPACK_IMPORTED_MODULE_16__ionic_native_device__["a" /* Device */],
            __WEBPACK_IMPORTED_MODULE_7__provider_utils_ChatUtils__["a" /* ChatUtils */]])
    ], TabsPage);
    return TabsPage;
}());

//# sourceMappingURL=tabs.js.map

/***/ }),

/***/ 677:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return WapLoginStudentService; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__provider_utils_Validators__ = __webpack_require__(249);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__provider_Api__ = __webpack_require__(49);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__services_BaseService__ = __webpack_require__(91);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4_date_fns_add_seconds__ = __webpack_require__(93);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4_date_fns_add_seconds___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_4_date_fns_add_seconds__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__provider_utils_StorageUtils__ = __webpack_require__(92);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__provider_Constants__ = __webpack_require__(67);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__provider_Config__ = __webpack_require__(48);
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};








var WapLoginStudentService = /** @class */ (function (_super) {
    __extends(WapLoginStudentService, _super);
    function WapLoginStudentService(api, local) {
        var _this = _super.call(this) || this;
        _this.api = api;
        _this.local = local;
        return _this;
    }
    WapLoginStudentService.prototype.login = function (params) {
        var _this = this;
        if (__WEBPACK_IMPORTED_MODULE_0__provider_utils_Validators__["a" /* Validators */].isEmpty(params.code)) {
            this.page.showMsg("请选择学校!");
        }
        else if (__WEBPACK_IMPORTED_MODULE_0__provider_utils_Validators__["a" /* Validators */].isEmpty(params.no)) {
            this.page.showMsg("请输入学号!");
        }
        else if (__WEBPACK_IMPORTED_MODULE_0__provider_utils_Validators__["a" /* Validators */].isEmpty(params.password)) {
            this.page.showMsg("请输入密码!");
        }
        else {
            this.page.showLoading();
            this.subscription.add(this.api.getCodeForStudentId(params)
                .subscribe(function (res) {
                console.log("code =>" + res.value);
                _this.getToken(res.value);
                _this.page.hideLoading();
            }, function (err) {
                console.log(err);
                _this.page.hideLoading();
                var errorMsg = JSON.parse(err.error._body);
                _this.page.showMsg(errorMsg.Errmsg);
            }));
        }
    };
    WapLoginStudentService.prototype.getToken = function (user_code) {
        var _this = this;
        var params = {
            "grant_type": "authorization_code",
            "code": user_code,
            "refresh_token": '',
            "loginname": '',
            "password": '',
            "login_source": '',
        };
        this.subscription.add(this.api.getToken(params)
            .subscribe(function (res) { return __awaiter(_this, void 0, void 0, function () {
            var expiresDate;
            return __generator(this, function (_a) {
                console.log("access_token =>" + res.access_token);
                __WEBPACK_IMPORTED_MODULE_7__provider_Config__["a" /* Config */].getInstance().token = res.access_token;
                expiresDate = __WEBPACK_IMPORTED_MODULE_4_date_fns_add_seconds__(new Date(), res.expires_in);
                this.local.set(__WEBPACK_IMPORTED_MODULE_6__provider_Constants__["a" /* Constants */].LocalStorage.AccessToken, res.access_token);
                this.local.set(__WEBPACK_IMPORTED_MODULE_6__provider_Constants__["a" /* Constants */].LocalStorage.RefreshToken, res.refresh_token);
                this.local.set(__WEBPACK_IMPORTED_MODULE_6__provider_Constants__["a" /* Constants */].LocalStorage.TokenExpiresDate, expiresDate);
                this.getAccount();
                return [2 /*return*/];
            });
        }); }, function (err) {
            _this.page.showMsg(err.msg);
            _this.page.hideLoading();
        }));
    };
    WapLoginStudentService.prototype.getAccount = function () {
        var _this = this;
        __WEBPACK_IMPORTED_MODULE_7__provider_Config__["a" /* Config */].getInstance().account_id = "";
        this.subscription.add(this.api.getAccount()
            .subscribe(function (res) { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                console.log(res);
                if (res.accountid) {
                    __WEBPACK_IMPORTED_MODULE_7__provider_Config__["a" /* Config */].getInstance().account_id = res.accountid;
                    __WEBPACK_IMPORTED_MODULE_7__provider_Config__["a" /* Config */].getInstance().jm_login_user = res.jm_username;
                    __WEBPACK_IMPORTED_MODULE_7__provider_Config__["a" /* Config */].getInstance().jm_login_pwd = res.jm_password;
                    this.local.set(__WEBPACK_IMPORTED_MODULE_6__provider_Constants__["a" /* Constants */].LocalStorage.AccountId, res.accountid);
                    this.local.set(__WEBPACK_IMPORTED_MODULE_6__provider_Constants__["a" /* Constants */].LocalStorage.JmUser, res.jm_username);
                    this.local.set(__WEBPACK_IMPORTED_MODULE_6__provider_Constants__["a" /* Constants */].LocalStorage.JmPwd, res.jm_password);
                    this.getUserInfo();
                    //this.page.loginDone();
                }
                else {
                    this.page.hideLoading();
                    this.local.clear();
                }
                return [2 /*return*/];
            });
        }); }, function (err) {
            var errorMsg = JSON.parse(err.error._body);
            _this.page.showMsg(errorMsg.Errmsg);
            _this.page.hideLoading();
        }));
    };
    WapLoginStudentService.prototype.getResume = function () {
        var _this = this;
        this.subscription.add(this.api.getResume()
            .subscribe(function (res) { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                console.log(res);
                this.page.hideLoading();
                if (res.resumeid) {
                    __WEBPACK_IMPORTED_MODULE_7__provider_Config__["a" /* Config */].getInstance().resume_id = res.resumeid;
                    __WEBPACK_IMPORTED_MODULE_7__provider_Config__["a" /* Config */].getInstance().resume_number = res.resume_number;
                    this.local.set(__WEBPACK_IMPORTED_MODULE_6__provider_Constants__["a" /* Constants */].LocalStorage.ResumeId, res.resumeid);
                    this.local.set(__WEBPACK_IMPORTED_MODULE_6__provider_Constants__["a" /* Constants */].LocalStorage.ResumeNumber, res.resume_number);
                    __WEBPACK_IMPORTED_MODULE_7__provider_Config__["a" /* Config */].getInstance().user.name = res.talent_base.name;
                    if (res.talent_base.logo) {
                        __WEBPACK_IMPORTED_MODULE_7__provider_Config__["a" /* Config */].getInstance().user.avatar = res.talent_base.logo;
                    }
                    else {
                        if (res.talent_base.gender == "01") {
                            __WEBPACK_IMPORTED_MODULE_7__provider_Config__["a" /* Config */].getInstance().user.avatar = __WEBPACK_IMPORTED_MODULE_7__provider_Config__["a" /* Config */].getInstance().maleDefaultAvatar;
                        }
                        else if (res.talent_base.gender == "02") {
                            __WEBPACK_IMPORTED_MODULE_7__provider_Config__["a" /* Config */].getInstance().user.avatar = __WEBPACK_IMPORTED_MODULE_7__provider_Config__["a" /* Config */].getInstance().femaleDefaultAvatar;
                        }
                        else {
                            __WEBPACK_IMPORTED_MODULE_7__provider_Config__["a" /* Config */].getInstance().user.avatar = __WEBPACK_IMPORTED_MODULE_7__provider_Config__["a" /* Config */].getInstance().userDefaultAvatar;
                        }
                    }
                    __WEBPACK_IMPORTED_MODULE_7__provider_Config__["a" /* Config */].getInstance().user.wechat = res.talent_base.wechat;
                    __WEBPACK_IMPORTED_MODULE_7__provider_Config__["a" /* Config */].getInstance().user.email = res.talent_base.email;
                    __WEBPACK_IMPORTED_MODULE_7__provider_Config__["a" /* Config */].getInstance().userMobile = res.talent_base.mobile;
                    __WEBPACK_IMPORTED_MODULE_7__provider_Config__["a" /* Config */].getInstance().studentId = res.talent_base.no;
                    __WEBPACK_IMPORTED_MODULE_7__provider_Config__["a" /* Config */].getInstance().collegeId = res.talent_base.collegeid;
                    if (res.education_backgrounds) {
                        __WEBPACK_IMPORTED_MODULE_7__provider_Config__["a" /* Config */].getInstance().user.school = res.education_backgrounds[0].graduation_school;
                        __WEBPACK_IMPORTED_MODULE_7__provider_Config__["a" /* Config */].getInstance().user.schoolCode = res.education_backgrounds[0].school_code;
                        __WEBPACK_IMPORTED_MODULE_7__provider_Config__["a" /* Config */].getInstance().user.major = res.education_backgrounds[0].major_status_text;
                    }
                    __WEBPACK_IMPORTED_MODULE_7__provider_Config__["a" /* Config */].getInstance().education = res.education_backgrounds; //教育经历
                    __WEBPACK_IMPORTED_MODULE_7__provider_Config__["a" /* Config */].getInstance().resumeLevel = res.level; //简历完整度
                    if (res.job_target.work_city[0]) {
                        __WEBPACK_IMPORTED_MODULE_7__provider_Config__["a" /* Config */].getInstance().user.targetCity = res.job_target.work_city[0].text;
                        __WEBPACK_IMPORTED_MODULE_7__provider_Config__["a" /* Config */].getInstance().user.targetCityCode = res.job_target.work_city[0].code;
                    }
                    this.local.set(__WEBPACK_IMPORTED_MODULE_6__provider_Constants__["a" /* Constants */].LocalStorage.User, __WEBPACK_IMPORTED_MODULE_7__provider_Config__["a" /* Config */].getInstance().user);
                    if (res.skills && res.skills.length > 0) {
                        __WEBPACK_IMPORTED_MODULE_7__provider_Config__["a" /* Config */].getInstance().skills = res.skills; //技能
                        __WEBPACK_IMPORTED_MODULE_7__provider_Config__["a" /* Config */].getInstance().proSkills = res.pro_skills; //职业技能
                        __WEBPACK_IMPORTED_MODULE_7__provider_Config__["a" /* Config */].getInstance().jobTarget = res.job_target; //职位筛选条件
                        __WEBPACK_IMPORTED_MODULE_7__provider_Config__["a" /* Config */].getInstance().workExperiences = res.work_experiences; //工作经历
                        __WEBPACK_IMPORTED_MODULE_7__provider_Config__["a" /* Config */].getInstance().training = res.training_experiences; //培训经历
                        __WEBPACK_IMPORTED_MODULE_7__provider_Config__["a" /* Config */].getInstance().certificates = res.certificates; //证书
                        __WEBPACK_IMPORTED_MODULE_7__provider_Config__["a" /* Config */].getInstance().opus = res.works; //作品
                        __WEBPACK_IMPORTED_MODULE_7__provider_Config__["a" /* Config */].getInstance().project = res.project_experiences; //项目/比赛经历
                        __WEBPACK_IMPORTED_MODULE_7__provider_Config__["a" /* Config */].getInstance().career = res.job_target.career;
                        __WEBPACK_IMPORTED_MODULE_7__provider_Config__["a" /* Config */].getInstance().unReadTotal = 0;
                        //this.page.loginHome();
                        this.page.loginDone();
                    }
                    else {
                        //this.page.loginNext();
                        this.page.loginDone();
                    }
                    //初始化消息：清除所有会话和记录
                    /*
                    let list = await this.dialogListDB.find();
                    if(list){
                        await this.dialogListDB.remove(list);
                    }
                    
                    let chat = await this.dialogDB.find();
                    if(chat){
                        await this.dialogDB.remove(chat);
                    }*/
                    //Config.getInstance().dialogList = new Array();
                    /*
                    this.local.get(Constants.LocalStorage.DialogList).then((list) => {
                        if(list){
                            for(let i = 0;i < list.length;i++){
                                this.local.remove(list[i].dlid);
                            }
                        }
                        
                        this.local.remove(Constants.LocalStorage.DialogList);
                        Config.getInstance().dialogList = new Array();
                        Config.getInstance().unReadTotal = 0;
                    });*/
                    //this.page.goHome();
                }
                return [2 /*return*/];
            });
        }); }, function (err) {
            _this.page.showMsg(err.msg);
            _this.page.hideLoading();
        }));
    };
    WapLoginStudentService.prototype.getUserInfo = function () {
        var _this = this;
        this.subscription.add(this.api.getUserInfo()
            .subscribe(function (res) {
            console.log(res);
            if (res.mobile_actived == false || !res.mobile) {
                _this.page.bindingMobile();
            }
            else {
                _this.getResume();
            }
        }, function (err) {
            var errorMsg = JSON.parse(err.error._body);
            _this.page.showMsg(errorMsg.Errmsg);
            _this.page.hideLoading();
        }));
    };
    WapLoginStudentService = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_3__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__provider_Api__["a" /* Api */],
            __WEBPACK_IMPORTED_MODULE_5__provider_utils_StorageUtils__["a" /* StorageUtils */]])
    ], WapLoginStudentService);
    return WapLoginStudentService;
}(__WEBPACK_IMPORTED_MODULE_2__services_BaseService__["a" /* BaseService */]));

//# sourceMappingURL=WapLoginStudentService.js.map

/***/ }),

/***/ 678:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
Object.defineProperty(__webpack_exports__, "__esModule", { value: true });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_platform_browser_dynamic__ = __webpack_require__(679);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__app_module__ = __webpack_require__(683);


Object(__WEBPACK_IMPORTED_MODULE_0__angular_platform_browser_dynamic__["a" /* platformBrowserDynamic */])().bootstrapModule(__WEBPACK_IMPORTED_MODULE_1__app_module__["a" /* AppModule */]);
//# sourceMappingURL=main.js.map

/***/ }),

/***/ 683:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AppModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__pages_company_CompanyService__ = __webpack_require__(664);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__components_popover_popover__ = __webpack_require__(666);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__pages_milk_round_MilkRoundService__ = __webpack_require__(669);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__pages_wap_login_student_id_WapLoginStudentService__ = __webpack_require__(677);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__pages_campus_talk_CampusTalkService__ = __webpack_require__(665);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__provider_utils_ChatUtils__ = __webpack_require__(156);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__provider_utils_CameraUtils__ = __webpack_require__(659);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__provider_utils_EncryptUtils__ = __webpack_require__(648);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__angular_platform_browser_animations__ = __webpack_require__(1269);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__ionic_native_app_version__ = __webpack_require__(604);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__ionic_native_network__ = __webpack_require__(603);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__angular_platform_browser__ = __webpack_require__(54);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_12__ionic_native_in_app_browser__ = __webpack_require__(646);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_13__provider_http_HttpService__ = __webpack_require__(266);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_14__provider_utils_StorageUtils__ = __webpack_require__(92);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_15__provider_Config__ = __webpack_require__(48);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_16__ionic_native_screen_orientation__ = __webpack_require__(651);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_17__provider_utils_Validators__ = __webpack_require__(249);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_18__provider_Api__ = __webpack_require__(49);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_19__provider_utils_UiUtils__ = __webpack_require__(76);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_20__provider_utils_AppUtils__ = __webpack_require__(123);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_21__provider_utils_DateUtils__ = __webpack_require__(155);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_22__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_23_ionic_angular__ = __webpack_require__(22);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_24__app_component__ = __webpack_require__(1271);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_25_ionic_image_loader__ = __webpack_require__(657);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_26__ionic_native_status_bar__ = __webpack_require__(652);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_27__ionic_native_splash_screen__ = __webpack_require__(653);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_28__ionic_native_toast__ = __webpack_require__(647);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_29__angular_http__ = __webpack_require__(649);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_30__ionic_storage__ = __webpack_require__(406);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_31__ionic_native_camera__ = __webpack_require__(253);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_32__ionic_native_native_page_transitions__ = __webpack_require__(668);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_33__ionic_native_app_minimize__ = __webpack_require__(654);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_34__ionic_native_photo_viewer__ = __webpack_require__(660);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_35__ionic_native_clipboard__ = __webpack_require__(672);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_36__ionic_native_call_number__ = __webpack_require__(667);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_37__modal_transitions__ = __webpack_require__(1272);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_38__ionic_native_sqlite__ = __webpack_require__(1273);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_39__ionic_native_qr_scanner__ = __webpack_require__(673);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_40__ionic_native_file_transfer__ = __webpack_require__(605);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_41_ngx_date_fns__ = __webpack_require__(655);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_42_ion2_calendar__ = __webpack_require__(671);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_42_ion2_calendar___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_42_ion2_calendar__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_43__ionic_native_themeable_browser__ = __webpack_require__(606);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};








//import { JMessageUtils } from './../provider/utils/JMessageUtils';






























//数据库






var AppModule = /** @class */ (function () {
    /**
     * 自定义modal显示方式
     */
    function AppModule(ionicConfig) {
        this.ionicConfig = ionicConfig;
        this.setCustomTransitions();
    }
    AppModule.prototype.setCustomTransitions = function () {
        this.ionicConfig.setTransition('modal-from-right-enter', __WEBPACK_IMPORTED_MODULE_37__modal_transitions__["c" /* ModalFromRightEnter */]);
        this.ionicConfig.setTransition('modal-from-right-leave', __WEBPACK_IMPORTED_MODULE_37__modal_transitions__["d" /* ModalFromRightLeave */]);
        this.ionicConfig.setTransition('modal-from-bottom-enter', __WEBPACK_IMPORTED_MODULE_37__modal_transitions__["b" /* ModalFromBottomtEnter */]);
        this.ionicConfig.setTransition('modal-from-bottom-leave', __WEBPACK_IMPORTED_MODULE_37__modal_transitions__["a" /* ModalFromBottomLeave */]);
        this.ionicConfig.setTransition('modal-from-top-enter', __WEBPACK_IMPORTED_MODULE_37__modal_transitions__["e" /* ModalFromTopEnter */]);
        this.ionicConfig.setTransition('modal-from-top-leave', __WEBPACK_IMPORTED_MODULE_37__modal_transitions__["f" /* ModalFromTopLeave */]);
        this.ionicConfig.setTransition('modal-scale-enter', __WEBPACK_IMPORTED_MODULE_37__modal_transitions__["g" /* ModalScaleEnter */]);
        this.ionicConfig.setTransition('modal-scale-leave', __WEBPACK_IMPORTED_MODULE_37__modal_transitions__["h" /* ModalScaleLeave */]);
    };
    AppModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_22__angular_core__["NgModule"])({
            declarations: [
                __WEBPACK_IMPORTED_MODULE_24__app_component__["a" /* MyApp */],
                __WEBPACK_IMPORTED_MODULE_1__components_popover_popover__["a" /* PopoverComponent */]
            ],
            imports: [
                __WEBPACK_IMPORTED_MODULE_11__angular_platform_browser__["a" /* BrowserModule */],
                __WEBPACK_IMPORTED_MODULE_8__angular_platform_browser_animations__["a" /* BrowserAnimationsModule */],
                __WEBPACK_IMPORTED_MODULE_29__angular_http__["c" /* HttpModule */],
                __WEBPACK_IMPORTED_MODULE_42_ion2_calendar__["CalendarModule"],
                __WEBPACK_IMPORTED_MODULE_25_ionic_image_loader__["b" /* IonicImageLoader */].forRoot(),
                __WEBPACK_IMPORTED_MODULE_30__ionic_storage__["a" /* IonicStorageModule */].forRoot(),
                __WEBPACK_IMPORTED_MODULE_23_ionic_angular__["IonicModule"].forRoot(__WEBPACK_IMPORTED_MODULE_24__app_component__["a" /* MyApp */], {
                    scrollAssist: false,
                    autoFocusAssist: false,
                    platforms: {
                        android: {
                            backButtonText: "",
                            //backButtonIcon: "md-arrow-back",
                            iconMode: "ios",
                            mode: 'ios',
                            modalEnter: "modal-md-slide-in",
                            modalLeave: "modal-md-slide-out",
                            pageTransition: "md-transition",
                            tabsPlacement: 'bottom',
                            tabsHideOnSubPages: 'true'
                        },
                        ios: {
                            backButtonText: "",
                            //backButtonIcon: "ios-arrow-back",
                            iconMode: "ios",
                            modalEnter: "modal-md-slide-in",
                            modalLeave: "modal-md-slide-out",
                            pageTransition: "ios-transition",
                            tabsPlacement: 'bottom',
                            tabsHideOnSubPages: 'true'
                        }
                    }
                }, {
                    links: [
                        { loadChildren: '../pages/about/about.module#AboutPageModule', name: 'AboutPage', segment: 'about', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/binding-mobile/binding-mobile.module#BindingMobilePageModule', name: 'BindingMobilePage', segment: 'binding-mobile', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/binding-student-id/binding-student-id.module#BindingStudentIdPageModule', name: 'BindingStudentIdPage', segment: 'binding-student-id', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/campus-college-info/campus-college-info.module#CampusCollegeInfoPageModule', name: 'CampusCollegeInfoPage', segment: 'campus-college-info', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/campus-company/campus-company.module#CampusCompanyPageModule', name: 'CampusCompanyPage', segment: 'campus-company', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/campus-employment-offices/campus-employment-offices.module#CampusEmploymentOfficesPageModule', name: 'CampusEmploymentOfficesPage', segment: 'campus-employment-offices', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/campus-file-search/campus-file-search.module#CampusFileSearchPageModule', name: 'CampusFileSearchPage', segment: 'campus-file-search', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/campus-nav-more/campus-nav-more.module#CampusNavMorePageModule', name: 'CampusNavMorePage', segment: 'campus-nav-more', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/campus-online-faq-create/campus-online-faq-create.module#CampusOnlineFaqCreatePageModule', name: 'CampusOnlineFaqCreatePage', segment: 'campus-online-faq-create', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/campus-online-faq/campus-online-faq.module#CampusOnlineFaqPageModule', name: 'CampusOnlineFaqPage', segment: 'campus-online-faq', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/campus-position/campus-position.module#CampusPositionPageModule', name: 'CampusPositionPage', segment: 'campus-position', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/campus-talk/campus-talk.module#CampusTalkPageModule', name: 'CampusTalkPage', segment: 'campus-talk', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/campus/campus.module#CampusPageModule', name: 'CampusPage', segment: 'campus', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/chat-details/chat-details.module#ChatDetailsPageModule', name: 'ChatDetailsPage', segment: 'chat-details', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/chat-faq/chat-faq.module#ChatFaqPageModule', name: 'ChatFaqPage', segment: 'chat-faq', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/chat-filter/chat-filter.module#ChatFilterPageModule', name: 'ChatFilterPage', segment: 'chat-filter', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/chat-message-language/chat-message-language.module#ChatMessageLanguagePageModule', name: 'ChatMessageLanguagePage', segment: 'chat-message-language', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/chat-more-options/chat-more-options.module#ChatMoreOptionsPageModule', name: 'ChatMoreOptionsPage', segment: 'chat-more-options', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/chat/chat.module#ChatPageModule', name: 'ChatPage', segment: 'chat', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/college-campus-talk/college-campus-talk.module#CollegeCampusTalkPageModule', name: 'CollegeCampusTalkPage', segment: 'college-campus-talk', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/college-career-consult-details/college-career-consult-details.module#CollegeCareerConsultDetailsPageModule', name: 'CollegeCareerConsultDetailsPage', segment: 'college-career-consult-details', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/college-career-consult/college-career-consult.module#CollegeCareerConsultPageModule', name: 'CollegeCareerConsultPage', segment: 'college-career-consult', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/college-faculty-details/college-faculty-details.module#CollegeFacultyDetailsPageModule', name: 'CollegeFacultyDetailsPage', segment: 'college-faculty-details', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/college-faculty/college-faculty.module#CollegeFacultyPageModule', name: 'CollegeFacultyPage', segment: 'college-faculty', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/college-info-search/college-info-search.module#CollegeInfoSearchPageModule', name: 'CollegeInfoSearchPage', segment: 'college-info-search', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/college-job-info-details/college-job-info-details.module#CollegeJobInfoDetailsPageModule', name: 'CollegeJobInfoDetailsPage', segment: 'college-job-info-details', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/college-job-info/college-job-info.module#CollegeJobInfoPageModule', name: 'CollegeJobInfoPage', segment: 'college-job-info', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/college-milk-round/college-milk-round.module#CollegeMilkRoundPageModule', name: 'CollegeMilkRoundPage', segment: 'college-milk-round', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/college-position-brief-details/college-position-brief-details.module#CollegePositionBriefDetailsPageModule', name: 'CollegePositionBriefDetailsPage', segment: 'college-position-brief-details', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/college-position-brief/college-position-brief.module#CollegePositionBriefPageModule', name: 'CollegePositionBriefPage', segment: 'college-position-brief', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/college/college.module#CollegePageModule', name: 'CollegePage', segment: 'college', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/company/company.module#CompanyPageModule', name: 'CompanyPage', segment: 'company', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/feedback/feedback.module#FeedbackPageModule', name: 'FeedbackPage', segment: 'feedback', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/image-view/image-view.module#ImageViewPageModule', name: 'ImageViewPage', segment: 'image-view', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/interview-agenda/interview-agenda.module#InterviewAgendaPageModule', name: 'InterviewAgendaPage', segment: 'interview-agenda', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/interview-details/interview-details.module#InterviewDetailsPageModule', name: 'InterviewDetailsPage', segment: 'interview-details', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/job-details/job-details.module#JobDetailsPageModule', name: 'JobDetailsPage', segment: 'job-details', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/job-intension/job-intension.module#JobIntensionPageModule', name: 'JobIntensionPage', segment: 'job-intension', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/job-list/job-list.module#JobListPageModule', name: 'JobListPage', segment: 'job-list', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/job-subscription/job-subscription.module#JobSubscriptionPageModule', name: 'JobSubscriptionPage', segment: 'job-subscription', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/login-college/login-college.module#LoginCollegePageModule', name: 'LoginCollegePage', segment: 'login-college', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/login-for-test/login-for-test.module#LoginForTestPageModule', name: 'LoginForTestPage', segment: 'login-for-test', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/login-position-skill/login-position-skill.module#LoginPositionSkillPageModule', name: 'LoginPositionSkillPage', segment: 'login-position-skill', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/login-position/login-position.module#LoginPositionPageModule', name: 'LoginPositionPage', segment: 'login-position', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/login-student-id/login-student-id.module#LoginStudentIdPageModule', name: 'LoginStudentIdPage', segment: 'login-student-id', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/login-user-profile/login-user-profile.module#LoginUserProfilePageModule', name: 'LoginUserProfilePage', segment: 'login-user-profile', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/login-user-skill/login-user-skill.module#LoginUserSkillPageModule', name: 'LoginUserSkillPage', segment: 'login-user-skill', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/login/login.module#LoginPageModule', name: 'LoginPage', segment: 'login', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/message-details/message-details.module#MessageDetailsPageModule', name: 'MessageDetailsPage', segment: 'message-details', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/message/message.module#MessagePageModule', name: 'MessagePage', segment: 'message', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/milk-round-live-position/milk-round-live-position.module#MilkRoundLivePositionPageModule', name: 'MilkRoundLivePositionPage', segment: 'milk-round-live-position', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/milk-round/milk-round.module#MilkRoundPageModule', name: 'MilkRoundPage', segment: 'milk-round', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/milk-round-live/milk-round-live.module#MilkRoundLivePageModule', name: 'MilkRoundLivePage', segment: 'milk-round-live', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/modal-image-cropper/modal-image-cropper.module#ModalImageCropperPageModule', name: 'ModalImageCropperPage', segment: 'modal-image-cropper', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/modal-input/modal-input.module#ModalInputPageModule', name: 'ModalInputPage', segment: 'modal-input', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/modal-notification/modal-notification.module#ModalNotificationPageModule', name: 'ModalNotificationPage', segment: 'modal-notification', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/my-chat-history/my-chat-history.module#MyChatHistoryPageModule', name: 'MyChatHistoryPage', segment: 'my-chat-history', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/modal-share/modal-share.module#ModalSharePageModule', name: 'ModalSharePage', segment: 'modal-share', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/my-collection/my-collection.module#MyCollectionPageModule', name: 'MyCollectionPage', segment: 'my-collection', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/my-delivery/my-delivery.module#MyDeliveryPageModule', name: 'MyDeliveryPage', segment: 'my-delivery', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/my-order/my-order.module#MyOrderPageModule', name: 'MyOrderPage', segment: 'my-order', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/my-profile-email/my-profile-email.module#MyProfileEmailPageModule', name: 'MyProfileEmailPage', segment: 'my-profile-email', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/my-profile-name/my-profile-name.module#MyProfileNamePageModule', name: 'MyProfileNamePage', segment: 'my-profile-name', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/my-profile-wechat/my-profile-wechat.module#MyProfileWechatPageModule', name: 'MyProfileWechatPage', segment: 'my-profile-wechat', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/my-profile/my-profile.module#MyProfilePageModule', name: 'MyProfilePage', segment: 'my-profile', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/my-qr-code/my-qr-code.module#MyQrCodePageModule', name: 'MyQrCodePage', segment: 'my-qr-code', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/my-resume-certificate-agency/my-resume-certificate-agency.module#MyResumeCertificateAgencyPageModule', name: 'MyResumeCertificateAgencyPage', segment: 'my-resume-certificate-agency', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/my-resume-certificate-name/my-resume-certificate-name.module#MyResumeCertificateNamePageModule', name: 'MyResumeCertificateNamePage', segment: 'my-resume-certificate-name', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/my-resume-certificate/my-resume-certificate.module#MyResumeCertificatePageModule', name: 'MyResumeCertificatePage', segment: 'my-resume-certificate', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/my-resume-education-editor/my-resume-education-editor.module#MyResumeEducationEditorPageModule', name: 'MyResumeEducationEditorPage', segment: 'my-resume-education-editor', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/my-resume-interested/my-resume-interested.module#MyResumeInterestedPageModule', name: 'MyResumeInterestedPage', segment: 'my-resume-interested', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/my-resume-match-description/my-resume-match-description.module#MyResumeMatchDescriptionPageModule', name: 'MyResumeMatchDescriptionPage', segment: 'my-resume-match-description', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/my-resume-match-link/my-resume-match-link.module#MyResumeMatchLinkPageModule', name: 'MyResumeMatchLinkPage', segment: 'my-resume-match-link', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/my-resume-match-name/my-resume-match-name.module#MyResumeMatchNamePageModule', name: 'MyResumeMatchNamePage', segment: 'my-resume-match-name', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/my-resume-match-post/my-resume-match-post.module#MyResumeMatchPostPageModule', name: 'MyResumeMatchPostPage', segment: 'my-resume-match-post', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/my-resume-match/my-resume-match.module#MyResumeMatchPageModule', name: 'MyResumeMatchPage', segment: 'my-resume-match', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/my-resume-more/my-resume-more.module#MyResumeMorePageModule', name: 'MyResumeMorePage', segment: 'my-resume-more', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/my-resume-opus-description/my-resume-opus-description.module#MyResumeOpusDescriptionPageModule', name: 'MyResumeOpusDescriptionPage', segment: 'my-resume-opus-description', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/my-resume-opus-link/my-resume-opus-link.module#MyResumeOpusLinkPageModule', name: 'MyResumeOpusLinkPage', segment: 'my-resume-opus-link', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/my-resume-opus-name/my-resume-opus-name.module#MyResumeOpusNamePageModule', name: 'MyResumeOpusNamePage', segment: 'my-resume-opus-name', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/my-resume-opus/my-resume-opus.module#MyResumeOpusPageModule', name: 'MyResumeOpusPage', segment: 'my-resume-opus', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/my-resume-preview/my-resume-preview.module#MyResumePreviewPageModule', name: 'MyResumePreviewPage', segment: 'my-resume-preview', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/my-resume-training-course/my-resume-training-course.module#MyResumeTrainingCoursePageModule', name: 'MyResumeTrainingCoursePage', segment: 'my-resume-training-course', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/my-resume-training-name/my-resume-training-name.module#MyResumeTrainingNamePageModule', name: 'MyResumeTrainingNamePage', segment: 'my-resume-training-name', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/my-resume-training/my-resume-training.module#MyResumeTrainingPageModule', name: 'MyResumeTrainingPage', segment: 'my-resume-training', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/my-resume-viewed/my-resume-viewed.module#MyResumeViewedPageModule', name: 'MyResumeViewedPage', segment: 'my-resume-viewed', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/my-resume-work-description-template/my-resume-work-description-template.module#MyResumeWorkDescriptionTemplatePageModule', name: 'MyResumeWorkDescriptionTemplatePage', segment: 'my-resume-work-description-template', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/my-resume-work-description/my-resume-work-description.module#MyResumeWorkDescriptionPageModule', name: 'MyResumeWorkDescriptionPage', segment: 'my-resume-work-description', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/my-resume-work-editor/my-resume-work-editor.module#MyResumeWorkEditorPageModule', name: 'MyResumeWorkEditorPage', segment: 'my-resume-work-editor', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/my-resume-work-title/my-resume-work-title.module#MyResumeWorkTitlePageModule', name: 'MyResumeWorkTitlePage', segment: 'my-resume-work-title', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/my-resume/my-resume.module#MyResumePageModule', name: 'MyResumePage', segment: 'my-resume', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/my-skill-add/my-skill-add.module#MySkillAddPageModule', name: 'MySkillAddPage', segment: 'my-skill-add', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/my-skill-editor/my-skill-editor.module#MySkillEditorPageModule', name: 'MySkillEditorPage', segment: 'my-skill-editor', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/my-skill/my-skill.module#MySkillPageModule', name: 'MySkillPage', segment: 'my-skill', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/my/my.module#MyPageModule', name: 'MyPage', segment: 'my', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/position-add/position-add.module#PositionAddPageModule', name: 'PositionAddPage', segment: 'position-add', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/position-skill-add/position-skill-add.module#PositionSkillAddPageModule', name: 'PositionSkillAddPage', segment: 'position-skill-add', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/position-skill-editor/position-skill-editor.module#PositionSkillEditorPageModule', name: 'PositionSkillEditorPage', segment: 'position-skill-editor', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/position-skill-select/position-skill-select.module#PositionSkillSelectPageModule', name: 'PositionSkillSelectPage', segment: 'position-skill-select', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/privacy-policy/privacy-policy.module#PrivacyPolicyPageModule', name: 'PrivacyPolicyPage', segment: 'privacy-policy', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/publisher/publisher.module#PublisherPageModule', name: 'PublisherPage', segment: 'publisher', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/report/report.module#ReportPageModule', name: 'ReportPage', segment: 'report', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/rest-password/rest-password.module#RestPasswordPageModule', name: 'RestPasswordPage', segment: 'rest-password', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/scanner/scanner.module#ScannerPageModule', name: 'ScannerPage', segment: 'scanner', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/search/search.module#SearchPageModule', name: 'SearchPage', segment: 'search', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/select-city-district-modal/select-city-district-modal.module#SelectCityDistrictModalPageModule', name: 'SelectCityDistrictModalPage', segment: 'select-city-district-modal', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/select-city-modal/select-city-modal.module#SelectCityModalPageModule', name: 'SelectCityModalPage', segment: 'select-city-modal', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/select-city/select-city.module#SelectCityPageModule', name: 'SelectCityPage', segment: 'select-city', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/select-skill-modal/select-skill-modal.module#SelectSkillModalPageModule', name: 'SelectSkillModalPage', segment: 'select-skill-modal', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/selector-industry/selector-industry.module#SelectorIndustryPageModule', name: 'SelectorIndustryPage', segment: 'selector-industry', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/selector/selector.module#SelectorPageModule', name: 'SelectorPage', segment: 'selector', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/setup-user-mobile/setup-user-mobile.module#SetupUserMobilePageModule', name: 'SetupUserMobilePage', segment: 'setup-user-mobile', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/setup-user-password/setup-user-password.module#SetupUserPasswordPageModule', name: 'SetupUserPasswordPage', segment: 'setup-user-password', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/setup/setup.module#SetupPageModule', name: 'SetupPage', segment: 'setup', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/signup-center/signup-center.module#SignupCenterPageModule', name: 'SignupCenterPage', segment: 'signup-center', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/student-info/student-info.module#StudentInfoPageModule', name: 'StudentInfoPage', segment: 'student-info', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/subscription-add/subscription-add.module#SubscriptionAddPageModule', name: 'SubscriptionAddPage', segment: 'subscription-add', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/subscription-editor/subscription-editor.module#SubscriptionEditorPageModule', name: 'SubscriptionEditorPage', segment: 'subscription-editor', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/tabs/tabs.module#TabsPageModule', name: 'TabsPage', segment: 'tabs', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/wap-campus-talk/wap-campus-talk.module#WapCampusTalkPageModule', name: 'WapCampusTalkPage', segment: 'wap-campus-talk', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/wap-chat-default/wap-chat-default.module#WapChatDefaultPageModule', name: 'WapChatDefaultPage', segment: 'wap-chat-default', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/wap-company/wap-company.module#WapCompanyPageModule', name: 'WapCompanyPage', segment: 'wap-company', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/wap-default/wap-default.module#WapDefaultPageModule', name: 'WapDefaultPage', segment: 'wap-default', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/wap-job-list-default/wap-job-list-default.module#WapJobListDefaultPageModule', name: 'WapJobListDefaultPage', segment: 'wap-job-list-default', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/wap-login-student-id/wap-login-student-id.module#WapLoginStudentIdPageModule', name: 'WapLoginStudentIdPage', segment: 'wap-login-student-id', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/wap-milk-round/wap-milk-round.module#WapMilkRoundPageModule', name: 'WapMilkRoundPage', segment: 'wap-milk-round', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/wap-my-default/wap-my-default.module#WapMyDefaultPageModule', name: 'WapMyDefaultPage', segment: 'wap-my-default', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/wap-tabs/wap-tabs.module#WapTabsPageModule', name: 'WapTabsPage', segment: 'wap-tabs', priority: 'low', defaultHistory: [] },
                        { loadChildren: '../pages/welcome/welcome.module#WelcomePageModule', name: 'WelcomePage', segment: 'welcome', priority: 'low', defaultHistory: [] }
                    ]
                })
            ],
            bootstrap: [__WEBPACK_IMPORTED_MODULE_23_ionic_angular__["IonicApp"]],
            entryComponents: [
                __WEBPACK_IMPORTED_MODULE_24__app_component__["a" /* MyApp */],
                __WEBPACK_IMPORTED_MODULE_1__components_popover_popover__["a" /* PopoverComponent */]
            ],
            providers: [
                __WEBPACK_IMPORTED_MODULE_26__ionic_native_status_bar__["a" /* StatusBar */],
                __WEBPACK_IMPORTED_MODULE_27__ionic_native_splash_screen__["a" /* SplashScreen */],
                __WEBPACK_IMPORTED_MODULE_28__ionic_native_toast__["a" /* Toast */],
                __WEBPACK_IMPORTED_MODULE_33__ionic_native_app_minimize__["a" /* AppMinimize */],
                __WEBPACK_IMPORTED_MODULE_34__ionic_native_photo_viewer__["a" /* PhotoViewer */],
                __WEBPACK_IMPORTED_MODULE_35__ionic_native_clipboard__["a" /* Clipboard */],
                __WEBPACK_IMPORTED_MODULE_12__ionic_native_in_app_browser__["a" /* InAppBrowser */],
                __WEBPACK_IMPORTED_MODULE_41_ngx_date_fns__["a" /* DateFnsConfigurationService */],
                { provide: __WEBPACK_IMPORTED_MODULE_22__angular_core__["ErrorHandler"], useClass: __WEBPACK_IMPORTED_MODULE_23_ionic_angular__["IonicErrorHandler"] },
                __WEBPACK_IMPORTED_MODULE_15__provider_Config__["a" /* Config */],
                __WEBPACK_IMPORTED_MODULE_20__provider_utils_AppUtils__["a" /* APPUtils */],
                __WEBPACK_IMPORTED_MODULE_21__provider_utils_DateUtils__["a" /* DateUtils */],
                __WEBPACK_IMPORTED_MODULE_19__provider_utils_UiUtils__["a" /* UiUtils */],
                __WEBPACK_IMPORTED_MODULE_14__provider_utils_StorageUtils__["a" /* StorageUtils */],
                __WEBPACK_IMPORTED_MODULE_13__provider_http_HttpService__["a" /* HttpService */],
                __WEBPACK_IMPORTED_MODULE_7__provider_utils_EncryptUtils__["a" /* EncryptUtils */],
                __WEBPACK_IMPORTED_MODULE_18__provider_Api__["a" /* Api */],
                __WEBPACK_IMPORTED_MODULE_17__provider_utils_Validators__["a" /* Validators */],
                __WEBPACK_IMPORTED_MODULE_16__ionic_native_screen_orientation__["a" /* ScreenOrientation */],
                __WEBPACK_IMPORTED_MODULE_10__ionic_native_network__["a" /* Network */],
                __WEBPACK_IMPORTED_MODULE_9__ionic_native_app_version__["a" /* AppVersion */],
                //JMessageUtils,
                __WEBPACK_IMPORTED_MODULE_31__ionic_native_camera__["a" /* Camera */],
                __WEBPACK_IMPORTED_MODULE_36__ionic_native_call_number__["a" /* CallNumber */],
                //Keyboard,
                __WEBPACK_IMPORTED_MODULE_40__ionic_native_file_transfer__["a" /* FileTransfer */],
                __WEBPACK_IMPORTED_MODULE_6__provider_utils_CameraUtils__["a" /* CameraUtils */],
                __WEBPACK_IMPORTED_MODULE_5__provider_utils_ChatUtils__["a" /* ChatUtils */],
                __WEBPACK_IMPORTED_MODULE_38__ionic_native_sqlite__["a" /* SQLite */],
                __WEBPACK_IMPORTED_MODULE_39__ionic_native_qr_scanner__["a" /* QRScanner */],
                __WEBPACK_IMPORTED_MODULE_32__ionic_native_native_page_transitions__["a" /* NativePageTransitions */],
                __WEBPACK_IMPORTED_MODULE_4__pages_campus_talk_CampusTalkService__["a" /* CampusTalkService */],
                __WEBPACK_IMPORTED_MODULE_2__pages_milk_round_MilkRoundService__["a" /* MilkRoundService */],
                __WEBPACK_IMPORTED_MODULE_0__pages_company_CompanyService__["a" /* CompanyService */],
                __WEBPACK_IMPORTED_MODULE_3__pages_wap_login_student_id_WapLoginStudentService__["a" /* WapLoginStudentService */],
                __WEBPACK_IMPORTED_MODULE_43__ionic_native_themeable_browser__["a" /* ThemeableBrowser */],
            ],
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_23_ionic_angular__["Config"]])
    ], AppModule);
    return AppModule;
}());

//# sourceMappingURL=app.module.js.map

/***/ }),

/***/ 76:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return UiUtils; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__Config__ = __webpack_require__(48);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_ionic_angular__ = __webpack_require__(22);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__ionic_native_in_app_browser__ = __webpack_require__(646);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__ionic_native_toast__ = __webpack_require__(647);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};





var UiUtils = /** @class */ (function () {
    function UiUtils(loadingCtrl, toastCtrl, toast, //原生组件
        alertCtrl, inAppBrowser, app) {
        this.loadingCtrl = loadingCtrl;
        this.toastCtrl = toastCtrl;
        this.toast = toast;
        this.alertCtrl = alertCtrl;
        this.inAppBrowser = inAppBrowser;
        this.app = app;
        this.loadingIsOpen = false;
    }
    /**
    * 通过浏览器打开url
    */
    UiUtils.prototype.openUrlByBrowser = function (url) {
        this.inAppBrowser.create(url, '_system');
    };
    /**
    * 统一调用此方法显示loading
    * @param content 显示的内容
    */
    UiUtils.prototype.showLoading = function (content) {
        var _this = this;
        if (content === void 0) { content = ''; }
        if (!this.loadingIsOpen) {
            this.loadingIsOpen = true;
            this.loading = this.loadingCtrl.create({
                spinner: 'ios',
                content: content
            });
            this.loading.present();
            setTimeout(function () {
                _this.hideLoading();
            }, 1000 * 10);
        }
    };
    ;
    /**
     * 关闭loading
     */
    UiUtils.prototype.hideLoading = function () {
        this.loadingIsOpen && this.loading.dismiss();
        this.loadingIsOpen = false;
    };
    ;
    /**
     * 统一调用此方法显示提示信息
     * @param message 信息内容
     * @param duration 显示时长
     */
    UiUtils.prototype.showToast = function (message, position) {
        if (message === void 0) { message = '操作错误'; }
        if (position === void 0) { position = "center"; }
        /*
        return new Promise((resolve,reject)=>{
            let toast = this.toastCtrl.create({
                message: message,
                duration: duration,
                position: 'middle',
                showCloseButton:false,
                closeButtonText:"关闭",
                dismissOnPageChange: true,
            })
            
            toast.onDidDismiss(() => {
              resolve();
            });
            toast.present();
        });*/
        if (!__WEBPACK_IMPORTED_MODULE_0__Config__["a" /* Config */].getInstance().isWeb) {
            // 'top', 'center', or 'bottom'
            /*
            this.toast.show(message,'2000', position).subscribe(
                toast => {
                    //console.log(toast);
                }
            );*/
            var toast = this.toastCtrl.create({
                message: message,
                duration: 2000,
                position: 'middle',
                showCloseButton: false,
                dismissOnPageChange: true,
            });
            toast.present();
        }
        else {
            var toast = this.toastCtrl.create({
                message: message,
                duration: 2000,
                position: 'middle',
                showCloseButton: false,
                dismissOnPageChange: true,
            });
            toast.present();
        }
    };
    /**
     * 打开新页面
     * @param newPage
     * @param params
     */
    UiUtils.prototype.openNewPage = function (newPage, params) {
        if (params === void 0) { params = undefined; }
        if (params) {
            this.app.getRootNav().push(newPage, params);
        }
        else {
            this.app.getRootNav().push(newPage);
        }
    };
    UiUtils.prototype.alertDialog = function (_title, msg, btn_txt) {
        if (btn_txt === void 0) { btn_txt = '知道啦'; }
        var alert = this.alertCtrl.create({
            title: _title,
            message: msg,
            buttons: [btn_txt],
            enableBackdropDismiss: true
        });
        alert.present();
    };
    /**
     * 例子：
        this.uiUtils.confirmDialog('test','test').then(()=>{
        console.log('ok');
        },()=>{
        console.log('cancel');
        });
     */
    UiUtils.prototype.confirmDialog = function (_title, msg, cancel_btn, ok_btn) {
        var _this = this;
        if (cancel_btn === void 0) { cancel_btn = '取消'; }
        if (ok_btn === void 0) { ok_btn = '确定'; }
        return new Promise(function (resolve, reject) {
            var alert = _this.alertCtrl.create({
                title: _title,
                message: msg,
                enableBackdropDismiss: true,
                buttons: [{
                        text: cancel_btn,
                        handler: function () {
                            reject();
                        }
                    },
                    {
                        text: ok_btn,
                        handler: function () {
                            resolve();
                        }
                    }]
            });
            alert.present();
        });
    };
    /**
     * 单按钮
     * @param _title
     * @param msg
     * @param ok_btn
     */
    UiUtils.prototype.confirmDialogOneBtn = function (_title, msg, ok_btn) {
        var _this = this;
        if (ok_btn === void 0) { ok_btn = '确定'; }
        return new Promise(function (resolve, reject) {
            var alert = _this.alertCtrl.create({
                title: _title,
                message: msg,
                enableBackdropDismiss: false,
                buttons: [
                    {
                        text: ok_btn,
                        handler: function () {
                            resolve();
                        }
                    }
                ]
            });
            alert.present();
        });
    };
    UiUtils = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_1__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2_ionic_angular__["LoadingController"],
            __WEBPACK_IMPORTED_MODULE_2_ionic_angular__["ToastController"],
            __WEBPACK_IMPORTED_MODULE_4__ionic_native_toast__["a" /* Toast */],
            __WEBPACK_IMPORTED_MODULE_2_ionic_angular__["AlertController"],
            __WEBPACK_IMPORTED_MODULE_3__ionic_native_in_app_browser__["a" /* InAppBrowser */],
            __WEBPACK_IMPORTED_MODULE_2_ionic_angular__["App"]])
    ], UiUtils);
    return UiUtils;
}());

//# sourceMappingURL=UiUtils.js.map

/***/ }),

/***/ 91:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return BaseService; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_rxjs_Subscription__ = __webpack_require__(17);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_rxjs_Subscription___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_rxjs_Subscription__);

var BaseService = /** @class */ (function () {
    function BaseService() {
    }
    BaseService.prototype.init = function (page) {
        this.subscription = new __WEBPACK_IMPORTED_MODULE_0_rxjs_Subscription__["Subscription"]();
        this.page = page;
    };
    BaseService.prototype.destroy = function () {
        if (this.subscription) {
            this.subscription.unsubscribe();
        }
    };
    return BaseService;
}());

//# sourceMappingURL=BaseService.js.map

/***/ }),

/***/ 92:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return StorageUtils; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_rxjs__ = __webpack_require__(157);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_rxjs___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_rxjs__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__ionic_storage__ = __webpack_require__(406);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};



/*
 * 对Storage进行二次封装，增加可维护性, 或方便添加我们自己的钩子代码
 */
var StorageUtils = /** @class */ (function () {
    function StorageUtils(storage) {
        this.storage = storage;
    }
    StorageUtils.prototype.get = function (key) {
        return this.storage.get(key);
    };
    StorageUtils.prototype.getObservable = function (key) {
        return __WEBPACK_IMPORTED_MODULE_0_rxjs__["Observable"].fromPromise(this.get(key));
    };
    StorageUtils.prototype.set = function (key, value) {
        return this.storage.set(key, value);
    };
    StorageUtils.prototype.remove = function (key) {
        return this.storage.remove(key);
    };
    StorageUtils.prototype.clear = function () {
        return this.storage.clear();
    };
    /**
     * @return the number of keys stored.
     */
    StorageUtils.prototype.length = function () {
        return this.storage.length();
    };
    /**
     * @return the keys in the store.
     */
    StorageUtils.prototype.keys = function () {
        return this.storage.keys();
    };
    /**
     * Iterate through each key,value pair.
     * @param iteratorCallback a callback of the form (value, key, iterationNumber)
     */
    StorageUtils.prototype.forEach = function (iteratorCallback) {
        this.storage.forEach(iteratorCallback);
    };
    StorageUtils = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_1__angular_core__["Injectable"])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__ionic_storage__["b" /* Storage */]])
    ], StorageUtils);
    return StorageUtils;
}());

//# sourceMappingURL=StorageUtils.js.map

/***/ })

},[678]);
//# sourceMappingURL=main.js.map